      SUBROUTINE CALFUN(X,N,M,FF,G)
      COMMON/STATIS/IFAIL,K,ITM,L
      DIMENSION X(N),G(M)
      FF=FI(X,N)
      L=L+1
      CALL CONSTR(X,N,G,M)
      RETURN
      END
      SUBROUTINE CALGRD(X,N,G,M,A)
      COMMON /B3/F(100)/DIF/DELTA
      DIMENSION X(N),A(100,N),G(M),G1(100),G2(100)
      DO 9 I=1,M
    9 G2(I)=G(I)
      CALL CALFUN(X,N,M,F1,G)
      DO 8 I=1,M
    8 G1(I)=G(I)
      DO 2 I=1,N
      X(I)=X(I)+DELTA
      CALL CALFUN(X,N,M,F2,G)
      F(I)=(F2-F1)/DELTA
      DO 1 J=1,M
    1 A(J,I)=(G (J)-G1(J))/DELTA
    2 X(I)=X(I)-DELTA
      DO 7 I=1,M
    7 G(I)=G2(I)
      RETURN
      END
      SUBROUTINE REQP(X,B1,Q,A,N,FM,IPAR,PAR,IPA,IPAA)
      DIMENSION B1(N,N),A(100,N),Q(N,N),X(N)
      DIMENSION IPAR(30),PAR(30),G(100),U(100)
      COMMON /DIF/DELTA/FUN/FF,LG/STATIS/IFAIL,K,ITM,LF
      IFAIL=0
      LF=0
      CALL INWR35(X,G,N,IPAR,PAR,IPA,IPAA)
      IF (IFAIL.EQ.10) RETURN
      ME=IPAR(IPA+3)
      MC=IPAR(IPA+3)+IPAR(IPA+4)
      IPRINT=IPAR(IPA+1)
      IMAX=IPAR(IPA+2)
      R1=PAR(IPAA+1)
      SCALE=PAR(IPAA+2)
      DELTA=PAR(IPAA+3)
      EPS=PAR(IPAA+4)
      DO 1 I=1,N
      DO 1 J=1,N
      B1(I,J)=0.
    1 B1(I,I)=1.
      CALL RQP(N,MC,ME,X,B1,G,A,U,R1,SCALE,EPS,IPRINT,IMAX,Q)
      ITM=K
      FM=FF
      RETURN
      END
      SUBROUTINE PENFUN(X,N,M,ME,FF,FF1,G,EPS,IFEAS)
      DIMENSION X(100),G(100)
      COMMON/PEN/RSTAR
      CALL CALFUN(X,N,M,FF,G)
      IFEAS=1
      GTG=0.
      DO 1 I=1,M
      IF(G(I).LT.0.0.OR.I.LE.ME)GTG=GTG+G(I)*G(I)
      IF(I.LE.ME.AND.ABS(G(I)).GT.EPS)IFEAS=0
      IF(I.GT.ME.AND.G(I).LT.-EPS)IFEAS=0
    1 CONTINUE
      FF1=FF+GTG/RSTAR
      RETURN
      END
      SUBROUTINE UPDBIG(B1,N,SC,P,OLDF,F)
      DIMENSION B1(N,N),P(100),F(100),OLDF(100)
      COMMON/W4/Y(100)
      COMMON/W8/UH(100)
      PNM=0.0
      YNM=0.0
      D1=0.
      D2=0.
      DO 1 I=1,N
      P(I)=SC*P(I)
      PNM=PNM+P(I)*P(I)
      Y(I)=F(I)-OLDF(I)
      D1=D1+P(I)*F(I)
      D2=D2+P(I)*OLDF(I)
1     YNM=YNM+Y(I)*Y(I)
      SG=D1-D2
      GOTO 103
12    DO 13 I=1,N
      DO 13 J=1,N
      B1(I,J)=0.
      IF(I.EQ.J)B1(I,J)=1.
13    CONTINUE
103   GHG=0.
      DO 2 I=1,N
      UH(I)=0.
      DO 3 J=1,N
3     UH(I)=UH(I)+B1(I,J)*Y(J)
2     GHG=GHG+UH(I)*Y(I)
      IF(SG.LE.1E-3*SQRT(PNM*YNM))RETURN
      IF(GHG.LE.0.)GO TO 12
      DO 9 I=1,N
      DO 9 J=1,N
      CH=GHG*P(I)*P(J)/SG-(UH(I)*P(J)+UH(J)*P(I))
      B1(I,J)=B1(I,J)+(P(I)*P(J)+CH)/SG
9     CONTINUE
4     RETURN
      END
      SUBROUTINE SOLVE(N1,N,Q,RHS,VAR,DIAG)
      DIMENSION RHS(100),VAR(100),DIAG(100),Q(N1,N1)
      DOUBLE PRECISION Z
      IF(N.GT.1)GO TO 21
      VAR(1)=RHS(1)/Q(1,1)
      RETURN
21    VAR(1)=RHS(1)*DIAG(1)
      DO 1 I=2,N
      Z=DBLE(RHS(I))
      II=I-1
      DO 2 L=1,II
      K=I-L
2     Z=Z-DBLE(Q(I,K)*VAR(K))
1     VAR(I)=SNGL(Z)*DIAG(I)
      VAR(N)=VAR(N)*DIAG(N)
      JJ=N-1
      DO 3 J=1,JJ
      I=N-J
      Z=DBLE(VAR(I))
      KK=I+1
      DO 4 K=KK,N
4     Z=Z-DBLE(Q(K,I)*VAR(K))
3     VAR(I)=SNGL(Z)*DIAG(I)
      RETURN
      END
      SUBROUTINE DECOMP(N1,N,Q,DIAG,ISING)
      DIMENSION DIAG(100),Q(N1,N1)
      DOUBLE PRECISION X
      IF(N.GT.1) GO TO 21
      IF(Q(1,1).NE.0.0)GO TO 19
      ISING=1
19    RETURN
21    XBIG=Q(1,1)
      DO 1 I=1,N
      DO 1 J=I,N
      X=DBLE(Q(I,J))
      IF(I.EQ.1)GO TO 2
      II=I-1
      DO 3 L=1,II
      K=I-L
3     X=X-DBLE(Q(J,K)*Q(I,K))
2     IF(J.GT.I)GO TO 5
      IF(SNGL(X).GT.XBIG)XBIG=SNGL(X)
      IF(SNGL(X).GT.1E-7*XBIG)GO TO 6
      ISING=1
      RETURN
6     DIAG(I)=SNGL(1./DSQRT(X))
      GO TO 1
5     Q(J,I)=SNGL(X)*DIAG(I)
1     CONTINUE
      RETURN
      END
      SUBROUTINE LS(N,M,ME,X,Y,P,SC,FF,OLDFF,FF1,G1,G2,SF0,PNM,IFV,
     1ISTOP,EPS,IFEAS)
      DIMENSION X(N),Y(100),P(100),G1(100),G2(100)
      COMMON /INW/INWR
      IDC=0
      IQ=1
      E1=.01
      E2=.7
      SL=0.
      DL=1.
      FL=OLDFF
      IFL=IFEAS
      FF2=FF1
      DF=5E-7*(ABS(FL)+5E-7)
118   FF=OLDFF
      IXT=0
      IKT=0
      IF(SC.LT.1.0)IXT=1
119   DO 600 I=1,N
600   Y(I)=X(I)+SC*P(I)
      CALL PENFUN(Y,N,M,ME,FF1,FF,G1,EPS,IFEAS)
      IFV=IFV+1
171   IF(FF.GT.OLDFF)GO TO 601
604   IKT=IKT+1
      D=(FF-(OLDFF+SC*SF0))/(SC*SF0) +1.
      IF(D.LE.E2)GO TO 602
      IF(FF.GE.FL)GO TO 602
      IF(IKT.GT.1.AND.ABS(1.-D).GE.E1)GO TO 602
      IF(IXT.EQ.1)GO TO 603
      SL=SC
      DL=D
      FL=FF
      IFL=IFEAS
      DO 650 I=1,M
650   G2(I)=G1(I)
      FF2=FF1
      IF(IKT.GT.5)GO TO 607
      IF(D.GE.0.75)SC=2.*SC
      IF(D.LT.0.75)SC=.5*SC/(1.-D)
      DO 605 I=1,N
605   Y(I)=X(I)+SC*P(I)
      CALL PENFUN(Y,N,M,ME,FF1,FF,G1,EPS,IFEAS)
      IFV=IFV+1
      GO TO 604
602   IF(D.GE.E1)GO TO 603
      IF(ABS(1.-DL).GE.E1)GO TO 607
      GO TO 609
601   F0=SC*SF0
      D=(FF-(OLDFF+SC*SF0))/F0+1.
639   IF(D.LT.E1)GO TO 609
      IF(ABS(1.-D).GE.E1)GO TO 603
      SL=SC
      DL=D
      FL=FF
      IFL=IFEAS
      DO 651 I=1,M
651   G2(I)=G1(I)
      FF2=FF1
      IF(IQ.EQ.0)GO TO 608
      GO TO 610
609   SR=SC
      DR=D
      FR=FF
      IF(ABS(SC*SF0).LE.DF)GO TO 608
610   IF((SR-SL).LE.5E-7*SR)GO TO 607
      SC=SL+(SR-SL)*AMAX1(.001,(.5-DL)/(DR-DL))
      IQ=0
      DO 612 I=1,N
612   Y(I)=X(I)+SC*P(I)
      CALL PENFUN(Y,N,M,ME,FF1,FF,G1,EPS,IFEAS)
      IFV=IFV+1
      GO TO 601
608   SC=.5*(SR+SL)
      DO 619 I=1,N
619   Y(I)=X(I)+SC*P(I)
      CALL PENFUN(Y,N,M,ME,FF1,FF,G1,EPS,IFEAS)
      IFV=IFV+1
      IF(FF.LT.OLDFF)GO TO 640
      IF(ABS(SR*SF0).GT.DF)GO TO 640
      IF(SL.GT.0.)GO TO 607
      IF(IDC.EQ.1)GO TO 607
      IDC=1
      SFL=SF0
      SF0=(4.*FF-FR-3.*OLDFF)/SR
      IF(SF0.GE.0.)GO TO 641
      DR=DR*SFL/SF0
640   IQ=1
      GO TO 601
641   IF(SF0.EQ.0)GO TO 607
      DO 642 I=1,N
642   Y(I)=X(I)-SC*P(I)
      CALL PENFUN(Y,N,M,ME,FF1,FFN,G1,EPS,IFEAS)
      IFV=IFV+1
      IF(FFN.GE.OLDFF)GO TO 607
      DO 643 I=1,N
643   P(I)=-P(I)
      SF0=(FFN-FF)/SC
      DL=1.
      SL=0.
      FF=FFN
      FL=OLDFF
      IKT=0
      GO TO 604
607   SC=SL
      D=DL
      FF=FL
      IFEAS=IFL
      FF1=FF2
      DO 652 I=1,M
652   G1(I)=G2(I)
603   DO 618 I=1,N
618   X(I)=X(I)+SC*P(I)
      IF(FF.LT.OLDFF) RETURN
      ISTOP=1
      INWR=1
      RETURN
      END
      SUBROUTINE RQP(N,M,ME,X,B1,G,A,U,R1,
     1SCALE,EPS,IPRINT,IMAX,Q)
      DIMENSION X(N),G(100),U(100)
      DIMENSION B1(N,N),A(100,N),Q(N,N)
      COMMON/W1/C(100)/W9/G1(100)/W10/G2(100)
      COMMON/W2/P(100)/W3/OLDF(100)/W4/DIAG(100)/W5/BETA(100)
      COMMON/W6/ATG(100)/W11/Z1(100)
      COMMON/W7/Y(100)/W8/Z(100)
      COMMON/PEN/RSTAR
      COMMON /FUN/FF,IGV/B3/F(100)/STATIS/ISTOP,ICT,ITM,LFUN/INW/INWR
      COMMON /CONST/IVSET(100),IV /DIF/DELTA
      INWR=0
      NW99=6
      ICT=0
      ISTOP=0
      INEXT=IPRINT
      DO 2 I=1,M
      Y(I)=0.
2     U(I)=0.
      RLAST=R1
      CALL CALFUN(X,N,M,FF,G)
      CALL CALGRD(X,N,G,M,A)
      IGV=1
      GO TO 500
900   ICT=ICT-1
      DO 1 I=1,N
      DO 1 J=1,N
      B1(I,J)=0.
      IF(I.EQ.J)B1(I,J)=1.
1     CONTINUE
500   ISGRAD=1
      IF(IPRINT.EQ.1)GO TO 1170
      GO TO 1000
20    ICT=ICT+1
      IF(ICT.LT.IMAX) GO TO 4010
      INWR=1
      ISTOP=2
 4010 CONTINUE
      IBIND=0
      ISING=0
      IREV=0
      IPEN=0
      ILANG=0
      DO 48 I=1,N
      P(I)=0.
      BETA(I)=OLDF(I)
      DO 48 J=1,N
48    P(I)=P(I)-B1(I,J)*C(J)
      IF(IV.EQ.0)GO TO 702
      ILANG=1
      IF(IV.GT.N)GO TO 12
      DO 5 I=1,IV
      II=IVSET(I)
      C(I)=-G(II)-.5*RSTAR*U(II)
      DO 5 J=1,N
5     C(I)=C(I)-A(II,J)*P(J)
      DO 6 I=1,IV
      II=IVSET(I)
      DO 6 J=1,N
      QIJ=0.
      DO 66 K=1,N
66    QIJ=QIJ+A(II,K)*B1(K,J)
6     Q(I,J)=QIJ
      DO 7 I=1,IV
      DO 8 J=I,IV
      IJ=IVSET(J)
      Y(J)=0.
      DO 8 K=1,N
8     Y(J)=Y(J)+Q(I,K)*A(IJ,K)
      DO 7 J=I,IV
      Q(I,J)=Y(J)
      IF(I.EQ.J)Q(I,J)=Q(I,J)+.5*RSTAR
7     CONTINUE
113   CALL DECOMP(N,IV,Q,DIAG,ISING)
      IF(ISING.EQ.0)GO TO 877
      IF(ISGRAD.EQ.0)GO TO 900
      INWR=1
      ISTOP=3
      GO TO 1170
877   CALL SOLVE(N,IV,Q,C,Y,DIAG)
      GO TO 18
12    IPEN=1
      GG=GTG
968   RLAST=RSTAR
      DO 16 I=1,N
      DO 16 J=1,N
16    Q(I,J)=B1(I,J)
      DO 17 K=1,IV
      IK=IVSET(K)
      DEN=.5*RSTAR
      DO 971 I=1,N
      Y(I)=0.
      DO 972 J=1,N
972   Y(I)=Y(I)+Q(I,J)*A(IK,J)
971   DEN=DEN+Y(I)*A(IK,I)
      DO 873 I=1,N
      DO 873 J=1,N
873   Q(I,J)=Q(I,J)-Y(I)*Y(J)/DEN
17    CONTINUE
      DO 871 I=1,N
      P(I)=0.
      DO 871 J=1,N
871   P(I)=P(I)-Q(I,J)*(OLDF(J)+2.*ATG(J)/RSTAR)
      DO 872 I=1,IV
      II=IVSET(I)
      Y(I)=G(II)
      DO 874 J=1,N
874   Y(I)=Y(I)+A(II,J)*P(J)
872   Y(I)=-2.*Y(I)/RSTAR-U(II)
18    IBIND=1
      UU=0.
      GG=0.0
      DO 763 I=1,IV
      II=IVSET(I)
      ERR=.25*ABS(U(II))
      IF(ABS(Y(I)).GT.ERR)ILANG=0
      Z(I)=U(II)+Y(I)
      IF(I.LE.ME.OR.Z(I).GT.0.)UU=UU+Z(I)**2
      IF(I.LE.ME.OR.Z(I).GT.0.)GO TO 763
      IBIND=0
763   GG=GG+G(II)*G(II)
      IF(GTG.LE.0.)GO TO 767
      IF(IREV.GT.0)GO TO 767
      IF(UU.LE.0.)GO TO 767
      IF(.5*RSTAR*SQRT(UU).LT.SQRT(GTG))GO TO 767
      IREV=1
      RLAST=RSTAR
      RSTAR=2.*SCALE*SQRT(GTG)/SQRT(UU)
      RD=.5*(RLAST-RSTAR)
      IF(IPEN.EQ.1)GO TO 968
      DO 1760 I=1,IV
      II=IVSET(I)
      C(I)=C(I)+RD*U(II)
1760  Q(I,I)=Q(I,I)-RD
      GO TO 113
767   RLAST=RSTAR
      DO 4001 I=1,IV
      II=IVSET(I)
4001  U(II)=U(II)+Y(I)
      DO 4000 I=1,N
      Z(I)=0.
      DO 4000 J=1,IV
      IJ=IVSET(J)
      IF(ILANG.EQ.0)GO TO 4000
      UJ=0.
      IF(J.LE.ME.OR.U(IJ).GT.0.)UJ=U(IJ)
      BETA(I)=BETA(I)-A(IJ,I)*UJ
4000  Z(I)=Z(I)+A(IJ,I)*Y(J)
771   CONTINUE
      DO 9999 I=1,IV
      II=IVSET(I)
 9999 Y(I)=U(II)
707   IF(IPEN.EQ.1)GO TO 702
      DO 717 I=1,N
      DO 717 K=1,N
717   P(I)=P(I)+B1(I,K)*Z(K)
702   CONTINUE
      PNM=0.0
      FNM=0.0
      D1=0.
      D2=0.
      DO 727 I=1,N
      PNM=PNM+P(I)*P(I)
      FI=OLDF(I)+2.*ATG(I)/RSTAR
      FNM=FNM+FI*FI
      D1=D1+P(I)*OLDF(I)
727   D2=D2+P(I)*ATG(I)
      SF0=D1+2.*D2/RSTAR
      IF(IV.GT.0)GO TO 950
      IF(SQRT(FNM).LT.EPS)GO TO 26
      IF(SF0.LE.-1E-3*SQRT(PNM*FNM))GO TO 726
      IF(ISGRAD.EQ.0)GO TO 900
      ISTOP=4
      INWR=1
      GO TO 1170
950   IF(IFEAS.EQ.0)GO TO 952
      IF(IBIND.EQ.0)GO TO 952
      IF(SQRT(PNM).LE.EPS)GO TO 26
952   IF(SF0.LT.0.)GO TO 726
      IF(ISGRAD.EQ.0)GO TO 900
      ISTOP=4
      INWR=1
      GO TO 1170
26    CONTINUE
      INWR=1
      GO TO 1170
726   SC=1.0
      DO 811 I=1,M
      IF(I.LE.ME)GO TO 811
      IF(G(I).LE.0.0)GO TO 811
      IF(U(I).GT.0.0)GO TO 811
      ZZ=0.0
      DO 812 J=1,N
812   ZZ=ZZ+A(I,J)*P(J)
      IF(ZZ.GE.0.0)GO TO 811
      SK=-G(I)/ZZ
      SKLINE=(-G(I)-RSTAR)/ZZ
      IF(SK.GT.SC)GO TO 811
      ZZ2=2.0*ZZ*ZZ/RSTAR-SF0
      SK=SK-(1.0-SK)*SF0/ZZ2
      SC=AMIN1(SC,ABS(SK),SKLINE)
811   CONTINUE
      DO 723 I=1,M
723   G2(I)=G(I)
      FF2=OLDFF+GTG/RSTAR
      CALL LS(N,M,ME,X,Y,P,SC,FF1,FF2,FF,G,G2,SF0,PNM,IFV,
     1ISTOP,EPS,IFEAS)
      CALL CALGRD(X,N,G,M,A)
      IGV=IGV+1
      PG=0.
      DO 4006 I=1,N
      ATG(I)=F(I)
      IF(ILANG.EQ.0)GO TO 4006
      DO 4007 J=1,IV
      UJ=0.
      IJ=IVSET(J)
      IF(J.LE.ME.OR.U(IJ).GT.0.)UJ=U(IJ)
4007  ATG(I)=ATG(I)-A(IJ,I)*UJ
4006  PG=PG+ATG(I)*ATG(I)
      IF(SQRT(PG).GT.EPS)GO TO 9
      IF(IBIND.EQ.1.AND.IFEAS.EQ.1)GO TO 26
9     CALL UPDBIG(B1,N,SC,P,BETA,ATG)
      ISGRAD=0
 1170 IF(INWR.EQ.0) GOTO 171
      IF (IPRINT.GE.0) CALL SPAU35(N,M,ME,X,G)
      RETURN
  171 IF(IPRINT.LE.0) GOTO 1000
      IF(ICT.NE.INEXT) GOTO 1000
      INEXT=INEXT+IPRINT
      CALL SPAU35(N,M,ME,X,G)
1000  IV=0
      IFEAS=1
      GTG=0.0
      UU=0.
      DO 1060 I=1,N
1060  ATG(I)=0.0
      IF(ME.EQ.0)GO TO 1001
      DO 1002 I=1,ME
      IV=IV+1
      IVSET(IV)=I
      GTG=GTG+G(I)**2
      IF(ABS(G(I)).GT.EPS)IFEAS=0
      UU=UU+U(I)*U(I)
      DO 1002 J=1,N
1002  ATG(J)=ATG(J)+A(I,J)*G(I)
1001  IF(ME.EQ.M)GO TO 22
      J99=ME+1
      DO 60 I=J99,M
      IF(G(I).LT.-EPS)IFEAS=0
      IF(G(I).GT.0.0.AND.U(I).LE.0.0)U(I)=0.
      IF(G(I).GT.0.0.AND.U(I).LE.0.0)GO TO 60
61    IV=IV+1
      IVSET(IV)=I
      GTG=GTG+(AMIN1(0.0,G(I)))**2
      IF(U(I).GT.0)UU=UU+U(I)*U(I)
      IF(ABS(G(I)).GT.EPS)IFEAS=0
      DO 62 J=1,N
62    ATG(J)=ATG(J)+A(I,J)*AMIN1(0.0,G(I))
60    CONTINUE
22    OLDFF=FF
      DO 114 I=1,N
      C(I)=F(I)
114   OLDF(I)=F(I)
      RSTAR=RLAST
      IF(IV.EQ.0)GO TO 20
      DO 3002 I=1,N
      DO 3002 J=1,IV
      IJ=IVSET(J)
3002  C(I)=C(I)-A(IJ,I)*U(IJ)
      IF(GTG.LE.0.)GO TO 20
      IF(UU.LE.0.)GO TO 20
      RSTAR=2.*SCALE*SQRT(GTG)/SQRT(UU)
      GO TO 20
      END
      SUBROUTINE INWR35(X,G,N,IPAR,PAR,IPA,IPAA)
      COMMON /STATIS/IFAIL,IT,ITM,NF
      DIMENSION X(N),G(100),IPAR(30),PAR(30)
      NOUT=I1MACH(2)
      MIP=30
      K=4
      MN=100
      K1=4
      IPRINT=IPAR(IPA+1)
      MAP=100
      IF (IPA.GE.0.AND.IPA+K.LE.MIP) GO TO 10
      WRITE (NOUT,520) K,MIP
      WRITE (NOUT,510) IPA
    5 IFAIL=10
      RETURN
   10 IF (IPRINT.LT.0) GO TO 110
      WRITE (NOUT,860)
      WRITE (NOUT,620)
      WRITE (NOUT,630) N
  110 IF (N.GT.0.AND.N.LE.MN) GO TO 20
      WRITE (NOUT,500) MN
      IF (IPRINT.LT.0) WRITE (NOUT,630) N
      GO TO 5
   20 CONTINUE
      IMAX=IPAR(IPA+2)
      NC=IPAR(IPA+3)
      NIC=IPAR(IPA+4)
      IF (IPRINT.LT.0) GO TO 30
      WRITE (NOUT,640) IPRINT
      WRITE (NOUT,650) IMAX
      WRITE (NOUT,870) NC
      WRITE (NOUT,890) NIC
   30 IF (IMAX.GE.0) GO TO 40
      WRITE (NOUT,525)
      IF (IPRINT.LT.0) WRITE (NOUT,650) IMAX
      GO TO 5
   40 IF (NC.GE.0) GO TO 50
      WRITE (NOUT,900)
      IF (IPRINT.LT.0) WRITE (NOUT,870) NC
      GO TO 5
   50 IF (NIC.GE.0) GO TO 70
      WRITE (NOUT,910)
      IF (IPRINT.LT.0) WRITE (NOUT,890) NIC
      GO TO 5
   70 IF (NC+NIC.LE.MAP) GO TO 120
      WRITE (NOUT,930) MAP
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,870) NC
      WRITE (NOUT,890) NIC
      GO TO 5
  120 CONTINUE
      IF (IPAA.GE.0.AND.IPAA+K1.LE.MIP) GO TO 240
      WRITE (NOUT,710) K1,MIP
      WRITE (NOUT,700) IPAA
      GO TO 5
  240 CONTINUE
      MC=NC+NIC
      CALL CALFUN(X,N,MC,FF,G)
      IF (IPRINT.LT.0) RETURN
      I=IPAA+1
      J=IPAA+K1
      WRITE (NOUT,940) (PAR(L),L=I,J)
      IF (MC.EQ.0) GO TO 280
      IF (NC.EQ.0) GO TO 260
      DO 250 I=1,NC
      IF (ABS(G(I)).GT.PAR(IPAA+4)) GO TO 300
  250 CONTINUE
  260 IF (NIC.EQ.0) GO TO 280
      J1=NC+1
      DO 270 I=J1,MC
      IF (G(I).LT.-PAR(IPAA+4)) GO TO 300
  270 CONTINUE
  280 WRITE (NOUT,820)
  285 WRITE (NOUT,580) X
      WRITE (NOUT,950) FF
      IF (MC.EQ.0) GO TO 290
      WRITE (NOUT,960)
      WRITE (NOUT,580) (G(I),I=1,MC)
  290 IF (IPRINT.GT.0) WRITE (NOUT,970)
      RETURN
  300 WRITE (NOUT,980)
      GO TO 285
  500 FORMAT (/2X,59H**E R R O R  I N  R E Q P** N LESS THAN 1 OR N GREA
     CTER THAN,I4)
  510 FORMAT (/2X,26HNUMBER OF PARAMETERS IPA =,I6)
  520 FORMAT (/2X,43H**E R R O R  I N  R E Q P** IPA LESS THAN 0/2X,
     C7HOR IPA+,I2,13H GREATER THAN,I3)
  525 FORMAT (/2X,44H**E R R O R  I N  R E Q P** IMAX LESS THAN 1/)
  580 FORMAT (4(2X,E15.8))
  620 FORMAT (/2X,22HI N I T I A L  D A T A)
  630 FORMAT (/2X,19HNUMBER OF VARIABLES,16X,3HN =,I6)
  640 FORMAT (/2X,18HPRINTING PARAMETER,15X,5HIPR =,I6)
  650 FORMAT (2X,28HMAXIMUM NUMBER OF ITERATIONS,4X,6HIMAX =,I6)
  700 FORMAT (/2X,27HNUMBER OF PARAMETERS IPAA =,I3)
  710 FORMAT (/2X,44H**E R R O R  I N  R E Q P** IPAA LESS THAN 0/2X,
     C8HOR IPAA+,I2,13H GREATER THAN,I3)
  820 FORMAT (/2X,14HSTARTING POINT)
  860 FORMAT (////12X,7HR E Q P)
  870 FORMAT (2X,30HNUMBER OF EQUALITY CONSTRAINTS,4X,4HNC =,I6)
  890 FORMAT (2X,38HNUMBER OF INEQUALITY CONSTRAINTS NIC =,I6)
  900 FORMAT (/2X,42H**E R R O R  I N  R E Q P** NC LESS THAN 0/)
  910 FORMAT (/2X,43H**E R R O R  I N  R E Q P** NIC LESS THAN 0/)
  930 FORMAT (/2X,53H**E R R O R  I N  R E Q P** NUMBER OF ALL CONSTRAIN
     CTS/2X,12HGREATER THAN,I4/)
  940 FORMAT (/2X,17HPENALTY PARAMETER,7X,4HR1 =,E15.8/2X,17HSCALING PAR
     CAMETER,4X,7HSCALE =,E15.8/2X,28HDIFFERENTIATION STEP DELTA =,
     CE15.8/2X,15HTOLERANCE LEVEL,8X,5HEPS =,E15.8)
  950 FORMAT (2X,18HFUNCTION VALUE F =,E15.8)
  960 FORMAT (2X,11HCONSTRAINTS)
  970 FORMAT (1X,34(2H -))
  980 FORMAT (/2X,27HSTARTING POINT = INFEASIBLE)
      END
      SUBROUTINE SPAU35(N,MC,ME,X,G)
      DIMENSION X(N),G(100)
      COMMON /CONST/ICON(100),IV/FUN/FM,LG/STATIS/IFAIL,K,ITM,LF
     C/INW/INWR
      COMMON /B3/F(100)/W7/Y(100)
      NOUT=I1MACH(2)
      IF(INWR.NE.0) GOTO 6
    1 FORMAT(34(2H -))
      WRITE(NOUT,2) K
    2 FORMAT(/2X,23HI T E R A T I O N	K =,I6)
      WRITE(NOUT,3) FM
    3 FORMAT(/2X,18HFUNCTION VALUE F =,E15.8)
      WRITE(NOUT,4)
    4 FORMAT(/2X,13HCURRENT POINT)
      WRITE(NOUT,5) X
    5 FORMAT(4(2X,E15.8))
      IF (MC.EQ.0) GO TO 40
      WRITE(NOUT,31)
      WRITE (NOUT,5) (G(I),I=1,MC)
   40 CONTINUE
      WRITE(NOUT,1)
      RETURN
    6 WRITE(NOUT,7)
    7 FORMAT(2(/34(2H *)))
      WRITE(NOUT,8)
    8 FORMAT(/2X,13HR E S U L T S)
      IF(IFAIL.GE.3) GOTO 30
      WRITE(NOUT,9) FM
    9 FORMAT(/2X,27HOPTIMAL FUNCTION VALUE FM =,E15.8)
      WRITE(NOUT,10)
   10 FORMAT(/2X,13HOPTIMAL POINT)
   29 WRITE(NOUT,5) X
      IF (MC.EQ.0) GO TO 41
      WRITE (NOUT,31)
   31 FORMAT(/2X,11HCONSTRAINTS)
      WRITE(NOUT,5) (G(I),I=1,MC)
      WRITE (NOUT,32)
   32 FORMAT(/2X,20HLAGRANGE MULTIPLIERS)
      WRITE (NOUT,5) (Y(I),I=1,MC)
   41 CONTINUE
      WRITE(NOUT,11) K
   11 FORMAT(/2X,21HNUMBER OF ITERATIONS ,12X,3HK =,I6)
      WRITE(NOUT,12) LF
   12 FORMAT(2X,30HNUMBER OF FUNCTION EVALUATIONS,3X,3HL =,I6)
      WRITE(NOUT,13) LG
   13 FORMAT(2X,30HNUMBER OF GRADIENT EVALUATIONS,2X,4HLG =,I6)
      WRITE(NOUT,14) IV
   14 FORMAT(2X,28HNUMBER OF ACTIVE CONSTRAINTS,4X,4HMA =,I6/)
      IF(IV.LE.0) GOTO 17
      WRITE(NOUT,15)
   15 FORMAT(2X,31HNUMBERS OF ACTIVE CONSTRAINTS : )
      WRITE(NOUT,16) (ICON(I),I=1,IV)
   16 FORMAT(2X,10I6)
   17 CONTINUE
   18 FORMAT (/7X,15HREQP TERMINATED)
      IF (IFAIL.EQ.0) GO TO 19
      GO TO (25,21,23,33),IFAIL
   19 WRITE(NOUT,20)
   20 FORMAT (/2X,66HIFAIL = 0. TERMINATION CRITERION: NORMS OF GRADIENT
     CS LESS THAN EPS)
      GOTO 27
   21 WRITE(NOUT,22) IFAIL
   22 FORMAT (/2X,7HIFAIL =,I2,45H. TERMINATION CRITERION: NUMBER OF ITE
     CRATIONS/2X,14HEXCEEDED LIMIT)
      GOTO 27
   23 WRITE (NOUT,24) IFAIL
   24 FORMAT (/2X,7HIFAIL =,I2,44H. TERMINATION CRITERION: LAGRANGE MULT
     CIPLIER/2X,18HEQUATIONS SINGULAR)
      GOTO 27
   25 WRITE (NOUT,26) IFAIL
   26 FORMAT (/2X,7HIFAIL =,I2,45H. TERMINATION CRITERION: NO FURTHER RE
     CDUCTION/2X,26HIN FUNCTION OR CONSTRAINTS)
      GOTO 27
   33 WRITE (NOUT,34) IFAIL
   34 FORMAT (2X,8HIFAIL = ,I2,25H. TERMINATION CRITERION:  ,
     C 23HSEARCH DIRECTION UPHILL)
   27 WRITE(NOUT,18)
      WRITE(NOUT,7)
      RETURN
   30 WRITE(NOUT,3) FM
      WRITE(NOUT,4)
      GOTO 29
      END

      SUBROUTINE EXKOR(X,A,B,N,FM,IPAR,PAR,IPA,IPAA)
C
C     COORDINATE OPTIMIZATION OF FUNCTION FI(X,N)
C
C     INPUT :X,A,B,N,IPAR,PAR,IPA,IPAA
C     OUTPUT:X,FM
C     X 	     INPUT-INITIAL POINT,OUTPUT-OPTIMUM POINT
C     A 	     BEGINNING OF INTERVALS OF OPTIMIZATION
C     B 	     END OF INTERVALS OF OPTIMIZATION
C     N 	     DIMENSIONALITY OF X
C     FM	     OPTIMUM
C     IPAR(IPA+5)    NUMBER OF COORDINATE WHICH BEGINS OPTIMIZATION
C		     IN FIRST CYCLE
C     IPAR(IPA+4)    NUMBER OF CYCLES
C     IPAR(IPA+2)    MAXIMAL ALLOWABLE NUMBER OF EVALUATIONS OF FI
C     IPAR(IPA+3)    IT IS USED IN EXTR AS IPAR(IPA+3) AND RECOMMENDED=6
C     IPAR(IPA+1)    INDICATOR OF PRINTING
C		     <0 NO PRINTING
C		     =0 PRINTING OF INITIAL POINT AND RESULTS OF OPTIMIZ
C		     =IP PRINTING OF OPTIMIZATION RESULTS IN IP ITERAT
C     PAR(IPAA+1)    ACCURACY OF FM
C     PAR(IPAA+2)-PAR(IPAA+N+1) ACCURACY OF OPTIMUM POINT
      COMMON /STATIS/IFAIL,J4,ITM,NF/INW/IN/SP13/K1,K2
      COMMON /IEXTR/ IFAULT
      COMMON /EXTR3/NS/EXTR9/N1
      COMMON /EXTR4/XPA(20),YPA
      COMMON /EXK1/ J2,NEX/EXT10/XE,YE
      DIMENSION X(N),PA(2),IP(3),PAR(30),IPAR(30),A(N),B(N)
      IFAIL=0
      IN=4
      CALL INWR13(X,A,B,N,FM,IPAR,PAR,IPA,IPAA)
      IF (IFAIL.EQ.10) RETURN
      NEX=N
      YPA=FM
      DO 10 I=1,N
   10 XPA(I)=X(I)
      NF=1
      PA(1)=PAR(IPAA+1)
      IP(1)=IPAR(IPA+2)
      IP(2)=IPAR(IPA+3)
      KC=IPAR(IPA+4)
      IPR=IPAR(IPA+1)
      J4=0
      DO 100 J1=1,KC
      I4=IPAR(IPA+5)
      IF (J1.GT.1) I4=1
      K1=J1
      DO  90 J2=I4,N
      K2=J2
      IP(3)=J2
      IN=4
      I=IPAA+J2+1
      PA(2)=PAR(I)
      CALL EXTRKO(XM,A(J2),B(J2),YM,IP,PA)
      J4=J4+1
      GO TO (20,20,30,40),IN
   20 IF (J4.LE.N) CALL INWR13(X,A,B,N,FM,IPAR,PAR,IPA,IPAA)
      GO TO 90
   30 X(J2)=XE
      CALL INWR13(X,A,B,N,YE,IPAR,PAR,IPA,IPAA)
      IFAIL=10
   40 CONTINUE
      IF (YM.LT.FM) ITM=J4
      YPA=YM
      FM =YM
      XPA(J2)=XM
      NF=NF+N1
      X(J2)=XM
      IF (IFAIL.EQ.10) RETURN
      IF (IPR.LE.0) GO TO 90
      IF (MOD(J4,IPR).EQ.0) CALL SPAU13(X,N,FM,IPR)
   90 CONTINUE
  100 CONTINUE
      IN=IN+100
      IF(IPR.GE.0) CALL SPAU13(X,N,FM,IPR)
      RETURN
      END
      SUBROUTINE EXTRKO(XM,BP,EP,YM,IPAR,PAR)
C
C     INPUT: BP EP FI IPAR PAR IPA IPAA
C     OUTPUT:XM YM
C
C     XM	     POINT OF OPTIMUM
C     BP	     BEGINNING OF INTERVAL OF OPTIMIZATION
C     EP	     END OF INTERVAL OF OPTIMIZATION
C     YM	     OPTIMUM
C     IPAR(1)	     MAXIMAL ALLOWABLE NUMBER OF EVALUATIONS OF FI
C     IPAR(2)	     NUMBER OF EVALUATIONS OF FI FOR ESTIMATE OF MODEL'S
C		     PARAMETER
C     PAR(1)	    ACCURACY OF YM
C     PAR(2)	    ACCURACY OF XM
C
      COMMON/EXTR2/X2(506),Y2(506)
      COMMON /EXTR3/NS/EXTR9/N1
      COMMON /EXTR5/Y1(506)
      COMMON /EXTR6/X1(506)
      COMMON/IEXTR/IFAIL
      DOUBLE PRECISION EE1,EE2,EE3,DM17
      COMMON /EXTR1/A,YH,XJ1,XJ2,YJ1,YJ2
      DIMENSION IPAR(3),PAR(2)
      COMMON /EXTR4/XPA(20),YPA
      COMMON /INW/INW1/EXT10/P1,Y
C
      RMAX=R1MACH(2)
      RMAXS=SQRT(RMAX)
      RMAX=ALOG10(RMAX)
      K=IFIX(RMAX)+1
      E1=PAR(1)
      E2=PAR(2)
      N=IPAR(1)
      NE=IPAR(2)
      IPAR4=IPAR(3)
      NS=0
      N1=0
      K1=K/3
      CUND=-2.0*FLOAT(K)
      CP5=10.0**(K1-1)
      CP6=10.0*CP5
      CM6=1.0/CP6
      CM5=1.0/CP5
      DM17=10.0D0 **(-K+2)
      CM17=DM17
      IFAIL=0
      N2=NE+2
      A=AMIN1(BP,EP)
      EB=AMAX1(BP,EP)-A
      EB2=EB/25.0
      IF ((EB.GE.CM5).AND.(EB.LE.CP5)) GO TO 10
      IFAIL=10
      INW1=1
      RETURN
   10 DA=EB/FLOAT(NE-1)
      N6=NE+3
      DO 20 J=4,N6
      X1(J)=A
      NS=NS+1
      Y=G(A)
      N1=N1+1
      Y1(J)=Y
      IF (J.EQ.4) GO TO 16
      IF (YM.LE.Y) GO TO 17
   16 YM=Y
      XM=A
   17 CONTINUE
      IF (ABS(Y).GE.RMAXS) GO TO 262
   20 A=A+DA
      A=0.0
      YMAX=Y1(4)
C
C     A IS ESTIMATE OF PARAMETER OF WIENER PROCESS
C     (PARAMETER OF MODEL OF FUNCTION F)
C
      DO 30 J=5,N6
      Y=Y1(J)
      A=A+(Y-Y1(J-1))**2
      IF (YMAX.LT.Y) YMAX=Y
   30 CONTINUE
      YH=YM-(YMAX-YM)/2.
      A=SQRT(A/EB)*20.
      IF (A.GE.CM6.AND.A.LE.CP6) GO TO 40
      IFAIL=10
      INW1=2
      RETURN
C
C     A IS EVALUATED. N5 IS THE NUMBER OF LOCAL OPTIMA
C     COMPUTED WITH ACCURACY E1,E2
C
   40 N5=0
      E1=AMIN1(E1,A*SQRT(EB2)*0.1)
      P1=XPA(IPAR4  )
      P2=EB*0.001
      N3=N6
      DO 45 J=4,N3
      IF(P1.GT.X1(J+1)) GO TO 45
      IF(P1.LE.X1(J  )+P2 .OR. P1.GE.X1(J+1)-P2) GO TO 46
      DO 43 J1=J,N6
      J2=N6-J1+J+1
      X1(J2+1)=X1(J2)
      Y1(J2+1)=Y1(J2)
   43 CONTINUE
      NS=NS+1
      N2=N2+1
      N6=N6+1
      X1(J+1)=P1
      Y1(J+1)=YPA
      IF (YPA.GE.YM) GO TO 46
      YM=YPA
      XM=P1
      YH=YM-(YMAX-YM)/2.
      GO TO 46
   45 CONTINUE
   46 CONTINUE
      NP=N+6
      DO 50 J=1,NP
   50 Y2(J)=0.0
C
C     BAYESIAN STEP - FIND INTERVAL OF BIGGEST IMPROVEMENT (J)
C
   60 DO 70 J=4,N2
      IF(Y2(J).GT.0.0) GO TO 70
      XJ1=X1(J)
      XJ2=X1(J+1)
      YJ1=Y1(J)
      YJ2=Y1(J+1)
      Y2(J)=COR(X2(J))
   70 CONTINUE
   80 P1=Y2(4)
      J=4
      DO 90 N3=5,N2
      IF (Y2(N3).GE.P1) GO TO 90
      J=N3
      P1=Y2(N3)
   90 CONTINUE
      N4=NS-J+3
      DO 100 N3= 1,N4
      N7=NS+4-N3
      X1(N7+1)=X1(N7)
      Y1(N7+1)= Y1(N7)
      X2(N7)= X2(N7-1)
  100 Y2(N7)=Y2(N7-1)
      P1=X2(J)
       NS=NS+1
      Y=G(P1)
      IF(Y.GT.YMAX) YMAX=Y
      X1(J+1)=P1
      Y1(J+1)=Y
      N4=1
      IF (Y.GE.YM) GO TO 110
      YM=Y
      XM=P1
      N4= 2
  110 N1=N1+1
      IF (ABS(Y).GE.RMAXS) GO TO 262
      N2=NS+2
C
C     IF NUMBER OF EVALUATIONS OF F MORE THAN (N-1) GO TO END
C
      IF(N1.LT.N) GO TO 115
      IFAIL=1
      GO TO 360
C
C     P4 IS PROBABILITY OF EVALUATING
C     XM,YM WITH ACCURACY E1,E2
C
  115 P4=1
      DO 120 N3=4,N2
      IF (Y2(N3).GE.0.) GO TO 120
      P1=-800.*((Y1(N3)-YM+E1)/A)*((Y1(N3+1)-YM+E1)/A)/(X1(N3+1)-X1(N3))
      IF(P1.LE.CUND) GO TO 120
      P4=P4*(1.0-EXP(P1))
  120 CONTINUE
C
C     IF P4 MORE THAN 0.95, THEN
C     GO TO END OF EXTR
C
      YH=YM-(YMAX-YM)/2.
      IF (ABS(YM-Y).LT.R1MACH(1)*1.E+3) GO TO 130
      IF (P4.GE.0.95) GO TO 360
C
C     IF N5=0 A IS UPDATED IN EACH FIFTH STEP
C
      IF (MOD(NS,5).NE.0.OR.N5.GT.0) GO TO 160
  130 A=0.
      N4=2
      DO 150 N3=4,N2
  150 A=A+((Y1(N3+1)-Y1(N3))**2)/(X1(N3+1)-X1(N3))
      A=SQRT(A/FLOAT(NS-1))*20.
C
C     PREPARATION OF BOUNDS OF X1,Y1 FOR TESTING-
C     IS INTERVAL OF LOCAL OPTIMUM  FOUND
C
  160 X1(3)=(3.0*X1(4)-X1 (5))/2.0
      X1(1)=X1(3)
      X1(2)=X1(3)
      X1(NS+4)=(3.0*X1(NS+3)-X1(NS+2))/2.0
      X1(NS+5)=X1(NS+4)
      X1(NS+6)=X1(NS+4)
      NR=NS+3
      DO 170 N3=1,3
      Y1(N3)=Y1(5)
      NR3=NR+N3
  170 Y1(NR3)  =Y1(N2)
      N7=MAX0(1,J-5)
      N8=MIN0(NS,J+1)
C
C     TEST IF INTERVAL OF LOCAL OPTIMUM FOUND
C
      DO 180 N3=N7,N8
      IF ( Y1(N3).GE.Y1(N3+1).AND. Y1(N3+1).GE.Y1(N3+2)
     *.AND.Y1(N3+2).GT.Y1(N3+3).AND.Y1(N3+3).LT.Y1(N3+4)
     *.AND.Y1(N3+4).LE.Y1(N3+5).AND.Y1(N3+5).LE.Y1(N3+6)
     *.AND.(X1(N3+6)-X1(N3)).LE.(EB/5.0)) GO TO 200
  180 CONTINUE
      GO TO 310
C
C     BEGINING OF LOCAL OPTIMIZATION
C
  200 N6=N3+5
      DO 210 N7=N3,N6
  210 Y2(N7)=1.
      N3=N3+3
      N5=N5+1
      P3=X1(1)
      XL1=X1(N3-1)
      XL2=X1(N3)
      XL3=X1(N3+1)
      YL1=Y1(N3-1)
      YL2=Y1(N3)
      YL3=Y1(N3+1)
      N8=0
  220 EE1=DBLE(YL1-YL2)
      EE2=DBLE(XL1-XL2)
      IF (DABS(EE1).LE.DM17.OR.DABS(EE2).LE.DM17) GO TO 300
      EE3=DBLE(2.*(YL1-YL3))/EE1-DBLE(2.*(XL1-XL3))/EE2
      IF (DABS(EE3).LE.DM17) GO TO 300
      XA=(DBLE(XL1+XL2)*DBLE(YL1-YL3)/EE1-DBLE(XL1-XL3)*DBLE(XL1+XL3)/
     *EE2)/EE3
      EE3=DBLE(XL2-XA)
      EE2=DBLE(XL1-XA)
      IF (DABS(EE2).GE.DM17) GO TO 230
      P1=YL1
      GO TO 250
  230 EE3=1.0D0-(EE3/EE2)**2
      IF (DABS(EE3).GE.DM17) GO TO 240
      IF (EE1.LE.DABS(EE3)*1.0D6) GO TO 240
      P1=YL1-1.0E5
      GO TO 250
  240 EE1=EE1/EE3
      P1=YL1-EE1
  250 YA=G(XA)
      P3=ABS(XA-P3)
      IF (YA.GE.YM) GO TO 260
      YM=YA
      XM=XA
      YH=YM-(YMAX-YM)/2.
  260 N7=1
      N1=N1+1
      IF (N1.LT.N) GO TO 261
      IFAIL=1
      GO TO 360
  261 CONTINUE
      IF (ABS(YA).LT.RMAXS) GO TO 251
      A=XA
      Y=YA
  262 INW1=3
      P1=A
      IFAIL=10
      RETURN
  251 CONTINUE
      IF (XA.GT.XL2) N7=2
      P2=ABS(P1-YA)
      IF((P2.LE.E1.AND.P3.LE.E2).OR.P2.LE.CM17.OR.P3.LE.CM17)GO TO 300
      IF (YA.GE.YL2) GO TO 280
      IF (N7.EQ.1) GO TO 270
      XL1=XL2
      YL1=YL2
      XL2=XA
      YL2=YA
  265 IF (N3.EQ.NS+3.AND.N8.EQ.0) GO TO 267
      N8=1
      GO TO 290
  267 XL3=(3.*XL2-XL1)/2.
      YL3=YL1
      GO TO 290
  270 XL3=XL2
      YL3=YL2
      XL2=XA
      YL2=YA
  275 IF (N3.EQ.4.AND.N8.EQ.0) GO TO 277
      N8=1
      GO TO 290
  277 XL1=(3.*XL2-XL3)/2.
      YL1=YL3
      GO TO 290
  280 IF (N7.EQ.1) GO TO 285
      XL3=XA
      YL3=YA
      GO TO 275
  285 XL1=XA
      YL1=YA
      GO TO 265
  290 P3=XA
      GO TO 220
  300 X1(N3)=XA
      Y1(N3)=YA
  305 N4=2
  310 CONTINUE
      IF(N4.EQ.2) GO TO 60
      N7=J+1
      DO 330 N3=J,N7
      XJ1=X1(N3)
      XJ2=X1(N3+1)
      YJ1=Y1(N3)
      YJ2=Y1(N3+1)
      IF((XJ2-XJ1).LT.EB2.AND.Y2(N3-1).GT.0.0.AND.
     *YJ1.LT.YJ2) GO TO 320
      Y2(N3)=COR(X2(N3))
      GO TO 330
  320 Y2(N3)=1.
  330 CONTINUE
      IF (Y2(N7+1).GT.0.0.AND.Y1(N7).GT.Y1(N7+1).AND.
     *(X1(N7+1)-X1(N7)).LT.EB2) Y2(N7)=1.0
      IF( Y2(N7).GT.0.0 .AND. Y1(N7-1).GT.Y1(N7).AND.
     *(X1(N7)-X1(N7-1)).LT.EB2) Y2(N7-1)=1.0
      GO TO 80
  360 CONTINUE
       RETURN
      END
      FUNCTION G(X)
      COMMON/EXK1/K,NEX
      COMMON /EXTR4/XPA(20),YPA
      DIMENSION XP (20)
      DO 1 J=1,NEX
    1 XP(J)=XPA(J)
      XP(K)=X
      G1=FI(XP,NEX)
      G=G1
      RETURN
      END
      SUBROUTINE SPAU13(X,N,FM,IPR)
      COMMON/INW/IN/STATIS/IFAULT,J4,ITM,NF/EXTR9/N1/SP13/K1,K2/IEXTR/
     CIFAIL
      DIMENSION X(N)
      NOUT=I1MACH(2)
      IF(IN.GT.100) GOTO 10
      WRITE(NOUT,100)
      IF(J4.EQ.IPR) WRITE(NOUT,210)
      WRITE(NOUT,280) K1,K2
      WRITE(NOUT,290) N1
      WRITE(NOUT,300) IFAIL
      WRITE(NOUT,150) FM
      WRITE(NOUT,160)
      WRITE(NOUT,130) (X(I),I=1,N)
      WRITE (NOUT,190) NF
      RETURN
  10  WRITE(NOUT,170)
      WRITE(NOUT,180)
      WRITE(NOUT,150) FM
      WRITE(NOUT,160)
      WRITE(NOUT,130) (X(I),I=1,N)
      WRITE(NOUT,190) NF
      WRITE(NOUT,310)
      WRITE(NOUT,170)
      RETURN
  100 FORMAT (/1X,34(2H -))
  130 FORMAT(4(2X,E15.8))
  150 FORMAT (/2X,28HOPTIMAL FUNCTION VALUE FM = ,E15.8)
  160 FORMAT(2X,13HOPTIMAL POINT)
  170 FORMAT (/1X,34(2H *)/1X,34(2H *))
  180 FORMAT (/2X,13HR E S U L T S)
  190 FORMAT (/2X,34HNUMBER OF FUNCTION EVALUATIONS L =,I6)
  210 FORMAT (1X,34(2H -))
  280 FORMAT(2X,20HNUMBER OF CYCLE K1 =,I3,3X,
     C23HNUMBER OF VARIABLE K2 =,I3)
  290 FORMAT (2X,60HNUMBER OF FUNCTION EVALUATIONS IN ONEDIMENSIONAL SEA
     CRCH N1 =,I6)
  300 FORMAT(2X,23HSUBROUTINE EXTR IFAIL =,I2)
  310 FORMAT(/7X,16HEXKOR TERMINATED)
      END
      SUBROUTINE INWR13(X,A,B,N,FM,IPAR,PAR,IPA,IPAA)
      DIMENSION X(N),A(N),B(N)
      DIMENSION IPAR(30),PAR(30)
      COMMON /INW/INW1/STATIS/IFAIL,IT,ITM,NFUN/EXK1/J2,NEX
      MN=20
      MIP=30
      MM=500
      MIM=6
      K=5
      K1=N+1
      NOUT=I1MACH(2)
      GO TO (1,2,7,3),INW1
    1 WRITE (NOUT,750) J2
      IF (IPAR(IPA+1).GE.0) RETURN
    6 WRITE (NOUT,570)
      WRITE (NOUT,580) A
      WRITE (NOUT,590)
      WRITE (NOUT,580) B
      RETURN
    2 WRITE (NOUT,760) J2
      IF (IPAR(IPA+1).GE.0) RETURN
      LT=IPAR(IPA+3)
      WRITE (NOUT,660) LT
      GO TO 6
    7 WRITE (NOUT,860) FM
      WRITE (NOUT,580) X
      RETURN
    3 CONTINUE
      IF (IPA.GE.0.AND.IPA+K.LE.MIP) GO TO 4
      WRITE (NOUT,520) K,MIP
      WRITE (NOUT,510) IPA
    5 IFAIL=10
      RETURN
    4 CONTINUE
      IPRINT=IPAR(IPA+1)
      IF (IPRINT.LT.0) GO TO 110
      WRITE (NOUT,770)
      WRITE (NOUT,620)
      WRITE (NOUT,630) N
  110 IF (N.GT.0.AND.N.LE.MN) GO TO 10
      WRITE (NOUT,500) MN
      IF (IPRINT.LT.0) WRITE (NOUT,630) N
      GO TO 5
   10 CONTINUE
      M=IPAR(IPA+2)
      LT=IPAR(IPA+3)
      KC=IPAR(IPA+4)
      NO=IPAR(IPA+5)
      IF (IPRINT.LT.0) GO TO 40
      WRITE (NOUT,640) IPRINT
      WRITE (NOUT,650) M
      WRITE (NOUT,660) LT
      WRITE (NOUT,780) KC
      WRITE (NOUT,790) NO
   40 IF (M.GT.0.AND.M.LE.MM) GO TO 50
      WRITE (NOUT,530) MM
      IF (IPRINT.LT.0) WRITE (NOUT,650) M
      GO TO 5
   50 CONTINUE
      IF (LT.GE.MIM.AND.LT.LE.M) GO TO 80
      WRITE (NOUT,550) MIM
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,650) M
      WRITE (NOUT,660) LT
      GO TO 5
   80 CONTINUE
      IF (NO.GE.1.AND.NO.LE.N) GO TO 120
      WRITE (NOUT,800)
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,630) N
      WRITE (NOUT,790) NO
      GO TO 5
  120 CONTINUE
      IF (IPAA.GE.0.AND.IPAA+K1.LE.MIP) GO TO 240
      WRITE (NOUT,710) K1,MIP
      WRITE (NOUT,700) IPAA
      GO TO 5
  240 E1=PAR(IPAA+1)
      IF (IPRINT.LT.0) GO TO 200
      WRITE (NOUT,720) E1
      J=IPAA+2
      J1=IPAA+N+1
      WRITE (NOUT,810)
      WRITE (NOUT,580) (PAR(I),I=J,J1)
      WRITE (NOUT,570)
      WRITE (NOUT,580) (A(I),I=1,N)
      WRITE (NOUT,590)
      WRITE (NOUT,580) (B(I),I=1,N)
  200 NER=0
      NER1=0
      DO 90 I=1,N
      IF (A(I).LT.B(I)) GO TO 90
      IF (A(I).NE.B(I)) GO TO 81
      NER1=NER1+1
      GO TO 90
   81 CONTINUE
      IF (NER.NE.0) GO TO 86
      WRITE (NOUT,600) I,I
      GO TO 87
   86 WRITE (NOUT,605) I,I
   87 CONTINUE
      NER=1
   90 CONTINUE
      IF (NER.EQ.0) GO TO 100
   97 IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,570)
      WRITE (NOUT,580) (A(I),I=1,N)
      WRITE (NOUT,590)
      WRITE (NOUT,580) (B(I),I=1,N)
      GO TO 5
  100 CONTINUE
      IF (NER1.NE.N) GO TO 130
      WRITE (NOUT,607)
      GO TO 97
  130 CONTINUE
      IF (IPRINT.LT.0) GO TO 260
      WRITE (NOUT,820)
      WRITE (NOUT,580) (X(I),I=1,N)
  260 NER=0
      DO 270 I=1,N
      IF (X(I).LE.B(I).AND.X(I).GE.A(I)) GO TO 270
      WRITE (NOUT,830) I,I,I,I
      NER=1
  270 CONTINUE
      IF (NER.EQ.0) GO TO 300
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,570)
      WRITE (NOUT,580) (A(I),I=1,N)
      WRITE (NOUT,590)
      WRITE (NOUT,580) (B(I),I=1,N)
      WRITE (NOUT,820)
      WRITE (NOUT,580) (X(I),I=1,N)
      GO TO 5
  300 CONTINUE
      FM=FI(X,N)
      IF (IPRINT.GE.0) WRITE (NOUT,850) FM
      RETURN
  500 FORMAT (/2X,61H**E R R O R  I N  E X K O R** N LESS THAN 1 OR N GR
     CEATER THAN,I3)
  510 FORMAT (/2X,26HNUMBER OF PARAMETERS IPA =,I6)
  520 FORMAT (/2X,45H**E R R O R  I N  E X K O R** IPA LESS THAN 0/2X,
     C7HOR IPA+,I2,13H GREATER THAN,I3)
  530 FORMAT (/2X,43H**E R R O R  I N  E X K O R** M LESS THAN 1/2X,
     C17HOR M GREATER THAN,I6/)
  550 FORMAT (/2X,42H**E R R O R  I N  E X K O R** LT LESS THAN,I3/2X,
     C20HOR LT GREATER THAN M/)
  570 FORMAT ( /2X,32HVECTOR OF LOWER BOUNDS (A) FOR X)
  580 FORMAT (4(2X,E15.8))
  590 FORMAT (2X,32HVECTOR OF UPPER BOUNDS (B) FOR X)
  600 FORMAT (/2X,32H**E R R O R  I N  E X K O R** A(,I2,17H) GREATER TH
     CAN B(,I2,1H))
  605 FORMAT (32X,2HA(,I2,17H) GREATER THAN B(,I2,1H))
  607 FORMAT (/2X,55H**E R R O R  I N  E X K O R** VECTORS A AND B ARE E
     CQUAL)
  620 FORMAT (/2X,22HI N I T I A L  D A T A)
  630 FORMAT (/2X,19HNUMBER OF VARIABLES,39X,3HN =,I6)
  640 FORMAT (/2X,18HPRINTING PARAMETER,38X,5HIPR =,I6)
  650 FORMAT (2X,54HMAXIMUM NUMBER OF FUNCTION EVALUATIONS IN ONEDIMENSI
     CO-/2X,10HNAL SEARCH,48X,3HM =,I6)
  660 FORMAT (2X,55HNUMBER OF FUNCTION EVALUATIONS FOR PARAMETER ESTIMAT
     CION/2X,24HIN ONEDIMENSIONAL SEARCH,33X,4HLT =,I6)
  700 FORMAT (/2X,27HNUMBER OF PARAMETERS IPAA =,I3)
  710 FORMAT (/2X,46H**E R R O R  I N  E X K O R** IPAA LESS THAN 0/2X,
     C8HOR IPAA+,I2,13H GREATER THAN,I3)
  720 FORMAT (/2X,41HACCURACY OF OPTIMAL FUNCTION VALUE EPS1 =,E15.8)
  750 FORMAT (/2X,43H**E R R O R  I N  E X K O R** BOUNDS FOR X(,I2,
     C5H) ARE/2X,22HTOO SMALL OR TOO LARGE)
  760 FORMAT (/2X,64H**E R R O R  I N  E X K O R** VARIATION OF FUNCTION
     C IS TOO SMALL/2X,57HOR TOO LARGE. TRY TO CHANGE LT TO LT*2+1 OR BO
     CUNDS FOR X(,I2,1H)/)
  770 FORMAT (////12X,9HE X K O R)
  780 FORMAT (2X,16HNUMBER OF CYCLES,41X,4HKC =,I6)
  790 FORMAT (2X,42HNUMBER OF FIRST COORDINATE TO BE OPTIMIZED,15X,
     C4HNO =,I6)
  800 FORMAT (/2X,65H**E R R O R  I N  E X K O R** NO LESS THAN 1 OR NO
     CGREATER THAN N)
  810 FORMAT (2X,25HACCURACY OF OPTIMAL POINT)
  820 FORMAT (/2X,14HSTARTING POINT)
  830 FORMAT (/2X,32H**E R R O R  I N  E X K O R** X(,I2,17H) GREATER TH
     CAN B(,I2,1H)/2X,5HOR X(,I2,14H) LESS THAN A(,I2,1H))
  850 FORMAT (2X,19HFUNCTION VALUE F = ,E15.8)
  860 FORMAT (/2X,54H**E R R O R  I N  E X K O R** TOO LARGE FUNCTION VA
     CLUE//2X,3HF =,E15.8,2X,3HX =)
      END
      FUNCTION COR(X)
      COMMON /EXTR1/C,YH,XJ1,XJ2,YJ1,YJ2
      X=(XJ1+XJ2)/2.+(XJ2-XJ1)*(YJ1-YJ2)*0.5 /(YJ1+YJ2-2.*YH)
      AM=((XJ2-X)*YJ1+(X-XJ1)*YJ2)/(XJ2-XJ1)
      D=SQRT((XJ2-X)*(X-XJ1)/(XJ2-XJ1))*C
      COR=-ALNORM((YH-AM)/D,.FALSE.)
      RETURN
      END
      FUNCTION ALNORM(X,UPPER)
      REAL LTONE,UTZERO,ZERO,HALF,ONE,CON,Z,Y,X
      LOGICAL UPPER,UP
      DATA  LTONE/7.0/, UTZERO/18.66/
      DATA  ZERO/0./, HALF/0.5/, ONE/1./, CON/1.28/
      UP=UPPER
      Z=X
      IF (Z.GE.ZERO) GO TO 10
      UP= .NOT.UP
      Z=-Z
   10 IF (Z.LE.LTONE.OR.UP.AND.Z.LE.UTZERO) GO TO 20
      ALNORM=ZERO
      GO TO 40
   20 Y=HALF*Z*Z
      IF (Z.GT.CON) GO TO 30
      ALNORM=HALF-Z*(0.398942280444-0.399903438504*Y/(Y+5.75885480458-
     129.8213557808/(Y+2.62433121679+48.6959930692/(Y+5.92885724438))))
      GO TO 40
   30 ALNORM=0.398942280385*EXP(-Y)/(Z-3.8052E-8+1.00000615302/(Z+
     13.98064794E-4+1.98615381364/(Z-0.151679116635+5.29330324926/
     2(Z+4.8385912808-15.1508972451/(Z+0.742380924027+30.789933034/
     3(Z+3.99019417011))))))
   40 IF (.NOT.UP) ALNORM=ONE-ALNORM
      RETURN
      END

      SUBROUTINE ANAL1(XP,XG,N,XX,X,NM,IPAR,IPA)
C******************************************
C PROGRAM OF SELECTING OF MAIN VARIABLES
C IN PROBLEMS OF OPTIMIZATION AND EXPERIMET DESIGN.
C XP,XG- INPUT ARRAYS FOR BEGININGS AND ENDS OF
C	 INTERVALS,
C N- DIMENSIONALITY,
C IPAR(IPA+1) - PRINTING PARAMETER
C IPAR(IPA+2) - NUMBER OF FUNCTION EVALUATIONS
C IPAR(IPA+3) - NUMBER OF HARMONICS INVESTIGATED IG
C IPAR(IPA+4) - MAXIMAL NUMBER OF SELECTED VARIABLES
C		OR INTERACTIONS ICK
C IPAR(IPA+5) - SIGN OF INVESTIGATION OF INTERACTIONS IV
C****************************************
      COMMON /HREZ1/DDD(30)/INW/INW1/HREZ/III,MB1(2,30)
      COMMON /BS1/Y(1000)/STATIS/IFAIL,IT,ITM,NF
      DIMENSION XX(NM),X(NM),XP(20),XG(20),K(20),R(300),
     *RA(300),Y1(300),Y2(300),KA(20),IPAR(30),
     *AK1(8),AK2(8),AK3(8)
     *,Y3(300),MB(2),KAKA(30,20)
      DATA AK1/3*0.,.5,0.,.25,.5,.75/, AK2/1.,.5,.25,.75,
     *.125,.375,.625,.875/, AK3/1.,1.,.5,1.,.25,.5,.75,1./
      IFAIL=0
      CALL INWR21(XP,XG,N,XX,NM,IPAR,IPA)
      IF (IFAIL.EQ.10) RETURN
      RMAX=R1MACH(2)
      IPRINT=IPAR(IPA+1)
      M=IPAR(IPA+2)
      IG=IPAR(IPA+3)
      ICK=IPAR(IPA+4)
      IV=IPAR(IPA+5)
      INW1=0
      NF=M
C--------------------------------
C SCALING OF POINT COORDINATS
C TO THE SCALE 0 - 1. RESULT - IN ARRAY X (20,300)
C------------------------------------------------
      DO 1 I=1,N
      AIN=XG(I)-XP(I)
      DO 1 J=1,M
      I6=(J-1)*N+I
    1 X(I6)=(XX(I6)-XP(I))/AIN
C--------------------------
      CALL DISP(Y,M,V,D)
      IF (D.LT.RMAX/100.AND.D.GT.R1MACH(1)*100.) GO TO 70
      INW1=2
      CALL INWR21(XP,XG,N,XX,NM,IPAR,IPA)
      RETURN
   70 CONTINUE
      DIS=D
C---------------------------------
C THE BEGINING OF MAIN LOOP
C ICK - MAXIMAL NUMBER OF
C SELECTED VARIABLES
C-------------------------------
      DO 60 IL=1,ICK
      IT=IL
      ITM=IT
C---------------------------------
C ZEROS - TO ARRAY OF VARIANTS K
C-----------------------------------
      DO 7 I2=1,N
    7 K(I2)=0
      D0=RMAX
      IU=0
C----------------------------------
C GENERATING OF VARIANT
C--------------------------------
    8 CALL VAR (IG,IU,IV,N,K,IS,IJ)
      IF(IS.EQ.N) GO TO 32
C------------------------------------------
C LK AND LD - NUMBER OF POINTS IN
C DOMAINS 1 AND 2
C----------------------------------
      LK=0
      LD=0
C---------------------------------------------
C R - ARRAY OF SIGNS, IN WHICH DOMAIN
C	     POINT IS.
C IF R=0 , TO ANY DOMAIN,
C IF R=-1 , TO DOMAIN 1,
C IF R=1 , TO DOMAIN 2
C-----------------------------------
      NM1=0
      DO 28 J=1,M
      R(J)=0.
      IP=1
      DO 27 I=1,N
      I1=K(I)+1
      NM2=NM1+I
      AR=X(NM2)
      IF(AR.LT.AK1(I1)) GO TO 28
      IF(AR.GE.AK3(I1)) GO TO 28
      IF(AR.LT.AK2(I1)) GO TO 27
      IP=-IP
   27 CONTINUE
      IF(IP.LT.0) GO TO 24
      LK=LK+1
C------------------------------------------
C Y1 AND Y2 - ARRAYS WITH VALUES OF GOAL FUNCTION
C	    IN POINTS OF DOMAINS 1 AND 2
C---------------------------------------
      Y1(LK)=Y(J)
      R(J)=-1.
      GO TO 28
   24 LD=LD+1
      Y2(LD)=Y(J)
      R(J)=1.
   28 NM1=NM1+N
      IF((LK.LT.5).OR.(LD.LT.5)) GO TO 8
      CALL DISP (Y1,LK,VK,DK)
      CALL DISP (Y2,LD,VD,DD)
      DELV=VK-VD
      DO 33 J=1,M
   33 Y3(J)=Y(J)+R(J)*(DELV/2.)
      CALL DISP(Y3,M,VM,DM)
      IF(D0-DM)8,8,35
C---------------------------------------
C INFORMATION ABOUT THE BEST VARIANT - TO MEMORY
C----------------------------------------
   35 VMA=VM
      DELVA=DELV
      D0=DM
      DO 36 I=1,N
   36 KA(I)=K(I)
      DO 37 J=1,M
   37 RA(J)=R(J)
      GO TO 8
C----------------------------------
C ALL VARIANTS ARE INVESTIGATED
C---------------------------
   32 III=IL
      IF (D0.LE.DIS) GO TO 34
      IF (IL.NE.1) GO TO 22
      INW1=1
      CALL INWR21(XP,XG,N,XX,NM,IPAR,IPA)
      RETURN
   34 DO 56 J=1,M
   56 Y(J)=Y(J)+RA(J)*(DELVA/2.)
      DELD=D-D0
      D=D0
C--------------------------------
C RESULTS ARE OBTAINED
C----------------------------
      DDD(IL)=DELD/DIS
      DO 52 J=1,N
   52 KAKA(IL,J)=KA(J)
      IF (IPRINT.GT.0) CALL SPAU21(IPRINT,IL,KA,N,V,DIS)
      IF(D/DIS.LT.0.05) GO TO 22
C----------------------
C THE END OF MAIN LOOP
C----------------------
   60 CONTINUE
   22 CALL REDRES(N,KAKA)
      INW1=1
      IF (IPRINT.GE.0) CALL SPAU21(IPRINT,III,KA,N,V,DIS)
      RETURN
      END
      SUBROUTINE DISP(Y,M,V,D)
C************************************
C AUXILARY SUBROUTINE FOR SUBR-NE HARM
C RESULT - MEAN VALUE V AND DISPERSION D
C OF DATA ARRAY  Y (FROM M ELEMENTS)
C************************************
      DIMENSION Y(M)
      AM=FLOAT(M)
      V=0.
      D=0.
      DO 30 I1=1,M
      Y1=Y(I1)
      V=V+Y1
   30 D=D+Y1*Y1
      V=V/AM
      D=(D-AM*V*V)/(AM-1.)
      RETURN
      END
      SUBROUTINE VAR (IG,IU,IV,N,K,IS,IJ)
C********************************
C AUXILARY FOR SUBROUTINE HARM
C THE GENERATOR OF VARIANTS IN ARRAY K
C IV - HOW MANY VARIABLES ARE INVESTIGATED IN TNE VARIANT
C IS - OUTPUT PARAMETER - INFORMATION ABOUT THE END OF GENER.
C      IS=0 - GENERATING IS CONTINUEING
C IJ - NUMBER OF FIRST VARIABLE, FOR WHITCH NUMBER
C      OF HARMONIC IS NOT EQUAL TO ZERO
C******************************
      DIMENSION K(N)
      IS=0
      IF(IU.EQ.IV)GO TO 61
C-----------------------------------------------------
C I - NUMBER OF VARIABLE FOR WHICH NUMBER OF HARMONIC CHANGES
C-- ---------------------------------------------------
      I=0
    9 I=I+1
      GO TO 62
   61 I=IJ
   62 IF(K(I)-IG)11,10,10
   10 K(I)=0
      IF(I.NE.N) GO TO 9
C----------------------------------
C THE LAST VARIANT IS GENERATED
C----------------------------------
      IS=N
      GO TO 15
   11 K(I)=K(I)+1
      IU=0
      J=1
C------------------------------------
C THE BEGINING OF LOOP FOR DETERMINING OF IU AND IJ
C--------------------------------
   13 IF(K(J).EQ.0) GO TO 14
      IU=IU+1
      IF(IU.EQ.1)IJ=J
   14 IF((J.EQ.N).OR.(IU.EQ.IV))GO TO 15
      J=J+1
      GO TO 13
   15 RETURN
      END
      SUBROUTINE REDRES(N,KAKA)
      COMMON /HREZ/III,MB(2,30)/HREZ1/DDD(30)
      DIMENSION KAKA(30,20)
C-------------------------------
C REDUCING OF RESULTS
C------------------------------
      DO 19 I=1,III
      MB (2,I)=0
      K=0
      DO 19 J=1,N
      IF (KAKA(I,J).EQ.0) GO TO 19
      K=K+1
      MB (K,I)=J
   19 CONTINUE
   24 I2=III-1
      DO 21 I=1,I2
      J1=I+1
      IIII=III
      DO 21 J=J1,IIII
      IF (MB(1,I).NE.MB(1,J).OR.MB(2,I).NE.MB(2,J)) GO TO 21
      DDD(I)=DDD(I)+DDD(J)
      III=III-1
      DO 23 K=J,III
      DDD(K)=DDD(K+1)
      MB(1,K)=MB(1,K+1)
   23 MB (2,K)=MB (2,K+1)
      GO TO 24
   21 CONTINUE
      I2=III-1
   26 DO 25 I=1,I2
      J1=I+1
   75 DO 25 J=J1,III
      IF (DDD(I).GE.DDD(J)) GO TO 25
      BB=DDD(I)
      DDD(I)=DDD(J)
      DDD(J)=BB
      L1=MB(1,I)
      L2=MB(2,I)
      MB (1,I)=MB(1,J)
      MB(2,I)=MB(2,J)
      MB(1,J)=L1
      MB(2,J)=L2
      GO TO 75
   25 CONTINUE
      RETURN
      END
       SUBROUTINE INWR21(A,B,N,X,NM,IPAR,IPA)
      DIMENSION A(N),B(N),IPAR(30),X(NM)
      COMMON /INW/IN/STATIS/IFAIL,IT,ITM,NF
      MN=20
      MIP=30
      MM=300
      MIM=10
      K=5
      NOUT=I1MACH(2)
      IF(IN.EQ.1) GOTO 300
      IF (IN.EQ.2) GO TO 310
      IF (IPA.GE.0.AND.IPA+K.LE.MIP) GO TO 10
      WRITE (NOUT,520) K,MIP
      WRITE (NOUT,510) IPA
   5  IFAIL=10
      RETURN
   10 CONTINUE
      IPRINT=IPAR(IPA+1)
      IF (IPRINT.LT.0) GO TO 110
      WRITE(NOUT,960)
      WRITE (NOUT,620)
      WRITE (NOUT,630) N
  110 IF (N.GT.0.AND.N.LE.MN) GO TO 20
      WRITE (NOUT,500) MN
      IF (IPRINT.LT.0) WRITE (NOUT,630) N
      GO TO 5
   20 CONTINUE
      M=IPAR(IPA+2)
      NH=IPAR(IPA+3)
      NSF=IPAR(IPA+4)
      INP=IPAR(IPA+5)
      IF (IPRINT.LT.0) GO TO 40
      WRITE (NOUT,640) IPRINT
      WRITE (NOUT,650) M
      WRITE(NOUT,970)NH
      WRITE(NOUT,980) NSF
      WRITE(NOUT,990) INP
   40 IF (M.GE.MIM.AND.M.LE.MM) GO TO 47
      WRITE(NOUT,530) MIM,MM
      IF (IPRINT.LT.0) WRITE (NOUT,650) M
      GO TO 5
   47 IF (NM.GE.N*M) GO TO  50
      WRITE (NOUT,730)
      IF (IPRINT.GE.0) GO TO 48
      WRITE (NOUT,630) N
      WRITE (NOUT,650) M
   48 WRITE (NOUT,635) NM
      GO TO 5
   50 IF(NH.GE.1.AND.NH.LE.7) GOTO 60
      WRITE(NOUT,1000)
      IF (IPRINT.LT.0) WRITE (NOUT,970) NH
      GO TO 5
   60 IF(NSF.GE.1.AND.NSF.LE.30) GOTO 70
      WRITE(NOUT,1010)
      IF (IPRINT.LT.0) WRITE (NOUT,980) NSF
      GO TO 5
   70 IF(INP.EQ.1.OR.INP.EQ.2) GOTO 250
      WRITE(NOUT,1020)
      IF (IPRINT.LT.0) WRITE (NOUT,990) INP
      GO TO 5
  250 CONTINUE
      IF (IPRINT.LT.0) GO TO 200
      WRITE (NOUT,570)
      WRITE (NOUT,580) (A(I),I=1,N)
      WRITE (NOUT,590)
      WRITE (NOUT,580) (B(I),I=1,N)
  200 NER=0
      DO 90 I=1,N
      IF (A(I).LT.B(I)) GO TO 90
      IF (NER.NE.0) GO TO 86
      WRITE (NOUT,600) I,I
      GO TO 87
   86 WRITE (NOUT,605) I,I
   87 CONTINUE
      NER=1
   90 CONTINUE
      IF (NER.NE.1) GO TO 260
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,570)
      WRITE (NOUT,580) A
      WRITE (NOUT,590)
      WRITE (NOUT,580) B
      GO TO 5
  260 NER=0
      DO 270 I=1,M
      DO 285 J=1,N
      J1=(I-1)*N+J
      IF(X(J1).LE.B(J).AND.X(J1).GE.A(J)) GOTO 285
      IF (NER.NE.0) GO TO 280
      WRITE(NOUT,830) I
      GO TO 290
  280 WRITE(NOUT,840) I
  290 NER=1
      GO TO 270
  285 CONTINUE
  270 CONTINUE
      IF (NER.EQ.1) GO TO 5
      RETURN
  300 WRITE(NOUT,1030)
      GO TO 5
  310 WRITE (NOUT,1040)
      GO TO 5
  500 FORMAT (/2X,61H**E R R O R  I N  A N A L 1** N LESS THAN 1 OR N GR
     CEATER THAN,I3)
  510 FORMAT (/2X,20HNUMBER OF PARAMETERS,11X,5HIPA =,I6)
  520 FORMAT (/2X,45H**E R R O R  I N  A N A L 1** IPA LESS THAN 0/2X,
     C7HOR IPA+,I2,13H GREATER THAN,I3)
  530 FORMAT(/2X,41H**E R R O R  I N  A N A L 1** M LESS THAN,I3/2X,
     C17HOR M GREATER THAN,I6/)
  570 FORMAT ( /2X,32HVECTOR OF LOWER BOUNDS (A) FOR X)
  580 FORMAT (4(2X,E15.8))
  590 FORMAT (2X,32HVECTOR OF UPPER BOUNDS (B) FOR X)
  600 FORMAT (/2X,32H**E R R O R  I N  A N A L 1** A(,I2,22H) GREATER OR
     C EQUALS B(,I2,1H))
  605 FORMAT (32X,2HA(,I2,22H) GREATER OR EQUALS B(,I2,1H))
  620 FORMAT (/2X,22HI N I T I A L  D A T A)
  630 FORMAT(/2X,19HNUMBER OF VARIABLES,14X,3HN =,I6)
  635 FORMAT (2X,26HDIMENSION OF WORKING ARRAY,6X,4HNM =,I6)
  640 FORMAT(/2X,18HPRINTING PARAMETER,13X,5HIPR =,I6)
  650 FORMAT(2X,36HNUMBER OF FUNCTION EVALUATIONS   M =,I6)
  730 FORMAT (/2X,46H**E R R O R  I N  A N A L 1** NM LESS THAN N*M)
  830 FORMAT(/2X,42H**E R R O R  I N  A N A L 1** POINT NUMBER,I4,
     C14H OUT OF BOUNDS)
  840 FORMAT(32X,12HPOINT NUMBER,I4,14H OUT OF BOUNDS)
  960 FORMAT(////12X,9HA N A L 1)
  970 FORMAT(2X,19HNUMBER OF HARMONICS,13X,4HNH =,I6)
  980 FORMAT(2X,26HNUMBER OF SELECTED FACTORS,5X,5HNSF =,I6)
  990 FORMAT(2X,21HINTERACTION PARAMETER,10X,5HINP =,I6)
 1000 FORMAT (/2X,65H**E R R O R  I N  A N A L 1** NH LESS THAN 1 OR NH
     CGREATER THAN 7/)
 1010 FORMAT(/2X,45H**E R R O R  I N  A N A L 1** NSF LESS THAN 1/2X,
     C22HOR NSF GREATER THAN 30/)
 1020 FORMAT(/2X,45H**E R R O R  I N  A N A L 1** INP LESS THAN 1/2X,
     C21HOR INP GREATER THAN 2/)
 1030 FORMAT (/2X,47H**E R R O R  I N  A N A L 1** TOO LITTLE NUMBER/2X,
     C23HOF FUNCTION EVALUATIONS/)
 1040 FORMAT (/2X,61H**E R R O R  I N  A N A L 1** VARIATION OF OBJECTIV
     CE FUNCTION/2X,25HIS TOO SMALL OR TOO LARGE)
      END
      SUBROUTINE SPAU21(IPR,IL,KA,N,V,DIS)
      COMMON /HREZ1/DDD(30)/INW/IN/HREZ/IMB,MB(2,30)
      DIMENSION KA(20)
      NOUT=I1MACH(2)
      IF(IN.EQ.1) GOTO 20
      WRITE(NOUT,100)
      IF (IL.EQ.1) WRITE (NOUT,210) V,DIS
      WRITE(NOUT,110) IL
      WRITE(NOUT,400) DDD(IL)
      WRITE(NOUT,410)
      WRITE(NOUT,420) (KA(J),J=1,N)
      RETURN
   20 WRITE(NOUT,170)
      WRITE(NOUT,180)
      WRITE(NOUT,250)
      DO 40 I=1,IL
      J=MB(2,I)
      K=MB(1,I)
      IF(J.EQ.0) GOTO 30
      IF (K.GE.10) GO TO 60
      IF (J.GE.10) GO TO 50
      WRITE (NOUT,430) K,J,DDD(I)
      GO TO 40
   50 WRITE (NOUT,460) K,J,DDD(I)
      GO TO 40
   60 IF (J.GE.10) GO TO 70
      WRITE (NOUT,470) K,J,DDD(I)
      GO TO 40
   70 WRITE (NOUT,480) K,J,DDD(I)
      GOTO 40
   30 IF (K.GE.10) GO TO 80
      WRITE (NOUT,440) K,DDD(I)
      GO TO 40
   80 WRITE (NOUT,490) K,DDD(I)
   40 CONTINUE
      WRITE(NOUT,450)
      WRITE(NOUT,170)
  100 FORMAT (/1X,34(2H -))
  110 FORMAT(2X,23HI T E R A T I O N  NR =,I6)
  170 FORMAT (/1X,34(2H *)/1X,34(2H *))
  180 FORMAT (/2X,13HR E S U L T S)
  210 FORMAT (/2X,16HMEAN VALUE MV = ,E15.8,3X,16HDISPERSION DS = ,E15.8
     C/2(/1X,34(2H -)))
  250  FORMAT (/2X,31HVARIABLES OR PAIRS OF VARIABLES,7X,
     C19HDEGREE OF INFLUENCE)
  400 FORMAT(/2X,24HDEGREE OF INFLUENCE SD =,E15.8)
  410 FORMAT(2X,46HNUMBERS OF SELECTED HARMONIC FOR EACH VARIABLE)
  420 FORMAT(2X,10I6)
  430 FORMAT (14X,1HX,I1,3X,1HX,I1,22X,E15.8)
  440 FORMAT (16X,1HX,I1,25X,E15.8)
  450 FORMAT(/7X,16HANAL1 TERMINATED)
  460 FORMAT (14X,1HX,I1,3X,1HX,I2,21X,E15.8)
  470 FORMAT (13X,1HX,I2,3X,1HX,I1,22X,E15.8)
  480 FORMAT (13X,1HX,I2,3X,1HX,I2,21X,E15.8)
  490 FORMAT (16X,1HX,I2,24X,E15.8)
      RETURN
      END

      program miv
      dimension x(2),a(2),b(2),hes(3),ipar(30),par(30)
      data ipar/0,100,2,100,26*0/,par/100.,3*1.e-6,26*0./,x/-0.1,0.1/
      data n,nh,ipa,ipaa/2,3,0,0/,a/-0.25,-0.125/,b/0.5,0.625/
      call mivar40(x,a,b,n,hes,nh,fm,ipar,par,ipa,ipaa)
      stop
      end
      function fi(x,n)
      dimension x(n)
      fi=furasn(x,n)
      return
      end

      SUBROUTINE GLOPT(XM,A,B,M,FM,IPAR,IPA)
      DIMENSION XM(M),IPAR(30)
      INTEGER GUESS,FNMAX,CNMAX,GNMAX,D,PN,SN,FN,CN,OUT,RKEY
      INTEGER ND(20),REDUC(20),PG(150),FNP(150)
      INTEGER MARKM(150),MARK(150),PNC(150),WI1(150)
      INTEGER WI2(150)
      REAL A(M),B(M),STPLX(150),C(20)
      COMMON /INW/IN/ATT/AT(15)/STATIS/IFAIL,IT,ITM,FN
      REAL WR1(150),WR2(150),WR3(21),WR4(21),WR5(21)
      REAL S(21,21)
      REAL X(21,150)
      GNMAX=150
      CNMAX=20
      MMAX=20
      M1MAX=MMAX+1
      IFAIL=0
      CALL INWR16(A,B,M,IPAR,IPA)
      IF (IFAIL.EQ.10) RETURN
      IPR=IPAR(IPA+1)
      PN=IPAR(IPA+3)
      FNMAX=IPAR(IPA+2)
      IFAIL=1
      RKEY=1
      NDP=1
      M1=M+1
      IRD=10
      GUESS=0
      FN=0
      D1=0
      DO 10 I=1,M
      C(I)=B(I)-A(I)
   10 D1=D1+C(I)**2
      STPL=SQRT(D1/FLOAT(M))*(1./FLOAT(PN))**(1./FLOAT(M))*0.1
      DO 40 I=1,CNMAX
      REDUC(I)=IRD
   40 ND(I)=NDP
      DO 50 II=1,PN
      MARKM(II)=0
      STPLX(II)=STPL
   50 FNP(II)=1
C**  SAMPLING OF GLOBAL POINTS
      CALL GLOPO(M,NDP,PN,GUESS,A,C,ND,PG,X,WI1,WR1,WR2)
      FN=FN+PN-GUESS
  100 DO 150 SN=1,CNMAX
      CALL CLUST(FNMAX,M,SN,FN,PN,STPL,STPLX,PG,FNP,X,WR1,WR2,WR3,
     CM1,A,C,M2)
      PN=M2
C**  RADIUS IN SEPARATION ALGORITHM DETERMINED ONCE OR
C**  EVERY TIME DEPENDING ON RKEY
      IF (.NOT.(SN.EQ.1.OR.RKEY.EQ.1)) GO TO 110
      CALL RADUS(M,M1MAX,PN,ALFA,X,PG,D,R1,S,OUT,
     ,WR1,WR2,WR3,WR4,WR5)
C**  POINTS ARE SORTED AFTER DECENDING F-VALUES
  110 DO 120 II=1,PN
      JJ=PG(II)
  120 WR1(II)=X(M1,JJ)
      CALL MSORT(PN,WR1,WI2,ISTRT,WI1)
      DO 125 II=1,PN
  125 WI1(II)=PG(II)
      DO 130 II=1,PN
      JJ=PN-II+1
      PG(JJ)=WI1(ISTRT)
      ISTRT=WI2(ISTRT)
  130 CONTINUE
      CALL SEPAR(M,PN,D,R1,PG,X,CN,MARK,WI1,WR3,WR1,PNC,WI2,WR2,M1)
      M2=PN
      CALL OUTRE(M,SN,PN,CN,REDUC,PG,MARKM,MARK,PNC,GNMAX,M2)
      IT=SN
      ITM=SN
      IN=0
      IF (IPR.LE.0) GO TO 140
      IF (MOD(SN,IPR).EQ.0) CALL SPAU16(IPR,CN,PNC,GNMAX,MARK,M,
     CX,FM,XM)
  140 CONTINUE
      IF (PN.GT.1) GO TO 145
      IFAIL=2
      GO TO 199
  145 CONTINUE
      IF (FN.GE.FNMAX) GO TO 199
  150 CONTINUE
      IFAIL=0
  199 K2=0
      DO 210 MC=1,CN
      K1=K2+1
      K2=K2+PNC(MC)
      DO 220 K3=K1,K2
      J=MARK(K3)
      XK=X(M1,J)
      IF (K3.EQ.1) GO TO 200
      IF (XK.LE.FM) GO TO 220
  200 CONTINUE
      FM=XK
      DO 230 I=1,M
  230 XM(I)=X(I,J)
  220 CONTINUE
  210 CONTINUE
      FM=-FM
      IN=100
      IF (IPR.GE.0) CALL SPAU16(IPR,CN,PNC,GNMAX,MARK,M,X,FM,XM)
      RETURN
      END
      SUBROUTINE EIGVAL(LP,E,A,B,W,F)
C    LP IS THE SIZE OF ARRAY A. E IS A VECTOR OF LP ELEMENTS
C    WHICH WILL HOLD THE EIGENVALUES IN DESCENDING ABSOLUTE ORDER.
C    A IS A VECTOR OF LP ELEMENTS GIVING THE DIAGONAL ELEMENTS
C    OF THE TRIDIAGONAL MATRIX. B IS A VECTOR OF LP ELEMENTS.
C    THE LAST LP - 1. W IS A VECTOR OF LP ELEMENTS USED FOR
C    TEMPORARY STORAGE. F IS A VECTOR OF LP ELEMENTS USED FOR
C    TEMPORARY STORAGE.
      DIMENSION E(LP),A(LP),B(LP),W(LP)
      DIMENSION F(LP)
C    FIND ABSOLUTE BOUND FOR THE EIGENVALUES
      AM=ABS(A(1))
      BM=0.
      DO 1 I=2,LP
      AM=AMAX1(AM,ABS(A(I)))
    1 BM=AMAX1(BM,ABS(B(I)))
      BD=AM+BM+BM
      DO 6 I=1,LP
C    THIS LOOP FORCES THE EIGENVALUES TO LIE BETWEEN PLUS AND MINUS
C    ONE. THE E AND W VECTORS ARE RESPECTIVELY LOW AND HIGH ESTIMATES
C    TO ALL THE EIGENVALUES.
      A(I)=A(I)/BD
      B(I)=B(I)/BD
      E(I)=-1.
    6 W(I)=1.
      DO 50 K=1,LP
C    FIND THE K-TH EIGENVALUE. ALSO LOW AND HIGH ESTIMATES FOR THE
C    K+1-ST TO LP-TH EIGENVALUES ARE IMPROVED. THE EIGENVALUES ARE
C    FOUND IN ASCENDING ORDER. THE K-TH EIGENVALUE IS CONSIDERED
C    FOUND IF THE THE HIGH AND LOW PLACES AGREE TO SEVEN DECIMAD
C    PLACES.
    8 IF ((W(K)-E(K))/AMAX1(ABS(W(K))+ABS(E(K)),1.E-10)-R1MACH(4)*1000.)
     C50,50,10
   10 X=(W(K)+E(K))*0.5
C    X IS A GUESS FOR THE K-TH EIGENVALUE. COMPUTE NUMBER OF
C    EIGENVALUES EQUAL OR EXCEEDING X BY USING STURM SEQUENCE
C    (ORTEGA'S METHOD).
      S2=1.
      F(1)=A(1)-X
      IF (F(1)) 102,104,104
  102 S1=-1.
      N=0
      GO TO 105
  104 S1=1.
      N=1
  105 DO 120 I=2,LP
      IF (ABS(B(I)).LE.R1MACH(1)) GO TO 113
  106 IF (ABS(B(I-1)).LE.R1MACH(1)) GO TO 114
  107 IF (ABS(F(I-1))+ABS(F(I-2))-1.E-10   ) 111,112,112
C    IF THE PREVIOUS TWO TERMS OF THE STURM SEQUENCE WERE VERY
C    SMALL, THEY ARE FORCED TO BE CLOSER TO ONE IN MAGNITUDE TO
C    AVOID UNDERFLOW PROBLEMS.
  111 F(I-1)=F(I-1)*1.E10
      F(I-2)=F(I-2)*1.E10
  112 F(I)=(A(I)-X)*F(I-1)-B(I)*B(I)*F(I-2)
      GO TO 115
  113 F(I)=(A(I)-X)*S1
      GO TO 115
  114 F(I)=(A(I)-X)*F(I-1)-SIGN(B(I)*B(I),S2)
  115 S2=S1
      IF (ABS(F(I)).LE.R1MACH(1)) GO TO 117
  116 S1=SIGN(S1,F(I))
      IF (ABS(S1+S2).LE.R1MACH(1)) GO TO 120
  117 N=N+1
  120 CONTINUE
C    NOW LET N BE THE NUMBER OF EIGENVALUES SMALLER THAN X.
      N=LP-N
      IF (N.LT.K) GO TO 20
C    X BECOMES AN UPPER BOUND FOR THE K-TH TO N-TH EIGENVALUES.
   12 DO 15 J=K,N
   15 W(J)=X
   20 N=N+1
C    IF ALL THE EIGENVALUES ARE SMALLER THAN X, TEST WHETHER WE
C    HAVE CONVERGED TO THE K-TH EIGENVALUE.
      IF (LP.LT.N) GO TO 8
   24 DO 26 J=N,LP
C    IF X IS LARGER THAN PREVIOUS LOWER BOUND. INCREASE THE LOWER BOUND.
      IF (X-E(J)) 8,8,26
   26 E(J)=X
      GO TO 8
   50 CONTINUE
C    RESTORE INPUT AND SCALE EIGENVALUES.
      DO 60 I=1,LP
      A(I)=A(I)*BD
      B(I)=B(I)*BD
   60 W(I)=(W(I)+E(I))*BD*0.5
C    SORT EIGENVALUES IN ABSOLUTE DESCENDING ORDER
      J=LP
      K=1
      DO 80 I=1,LP
      IF (ABS(W(K))-ABS(W(J))) 63,63,65
   63 E(I)=W(J)
      J=J-1
      GO TO 80
   65 E(I)=W(K)
      K=K+1
   80 CONTINUE
      RETURN
      END
      SUBROUTINE TRIDMX(N,NM,A,D,B)
C    TRIDIAGONALIZATION OF REAL SYMMETRIC MATRIX.
      DIMENSION A(NM,NM),D(N),B(N)
      DOUBLE PRECISION SUM
C    SAVE ORIGINAL DIAGONALS IN ARRAY D.
      DO 10 I=1,N
   10 D(I)=A(I,I)
C    FOR N-2 RETURN WITHOUT COMPUTING.
      IF (N-2)60,55,15
C    K INDEX CONTROLS THE (N-2) SIMILARITY TRANSFORMATION.
   15 DO 46 K=3,N
      KK=K-1
C    SUM CONTAINS THE SUM OF THE SQUARE ELEMENTS
C    OF A COLUMN. EXCEPT THE FIRST K-2 ELEMENTS.
      SUM=DBLE(A(K-1,K-2)*A(K-1,K-2))
      DO 20 J=K,N
   20 SUM=SUM+DBLE(A(J,K-2)*A(J,K-2))
C    THE B ARRAY CONTAINS THE BETA VALUES.(I.E.,BETA=SUM**(1/2))
      B(K-2)=SIGN(SNGL(DSQRT(SUM)),-A(K-1,K-2))
C    IF BETA=0 NO TRANSFORMATION IS INITIATED.
      IF (ABS(B(K-2)).LE.R1MACH(1)) GO TO 46
C    THE COMPONENTS OF THE COLUMN VECTOR W ARE STORED IN THEPOSITIONS
C    OF THE ANNIHILATED ELEMENTS OF A (I.E.,LOWER HALF OF A)
   24 A(K-1,K-2)=SQRT(0.5*ABS(A(K-1,K-2)/B(K-2))+0.5)
      DENOM=-2.*A(K-1,K-2)*B(K-2)
      DO 30 I=K,N
   30 A(I,K-2)=A(I,K-2)/DENOM
      SCAL=0.
   37 DO 36 J=KK,N
C    THE BETAS ARE FORMED ONE BY ONE. WHEN R OF THEM HAVE BEEN
C    FORMED,P AND Q CONTAIN ONLY (N-R) ELEMENTS. THE B ARRAY IS
C    USED TO STORE SUCCESIVE P,S AND Q,S.
      B(J)=0.
      IF (J.EQ.KK) GO TO 350
      DO 349 L=KK,JJ
  349 B(J)=B(J)+A(J,L)*A(L,K-2)
  350 DO 35 L=J,N
   35 B(J)=B(J)+A(L,J)*A(L,K-2)
C    SCAL=W(TRANSPOSE)*P
      JJ=J
   36 SCAL=SCAL+B(J)*A(J,K-2)
      DO 40 J=KK,N
   40 B(J)=B(J)-SCAL*A(J,K-2)
C    TRANSFORM ALL ELEMENTS OF A EXCEPT PIVOTAL ROW AND COLUMN.
      DO 45 J=KK,N
      DO 45 L=J,N
   45 A(L,J)=A(L,J)-2.*(A(L,K-2)*B(J)+A(J,K-2)*B(L))
   46 CONTINUE
C    RESTORE ORIGINAL DIAGONALS OF A. STORE DIAGONAL OF
C    TRANSFORMED MATRIX IN ARRAY D.
      DO 50 I=1,N
      T=A(I,I)
      A(I,I)=D(I)
      J=N-I
      B(J+1)=B(J)
   50 D(I)=T
   55 B(N)=A(N,N-1)
   60 B(1)=0.
      RETURN
      END
      SUBROUTINE GLOPO(M,NDP,N,GUESS,A,C,ND,PG,X,STEP,R,Z)
      INTEGER M,NDP,N,GUESS,ND(M),PG(N),STEP(M)
      REAL A(M),C(M),R(M),Z(M)
      REAL X(21,150)
C    N-K=NUMBER OF POINTS TO	SAMPLE, NDP=1 CRUDE MC, =2 STRATIFIED.
C    ND DIVISIONS PER COORDINATE, M DIMENSION OF INDEPENDENT VARIABLE.
C    A AND C DETERMINES H. RI MULTIPLIER IN RANDOM NUMBER GENERATOR.
C    RN RANDOM NUMBER COUNTER. X CONTAINS THE GLOBAL POINTS. X(M+1,K)
C    THE FUNCTION VALUE, PG(K)=K
      K=GUESS
      GO TO (10,7),NDP
C    EVALUATE F. STORE R. UPDATE PG. TEST FOR READY
    4 K=K+1
      X(M+1,K)=-FI(R,M)
      DO 5 I=1,M
    5 X(I,K)=R(I)
      PG(K)=K
      IF (K.LT.N) GO TO (10,30),NDP
      RETURN
C    STRATIFIED SAMPLING
C    ALL POINTS IN A UNIFORM NET WITH THE RANDOM STARTING POINT R IN HS
C    ARE TESTED FOR BEING IN A. THE COORDINATE VALUE R(M) IS CHANGING
C    MOST RAPIDLY THEN R(M-1) AND SO ON. THE PROCESS IS REPEATED WITH
C    A NEW RANDOM START UNTIL ALL POINTS ARE FOUND. STEP IS A VECTOR
C    GOVERNING THE SAMPLING. FOR M=2, ND(1)=3, ND(2)=2 STEP ATTAINS THE
C    SUCCESSIVE VALUES 1 1, 1 2, 2 1, 2 2, 3 1, 3 2.
    7 DO 8 I=1,M
    8 STEP(I)=1
C    RANDOM NUMBERS IN HS
   10 DO 12 I=1,M
      CALL UNDEV(RI)
      R(I)=A(I)+C(I)*RI
C    REMEMBER ORIGINAL POINT R
   12 Z(I)=R(I)
   20 J=M
C    TEST R
      IF (IRA(R,A,C,M).EQ.1) GO TO 4
      GO TO (10,30),NDP
C    NEXT POINT IN HS
   30 STEP(J)=STEP(J)+1
      IF (STEP(J).GT.ND(J)) GO TO 40
      R(J)=R(J)+C(J)
      GO TO 20
C    THE J:TH ELEMENT HAS REACHED UPPER BOUND, IS SET TO 1
C    THE J-1:TH ELEMENT IS A CANDIDATE TO BE INCREASED BY 1
   40 STEP(J)=1
      R(J)=Z(J)
      J=J-1
      IF (J) 10,10,30
      END
      SUBROUTINE CLUST(FENMX,M,CC,FEN,N,STPL,STPLX,PG,FENP,X,Y,Z,S,
     CM1,A,C,M2)
      INTEGER FENMX,M,CC,FEN,N,PG(N),FENP(N)
      REAL S(M1),Y(M1),Z(M1),STPLX(N)
      DIMENSION A(M),C(M)
      REAL X(21,150)
C    N = NUMBER OF POINTS. CC = NUMBER OF CLUSTERINGS, STPL = VECTOR
C    GIVING STEPLENGTHS FOR SUCCESSIVE CLUSTERINGS, STPL(1) = FIRST
C    STEPLENGTH OF FIRST CLUSTERING, STPL(2) LEAST STEPLENGTH FOR FIRST
C    CLUSTERING = FIRST-LENGTH FOR SECOND CLUSTERING AND SO ON, X
C    = STARTING POINTS,PG = POINTER TO STARTING POINTS, M =DIMENSION OF
C     INDEPENDENT VARIABLE, FEN COUNTS NUM-
C    BER OF FUNCTION EVALUATIONS, FENMX = MAXIMUM NUMBER OF FUNCTION
C    EVALUATIONS PERMITTED. SF =FIRST STEPLENGTH, SL = LEAST STEP-
C    LENGTH.STPLX INDIVIDUAL STEPLENGTHS FOR THE POINTS X. MAKES SMALL
C    FIRST STEPLENGTH POSSIBLE
      M2=N
      SL=STPL
      STPL=0.3-STPL
      IF (STPL .LT. R1MACH(1)) STPL=R1MACH(1)
      DO 100 J=1,N
      K=PG(J)
      IF (FEN.GE.FENMX) GO TO 90
      SF=STPLX(K)
      DO 10 I=1,M1
   10 Y(I)=X(I,K)
      L=FEN
      CALL LOCOP(M,Y,SF,SS,SL,NEW,FEN,FENMX,Z,S,M1,A,C)
      FENP(K)=FENP(K)+FEN-L
      STPLX(K)=SS
      IF (NEW) 90,100,17
   17 DO 20 I=1,M1
   20 X(I,K)=Y(I)
      GO TO 100
   90 CONTINUE
      IF (CC.EQ.1) GO TO 110
  100 CONTINUE
      RETURN
  110 M2=J
      RETURN
      END
      SUBROUTINE LOCOP(M,Y,SF,SL,SLL,NEW,FEN,FENMX,X,S,M1,A,C)
      INTEGER M,NEW,FEN,FENMX,HALF,DUB
      REAL Y(M1),X(M1),S(M),SF,SL,SLL,A(M),C(M)
C    M = NUMBER OF DIMENSIONS,Y=STARTING POINT, FINAL POINT, SF = FIRST
C    STEPLENGTH, SL = CURRENT STEPLENGTH. SLL = LEAST STEPLENGTH, NEW
C    IS SET TO 1 IF BETTER POINT IS FOUND OTHERWISE IT IS 0. RI = MUL-
C    TIPLIER IN RANDOM NUMBER GENERATOR, RN =NUMBER OF R.N. USED, FEN =
C    NUMBER OF FUNCTION EVALUATIONS PERFORMED, FENMX = MAX NUMBER OF
C    FUNCTION EVALUATIONS PERMITTED. X = WORKING AREA
      NEW=0
      SL=SF
      HALF=2
      DUB=1
   20 DO 200 J=1,HALF
      IF (FEN.EQ.FENMX) RETURN
C    NEW DIRECTION S
      L=1
      Q=0
      DO 50 I=1,M
      CALL NORMD (S(I))
   50 Q=Q+S(I)*S(I)
      Q=SL/SQRT(Q)
   60 DO 65 I=1,M
   65 S(I)=Q*S(I)
C    NEW BASE POINT
   70 DO 75 I=1,M
   75 X(I)=Y(I)+S(I)
C    POINTS ON THE LINE THROUGH X AND DIRECTION S
   80 DO 150 K=1,DUB
      IF (FEN.LT.FENMX) GO TO 90
      NEW=-1-NEW
      RETURN
   90 CONTINUE
C    TEST FOR X IN A
      IF (IRA(X,A,C,M).EQ.0) GO TO (160,200),L
      X(M1)=-FI(X,M)
      FEN=FEN+1
C    BETTER POINT
      IF (X(M1).LE.Y(M1)) GO TO (160,200),L
C    BETTER POINT IS STORED,NEW POINT ON LINE
      DO 100 I=1,M
      Y(I)=X(I)
  100 X(I)=X(I)+S(I)
      Y(M1)=X(M1)
      NEW=NEW+1
  150 CONTINUE
C    STEPLENGTH IS DOUBLED
      SL=2.*SL
      Q=2.
      GO TO 60
C    OPPOSITE DIRECTION
  160 L=2
      DO 170 I=1,M
  170 S(I)=-S(I)
      GO TO 70
  200 CONTINUE
C    STEPLENGTH IS HALVED
      SL=0.5*SL
      IF (SL.GT.SLL) GO TO 20
      RETURN
      END
      SUBROUTINE RADUS(DIM,DIMAX,N,ALFA,X,P,D,R1,S,OUT,A,B,E,W,F)
      INTEGER DIM,DIMAX,D,P(N),OUT
      REAL X(21,150),A(DIM),B(DIM),E(DIM),W(DIM),F(DIM)
      REAL S(21,21),NINV
      LOGICAL ODD
      NINV=1./FLOAT(N)
      SQIN=SQRT(NINV)
      PHI=3.141593
      ALFA=2.
C    COMPUTE THE COVARIANCE MATRIX
      DO 14 I=1,DIM
      XH=0.
      DO 12 JJ=1,N
      J=P(JJ)
   12 XH=XH+X(I,J)
      W(I)=XH*SQIN
   14 CONTINUE
      DO 18 I1=1,DIM
      DO 17 I2=1,I1
      XH=0.
      DO 16 JJ=1,N
      J=P(JJ)
   16 XH=XH+X(I1,J)*X(I2,J)
      XH=XH-W(I1)*W(I2)
      S(I1,I2)=XH
      S(I2,I1)=XH
   17 CONTINUE
   18 CONTINUE
C    THE CASE DIM=1
      R1=ALFA*ALFA*S(1,1)*NINV**3
      IF(DIM.EQ.1) GO TO 39
C    TRIDIAGONALIZATION OF S. RESULT IN A AND B
      CALL TRIDMX(DIM,DIMAX,S,A,B)
C    EIGENVALUES OF TRIDIAGONAL MATRIX
      CALL EIGVAL(DIM,E,A,B,W,F)
C    DETERMINE R1
      R1=-1.
      F2D=1.
      F1M=1.
      ODD=.TRUE.
      M=0
      EH=1.
C    N INSTEAD OF N-1 AS A CORRECTION FOR SMALL N
      TOALF=4.*ALFA*ALFA*NINV
      DO 38 K=1,DIM
C    COMPUTE THE VOLUME E(K)=V(L,K,LAMDA)
      IF (E(K).LT.0.) E(K)=0.
      EH=EH*E(K)*TOALF
      E(K)=SQRT(EH)
C    COMPUTE R1N BY USING E(K)
      DINV=2./FLOAT(K)
      IF (ODD) GO TO 32
C    EVEN CASE
      R1N=(F1M*E(K)*NINV)**DINV/PHI
      ODD=.TRUE.
      F2D=F2D*FLOAT(K+1)
      GO TO 34
C    ODD CASE
   32 R1N=(F2D*E(K)*NINV/(2.*(2.*PHI)**M))**DINV
      M=M+1
      F1M=F1M*FLOAT(M)
      ODD=.FALSE.
   34 IF (R1.GE.R1N) GO TO 40
      R1=R1N
   38 CONTINUE
   39 D=DIM
      RETURN
C    DIMENSION OF VOLUME IS K-1
   40 D=K-1
      RETURN
      END
      SUBROUTINE MSORT(N,A,LIST,START,HDS)
C    ALGORITHM 45 IN THE COMPUTER JOURNAL VOLUME 13 NUMBER 1 FEBRUARY
C    1970  N IS THE NUMBER OF KEYS TO BE SORTED. THE ACTUAL PARAMETER
C    CORRESPONDING TO LIST SHOLD HAVE BOUNDS 1 TO N. A(1) TO A(N)
C    SHOULD CONTAIN THE N KEYS TO BE SORTED. AFTER MSORT HAS BEEN
C    CALLED, A WILL BE UNCHANGED. START WILL HAVE THE INDEX OF THE
C    START OF THE ORDERED LIST, SO THAT A(START) IS THE SMALLEST KEY,
C    AND THE REMAINING ORDER IS DEFINED BY LIST. TO PICK UP THE ITEMS
C    IN ORDER AFTER CALLING MSORT IS SIMPLE. FOR EXAMPLE IF PRINT(X)
C    IS A PROCEDURE WHICH PRINTS THE VALUE OF X ON A NEW LINE, THEN
C    ALL OF THE ITEMS OF A(I) WOULD BE PRINTED IN ORDER BY THE STATE-
C    MENT FOR I=START,LIST(I) WHILE I.NE. 0 DO PRINT(A(I))
      DIMENSION LIST(N),A(N)
      INTEGER HDS(N)
      INTEGER START,T,TRY1,TRY2
      REAL NEXT
C    FROM HERE TO LABEL 150 THE FIRST PASS LINKS ADJACENT ITEMS INTO
C    ORDERED LISTS, USING EXISTING RUNS IN THE DATA. A LIST MAY BE
C    EITHER FORWARD, IF THE RUN IS IN ORDER, OR BACKWARD IF IT IS IN
C    REVERSE ORDER
      START=1
      LIST(1)=0
      IF (N.LE.1) RETURN
      J=1
      T=1
      K=2
      TRY=A(1)
   10 NEXT=A(K)
      IF (TRY.GT.NEXT) GO TO 110
      HDS(J)=T
   50 LIST(T)=K
      IF (K-N) 70,60,70
   60 LIST(K)=0
      GO TO 150
   70 TRY=NEXT
      T=K
      K=K+1
      NEXT=A(K)
      IF (TRY.LE.NEXT) GO TO 50
      LIST(T)=0
   80 T=K
      K=K+1
      J=J+1
      IF (T-N) 100,90,100
   90 HDS(J)=N
      LIST(N)=0
C    THE LAST LIST HAS ONE MEMBER
      GO TO 150
  100 TRY=NEXT
      GO TO 10
  110 LIST(T)=0
  120 LIST(K)=T
      IF (K-N) 140,130,140
  130 HDS(J)=K
      GO TO 150
  140 TRY=NEXT
      T=K
      K=K+1
      NEXT=A(K)
      IF (TRY.GE.NEXT) GO TO 120
      HDS(J)=T
      GO TO 80
  150 IF (J.EQ.1) GO TO 320
C    THIS WOULD IMPLY THAT THE DATA WAS ALREADY IN ORDER
C    OR REVERSE ORDER
      NOL=J
C    NOL IS  THE NUMBER OF LISTS AFTER EACH PASS
      IT=1
  155 IF (IT.GE.NOL) GO TO 160
      K=IT
      IT=IT+IT
      GO TO 155
  160 J=K+K+1-NOL
      T=J
      GO TO 180
C    MERGING STARTS PART-WAY THROUGH, AT A POINT CHOSEN TO REDUCE THE
C    NUMBER OF LISTS TO A POWER OF 2 AFTER THE FIRST MERGING PASS
  170 T=1
      J=1
C    LISTS STARTING FROM HDS(T) AND HDS(T+1) ARE MERGED
C    INTO A LIST STARTING FROM HDS(J)
  180 TRY1=HDS(T)
      TRY2=HDS(T+1)
      AT1=A(TRY1)
      AT2=A(TRY2)
      IF (AT1-AT2) 190,190,200
  190 HDS(J)=TRY1
      GO TO 260
  200 HDS(J)=TRY2
  210 K=LIST(TRY2)
      IF (K) 230,220,230
  220 LIST(TRY2)=TRY1
      GO TO 310
  230 AT2=A(K)
      IF (AT1-AT2) 250,240,240
  240 TRY2=K
      GO TO 210
  250 LIST(TRY2)=TRY1
      TRY2=K
  260 K=LIST(TRY1)
      IF (K) 280,270,280
  270 LIST(TRY1)=TRY2
      GO TO 310
  280 AT1=A(K)
      IF (AT2-AT1) 290,300,300
  290 LIST(TRY1)=TRY2
      TRY1=K
      GO TO 210
  300 TRY1=K
      GO TO 260
  310 J=J+1
      T=T+2
      IF (NOL.GT.T) GO TO 180
      NOL=J-1
      IF (NOL.GT.1) GO TO 170
  320 START=HDS(1)
      RETURN
      END
      SUBROUTINE SEPAR(DIM,N,D,R1,P,X,NCL,MARK,MARKR,C,R,NMCV,DISTP,
     CDIST,M1)
      INTEGER DIM,N,NCL,D
      INTEGER P(N),MARK(N),MARKR(N),NMCV(N),DISTP(N)
      INTEGER NEXTP(150),LASTP(150)
      REAL X(21,150),DIST(N),C(M1),R(N)
C    INITIALIZE MARKERARRAY MARKR. NUMBER OF CLUSTERS NCL, TOTAL NUMBER
C    OF MARKED POINTS NMT, INDEX TO SEED POINT IN MARKS IS, NUMBER OF
C    POINTS LEFT TO MARK LEFT, NUMBER OF COMPUTED RADIES NRR
      DO 15 I=1,N
   15 MARKR(I)=0
      NCL=0
      NMT=0
      LEFT=N
      IS=1
      DINV=2./FLOAT(D)
      R(1)=R1
      NRR=1
C    START NEXT CLUSTER. X(K) IS THE NEXT SEED POINT NMC COUNTS THE
C    NUMBER OF POINTS IN A CLUSTER
   20 NCL=NCL+1
      NMC=1
      NMT=NMT+1
      LEFT=LEFT-1
      K=P(IS)
      MARK(NMT)=K
      MARKR(IS)=NCL
C    CHECK IF ALL MARKED
      IF (LEFT.EQ.0) GO TO 60
C    COMPUTE DISTANCES FROM SEED POINT C TO THOSE POINTS NOT YET
C    MARKED. DIM DIMENSION OF ARGUMENT SPACE
      DO 42 I=1,DIM
   42 C(I)=X(I,K)
      KL=IS
      DO 48 KK=1,LEFT
   44 KL=KL+1
      IF (MARKR(KL).NE.0) GO TO 44
      D2=0.
      IX=P(KL)
      DO 46 I=1,DIM
      E=C(I)-X(I,IX)
      D2=D2+E*E
   46 CONTINUE
      DIST(KK)=D2
      DISTP(KK)=KL
   48 CONTINUE
C    MARK POINTS
      KK2=LEFT
      DO 58 I=1,KK2
      KK1=LEFT
      IF (I.LE.NRR) GO TO 505
      R(I)=R1*(FLOAT(I))**DINV
      NRR=NRR+1
  505 RR=R(I)
      IF (I.EQ.1) GO TO 510
      DO 507 II=1,NNEXT
  507 LASTP(II)=NEXTP(II)
      NLAST=NNEXT
  510 NNEXT=0
      J=0
      DO 56 JL=1,KK1
  512 J=J+1
      IF (DISTP(J).EQ.0) GO TO 512
      IF (DIST(J).GT.RR) GO TO 56
C    DISTANCE TO A POINT IN LASTP SHOULD BE LE R1
      IC=DISTP(J)
      IC=P(IC)
      IF (I.EQ.1) GO TO 548
      DO 542 II=1,DIM
  542 C(II)=X(II,IC)
      DO 546 JJ=1,NLAST
      D2=0.
      ILAST=LASTP(JJ)
      DO 544 II=1,DIM
      E=C(II)-X(II,ILAST)
  544 D2=D2+E*E
      IF (D2.LE.R1) GO TO 548
  546 CONTINUE
      GO TO 56
  548 NNEXT=NNEXT+1
      NEXTP(NNEXT)=IC
      NMC=NMC+1
      NMT=NMT+1
      LEFT=LEFT-1
      JP=DISTP(J)
      MARK(NMT)=P(JP)
      MARKR(JP)=NCL
      DISTP(J)=0
      IF (LEFT.EQ.0) GO TO 60
   56 CONTINUE
      IF (LEFT.EQ.KK1) GO TO 60
   58 CONTINUE
C    UPDATE VECTOR NMCV CONTAINING THE NUMBER OF POINTS IN CLUSTER
C    NCL  TEST IF ALL MARKED
   60 NMCV(NCL)=NMC
      IF (LEFT.EQ.0) RETURN
C    SEARCH FOR NEXT SEED POINT
      IS1=IS+1
      DO 78 IS=IS1,N
      IF (MARKR(IS).EQ.0) GO TO 20
   78 CONTINUE
      RETURN
      END
      SUBROUTINE OUTRE(M,SN,PN,CN,REDUC,PG,MARKM,MARK,PNC,NM,M2)
      INTEGER SN,PN,CN,REDUC(M),PG(M2),PNC(M2),MARKM(NM),MARK(M2)
C    POINTS ARE SORTED CLUSTER WIESE
   10 PN=0
      JS=REDUC(SN)
      M1=M+1
      JL=0
      DO 100 MC=1,CN
      JF=JL+1
      JL=JL+PNC(MC)
      DO 50 J=JF,JL
      K=MARK(J)
      MARKM(K)=MC
   50 CONTINUE
C    REDUCTION OF POINTS FOR NEXT CLUSTERING
      DO 70 J=JF,JL,JS
      PN=PN+1
   70 PG(PN)=MARK(J)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE UNDEV(A)
      A=ATS(1)
      RETURN
      END
      SUBROUTINE NORMD(A)
      A=SIN(6.283185*ATS(1))*SQRT(-2.*ALOG(ATS(1)))
      RETURN
      END
      FUNCTION IRA(X,A,C,M)
      DIMENSION X(M),A(M),C(M)
      IR =1
      DO 1 I=1,M
      X1=X(I)-A(I)
      IF (X1.LT.0..OR.X1.GT.C(I))IR=0
    1 CONTINUE
      IRA=IR
      RETURN
      END
      SUBROUTINE INWR16(A,B,N,IPAR,IPA)
      DIMENSION IPAR(30),A(N),B(N)
      COMMON /STATIS/IFAIL,IT,ITM,NF
      MN=20
      MIP=30
      MIM=1
      MM=150
      K=3
      NOUT=I1MACH(2)
      IF (IPA.GE.0.AND.IPA+K.LE.MIP) GO TO 10
      WRITE (NOUT,520) K,MIP
      WRITE (NOUT,510) IPA
    5 IFAIL=10
      RETURN
   10 CONTINUE
      IPRINT=IPAR(IPA+1)
      IF (IPRINT.LT.0) GO TO 110
      WRITE (NOUT,1030)
      WRITE (NOUT,620)
      WRITE (NOUT,630) N
  110 IF (N.GT.0.AND.N.LE.MN) GO TO 20
      WRITE (NOUT,500) MN
      IF (IPRINT.LT.0) WRITE (NOUT,630) N
      GO TO 5
   20 CONTINUE
      M=IPAR(IPA+2)
      LT=IPAR(IPA+3)
      IF (IPRINT.LT.0) GO TO 40
      WRITE (NOUT,640) IPRINT
      WRITE (NOUT,650) M
      WRITE (NOUT,660) LT
   40 IF (M.GT.0) GO TO 45
      WRITE (NOUT,525)
      IF (IPRINT.LT.0) WRITE (NOUT,650) M
      GO TO 5
   45 CONTINUE
      IF (LT.GE.MIM.AND.LT.LE.MM) GO TO 80
      WRITE (NOUT,550) MIM,MM
      IF (IPRINT.LT.0) WRITE (NOUT,660) LT
      GO TO 5
   80 CONTINUE
      IF (IPRINT.LT.0) GO TO 200
      WRITE (NOUT,570)
      WRITE (NOUT,580) (A(I),I=1,N)
      WRITE (NOUT,590)
      WRITE (NOUT,580) (B(I),I=1,N)
  200 NER=0
      NER1=0
      DO 90 I=1,N
      IF (A(I).LT.B(I)) GO TO 90
      IF (A(I).NE.B(I)) GO TO 81
      NER1=NER1+1
      GO TO 90
   81 CONTINUE
      IF (NER.NE.0) GO TO 86
      WRITE (NOUT,600) I,I
      GO TO 87
   86 WRITE (NOUT,605) I,I
   87 CONTINUE
      NER=1
   90 CONTINUE
      IF (NER.EQ.0) GO TO 120
  100 IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,570)
      WRITE (NOUT,580) A
      WRITE (NOUT,590)
      WRITE (NOUT,580) B
      GO TO 5
  120 CONTINUE
      IF (NER1.NE.N) RETURN
      WRITE (NOUT,607)
      GO TO 100
  500 FORMAT (/2X,61H**E R R O R  I N  G L O P T** N LESS THAN 1 OR N GR
     CEATER THAN,I3)
  510 FORMAT (/2X,20HNUMBER OF PARAMETERS,11X,5HIPA =,I6)
  520 FORMAT (/2X,45H**E R R O R  I N  G L O P T** IPA LESS THAN 0/2X,
     C7HOR IPA+,I2,13H GREATER THAN,I3)
  525 FORMAT (/2X,43H**E R R O R  I N  G L O P T** M LESS THAN 1/)
  550 FORMAT (/2X,42H**E R R O R  I N  G L O P T** LT LESS THAN,I2/2X,
     C18HOR LT GREATER THAN,I4/)
  570 FORMAT ( /2X,32HVECTOR OF LOWER BOUNDS (A) FOR X)
  580 FORMAT (4(2X,E15.8))
  590 FORMAT (2X,32HVECTOR OF UPPER BOUNDS (B) FOR X)
  600 FORMAT (/2X,32H**E R R O R  I N  G L O P T** A(,I2,17H) GREATER TH
     CAN B(,I2,1H))
  605 FORMAT (32X,2HA(,I2,17H) GREATER THAN B(,I2,1H))
  607 FORMAT (/2X,55H**E R R O R  I N  G L O P T** VECTORS A AND B ARE E
     CQUAL)
  620 FORMAT (/2X,22HI N I T I A L  D A T A)
  630 FORMAT (/2X,19HNUMBER OF VARIABLES,22X,3HN =,I6)
  640 FORMAT (/2X,18HPRINTING PARAMETER,21X,5HIPR =,I6)
  650 FORMAT (2X,44HMAXIMUM NUMBER OF FUNCTION EVALUATIONS   M =,I6)
  660 FORMAT (2X,24HNUMBER OF INITIAL POINTS,16X,4HLT =,I6)
 1030 FORMAT (////12X,9HG L O P T)
      END
      SUBROUTINE SPAU16(IPR,NC,PNC,NMAX,MARK,N,X,FM,XM)
      COMMON /INW/IN/STATIS/IFAIL,NR,ITM,L
      DIMENSION XM(N),X(21,150),MARK(NMAX)
      INTEGER PNC(NMAX)
      NOUT=I1MACH(2)
      M1=N+1
      IF (IN.GT.0) GO TO 10
      WRITE(NOUT,100)
      IF (NR.EQ.IPR) WRITE (NOUT,210)
      WRITE (NOUT,110) NR
      JL=0
      DO 30 MC=1,NC
      JF=JL+1
      JL=JL+PNC(MC)
      DO 20 J=JF,JL
      K=MARK(J)
       F1=X(M1,K)
      IF (J.EQ.JF) GO TO 50
      IF (F1.LE.FM) GO TO 20
   50 CONTINUE
      FM=F1
      DO 40 I=1,N
   40 XM(I)=X(I,K)
   20 CONTINUE
      F1=-FM
      WRITE (NOUT,150) MC,F1
      WRITE(NOUT,160)
      WRITE (NOUT,130) (XM(I),I=1,N)
   30 CONTINUE
      RETURN
   10 WRITE(NOUT,170)
      WRITE(NOUT,180)
      WRITE (NOUT,120) FM
      WRITE(NOUT,160)
      WRITE (NOUT,130) (XM(I),I=1,N)
      WRITE(NOUT,190) L
      IF (IFAIL.EQ.0) WRITE (NOUT,260)
      IF (IFAIL.EQ.1) WRITE (NOUT,240)
      IF (IFAIL.EQ.2) WRITE (NOUT,270)
      WRITE (NOUT,200)
      WRITE(NOUT,170)
      RETURN
  100 FORMAT (/1X,34(2H -))
  110 FORMAT(2X,23HI T E R A T I O N  NR =,I6)
  120 FORMAT (/2X,28HOPTIMAL FUNCTION VALUE FM = ,E15.8)
  130 FORMAT(4(2X,E15.8))
  150 FORMAT (2X,7HCLUSTER,I4,29H OPTIMAL FUNCTION VALUE FM = ,E15.8)
  160 FORMAT(2X,13HOPTIMAL POINT)
  170 FORMAT (/1X,34(2H *)/1X,34(2H *))
  180 FORMAT (/2X,13HR E S U L T S)
  190 FORMAT (/2X,34HNUMBER OF FUNCTION EVALUATIONS L =,I6)
  200 FORMAT (/7X,16HGLOPT TERMINATED)
  210 FORMAT (1X,34(2H -))
  240 FORMAT (/2X,52HIFAIL = 1. TERMINATION CRITERION: NUMBER OF FUNCTIO
     CN/2X,20HEVALUATIONS EQUALS M)
  260 FORMAT (/2X,64HIFAIL = 0. TERMINATION CRITERION: NUMBER OF ITERATI
     CONS EQUALS 20)
  270 FORMAT (/2X,52HIFAIL = 2. TERMINATION CRITERION: OBJECTIVE FUNCTIO
     CN/2X,20HIS SUPPOSED UNIMODAL)
      END

      SUBROUTINE MIG2(X,A,B,N,XN,NM,FM,IPAR,IPA)
C     THE PARAMETERS
C     IPAR(IPA+1) = IPR - PRINTING PARAMETER
C     IPAR(IPA+2) = M - THE TOTAL NUMBER OF FUNCTION EVALUATIONS
      DIMENSION IPAR(30),X(N),A(N),B(N),XN(NM)
       COMMON /BAYZ/Z(20)/BS1/Y(1000)/INW/IN/ATT/AT(15)
     C/STATIS/IFAIL,M,IM,L
      IFAIL=0
      IN=5
      CALL INWR15(A,B,N,NM,IPAR,IPA)
      IF (IFAIL.EQ.10) RETURN
      IPR=IPAR(IPA+1)
      M=IPAR(IPA+2)
      J=0
      DO 70 K=1,M
      DO 10 I=1,N
   10 Z(I)=ATS(1)*(B(I)-A(I))+A(I)
      FF=FI(Z,N)
      L=K
      Y(L)=FF
      DO 16 I=1,N
      J1=J+I
   16 XN(J1)=Z(I)
      J=J+N
      IF (K.EQ.1) GO TO 20
      IF (FM.LE.FF) GO TO 50
   20 FM=FF
      IM=K
      DO 30 I=1,N
   30 X(I)=Z(I)
   50 IF(IPR.LE.0) GO TO 70
      IF (MOD(K,IPR).EQ.0) CALL SPAU15(X,Z,N,FM,FF,IPR)
   70 CONTINUE
      IF (IPR.LT.0) RETURN
      IN=IN+100
      CALL SPAU15(X,Z,N,FM,FF,IPR)
      RETURN
      END
      SUBROUTINE INWR15(A,B,N,NM,IPAR,IPA)
      DIMENSION IPAR(30),A(N),B(N)
      COMMON /STATIS/IFAIL,IM,ITM,NF
      MN=20
      MM=1000
      MIP=30
      NOUT=I1MACH(2)
      K=2
      IF (IPA.GE.0.AND.IPA+K.LE.MIP) GO TO 10
      WRITE (NOUT,520) K,MIP
      WRITE (NOUT,510) IPA
    5 IFAIL=10
      RETURN
   10 CONTINUE
      IPRINT=IPAR(IPA+1)
      M=IPAR(IPA+2)
      IF (IPRINT.LT.0) GO TO 110
      WRITE (NOUT,680)
      WRITE (NOUT,620)
      WRITE (NOUT,630) N
  110 IF (N.GT.0.AND.N.LE.MN) GO TO 20
      WRITE (NOUT,500) MN
      IF (IPRINT.LT.0) WRITE (NOUT,630) N
      GO TO 5
   20 CONTINUE
      IF (IPRINT.LT.0) GO TO 40
      WRITE (NOUT,640) IPRINT
      WRITE (NOUT,650) M
   40 IF (M.GT.0.AND.M.LE.MM) GO TO 50
      WRITE (NOUT,530) MM
      IF (IPRINT.LT.0) WRITE (NOUT,650) M
      GO TO 5
   50 IF (NM.GE.N*M) GO TO 60
      WRITE (NOUT,540)
      IF (IPRINT.GE.0) GO TO 55
      WRITE (NOUT,630) N
      WRITE (NOUT,650) M
   55 WRITE (NOUT,635) NM
      GO TO 5
   60 CONTINUE
      IF (IPRINT.LT.0) GO TO 200
      WRITE (NOUT,570)
      WRITE (NOUT,580) (A(I),I=1,N)
      WRITE (NOUT,590)
      WRITE (NOUT,580) (B(I),I=1,N)
  200 NER=0
      DO 90 I=1,N
      IF (A(I).LE.B(I)) GO TO 90
      IF (NER.NE.0) GO TO 86
      WRITE (NOUT,600) I,I
      GO TO 87
   86 WRITE (NOUT,605) I,I
   87 CONTINUE
      NER=1
   90 CONTINUE
      IF (NER.NE.1) RETURN
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,570)
      WRITE (NOUT,580) A
      WRITE (NOUT,590)
      WRITE (NOUT,580) B
      GO TO 5
  500 FORMAT (/2X,59H**E R R O R  I N  M I G 2** N LESS THAN 1 OR N GREA
     CTER THAN,I3)
  510 FORMAT (/2X,20HNUMBER OF PARAMETERS,11X,5HIPA =,I6)
  520 FORMAT (/2X,43H**E R R O R  I N  M I G 2** IPA LESS THAN 0/2X,
     C7HOR IPA+,I2,13H GREATER THAN,I3)
  530 FORMAT (/2X,59H**E R R O R  I N  M I G 2** M LESS THAN 1 OR M GREA
     CTER THAN,I6/)
  540 FORMAT (/2X,44H**E R R O R  I N  M I G 2** NM LESS THAN N*M)
  570 FORMAT ( /2X,32HVECTOR OF LOWER BOUNDS (A) FOR X)
  580 FORMAT (4(2X,E15.8))
  590 FORMAT (2X,32HVECTOR OF UPPER BOUNDS (B) FOR X)
  600 FORMAT (/2X,30H**E R R O R  I N  M I G 2** A(,I3,17H) GREATER THAN
     C B(,I3,1H))
  605 FORMAT (30X,2HA(,I3,17H) GREATER THAN B(,I3,1H))
  620 FORMAT (/2X,22HI N I T I A L  D A T A)
  630 FORMAT (/2X,19HNUMBER OF VARIABLES,14X,3HN =,I6)
  635 FORMAT (2X,26HDIMENSION OF WORKING ARRAY,6X,4HNM =,I6)
  640 FORMAT (/2X,18HPRINTING PARAMETER,13X,5HIPR =,I6)
  650 FORMAT (2X,30HNUMBER OF FUNCTION EVALUATIONS, 3X,3HM =,I6)
  680 FORMAT (////12X,7HM I G 2)
      END
      SUBROUTINE SPAU15(X,Z,N,YM,FF,IPR)
      DIMENSION X(N),Z(N)
      COMMON /INW/IN/STATIS/IFAIL,IT,IM,L
      NOUT=I1MACH(2)
      IF(IN.GT.100) GOTO 10
      WRITE(NOUT,100)
      IF (L.EQ.IPR) WRITE(NOUT,210)
      WRITE(NOUT,110) L
      WRITE(NOUT,120) FF
      WRITE(NOUT,140)
      WRITE(NOUT,130) (Z(I),I=1,N)
      IF (L.EQ.1) RETURN
      WRITE(NOUT,150) YM,IM
      WRITE(NOUT,160)
      WRITE(NOUT,130) (X(I),I=1,N)
      RETURN
   10 WRITE(NOUT,170)
      WRITE(NOUT,180)
      WRITE(NOUT,150) YM,IM
      WRITE(NOUT,160)
      WRITE(NOUT,130) (X(I),I=1,N)
      WRITE(NOUT,190) L
      WRITE (NOUT,230)
      WRITE(NOUT,170)
      RETURN
  100 FORMAT (/1X,34(2H -))
  110 FORMAT(2X,23HI T E R A T I O N  NR =,I6)
  120 FORMAT (/2X,19HFUNCTION VALUE F = ,E15.8)
  130 FORMAT(4(2X,E15.8))
  140 FORMAT (2X,13HCURRENT POINT)
  150 FORMAT (/2X,28HOPTIMAL FUNCTION VALUE FM = ,E15.8,17H OBTAINED IN
     CNR =,I6)
  160 FORMAT(2X,13HOPTIMAL POINT)
  170 FORMAT (/1X,34(2H *)/1X,34(2H *))
  180 FORMAT (/2X,13HR E S U L T S)
  190 FORMAT (/2X,34HNUMBER OF FUNCTION EVALUATIONS L =,I6)
  210 FORMAT (1X,34(2H -))
  230 FORMAT (/7X,15HMIG2 TERMINATED)
      END

      SUBROUTINE ANAL2(A,B,N,XX,X,NM,IPAR,IPA)
      DIMENSION A(N),B(N),IPAR(30),XX(NM),X(NM)
      COMMON /ANA1/R(20,20)/ANA2/VK(20,20)/ANA3/DX(20)/ANA4/DY(20)
      COMMON /BS1/F(1000)/STATIS/IFAIL,IT,ITM,NF
      IFAIL=0
      CALL INWR22(A,B,N,XX,NM,IPAR,IPA)
      IF (IFAIL.EQ.10) RETURN
      ISP=IPAR(IPA+1)
      M=IPAR(IPA+2)
      NF=M
      IT=M
      ITM=M
      DO 1 I=1,N
      AIN=B(I)-A(I)
      DO 1 J=1,M
      I1=(J-1)*N+I
    1 X(I1)=(XX(I1)-A(I))/AIN
      VID=0.
      DO 5 I=1,M
    5 VID=VID+F(I)
      VID=VID/FLOAT(M)
      CALL FAKTKK(X,NM,F,M,R,N,20)
      DISP=0.
      DO 6 I=1,N
    6 DISP=DISP+R(I,I)
      IF (DISP.GT.1.E-10) GO TO 10
      IFAIL=10
      CALL INWR22(A,B,N,XX,NM,IPAR,IPA)
      RETURN
   10 CONTINUE
      DO 7 I=1,N
    7 DX(I)=R(I,I)/DISP
      CALL VKNVR(R,20,N,VK,DY,1.E-5,200)
      DO 16 I=1,N
   16 DY(I)=DY(I)/DISP
      CALL SPAU22(ISP,VID,DISP,N)
      RETURN
      END
      SUBROUTINE MAXNVR(R,M,N,VK,RNR,EPS,ITER)
      DIMENSION R(M,M),VK(N),VK1(100)
      DO 1 I=1,N
    1 VK(I)=1.
      DO 2 IT=1,ITER
      DO 12 I=1,N
      VK1(I)=0.
      DO 12 J=1,N
   12 VK1(I)=VK1(I)+VK(J)*R(J,I)
      RNR=VK1(1)
      DO 9 I=2,N
      R1=VK1(I)
      IF(ABS(R1).GT.ABS(RNR)) RNR=R1
    9 CONTINUE
      DO 3 I=1,N
    3 VK1(I)=VK1(I)/RNR
      S=0.
      DO 4 I=1,N
      S=S+(VK1(I)-VK(I))**2
    4 VK(I)=VK1(I)
      S=SQRT(S)
      IF(S.LT.EPS) GO TO 5
    2 CONTINUE
    5 S=0.
      DO 6 I=1,N
    6 S=S+VK(I)*VK(I)
      S=SQRT(S)
      DO 7 I=1,N
    7 VK(I)=VK(I)/S
      RETURN
      END
      SUBROUTINE FAKTKK(X,NM,F,M,R,N,MR)
      DIMENSION X(NM),F(M),R(MR,MR)
      RL=FLOAT(M)
      RL=RL*RL-RL
      DO 3 I=1,N
      DO 3 J=I,N
    3 R(I,J)=0.
      M1=M-1
      NM1=0
      DO 11 K=1,M1
      K2=K+1
      NM2=NM1+N
      DO 12 K1=K2,M
      Z=0.
      DO 5 JJ=1,N
      NM3=NM1+JJ
      NM4=NM2+JJ
    5 Z=Z+(X(NM3)-X(NM4))**2
      IF (Z.LT.1.E-10) GO TO 12
      FK=(F(K)-F(K1))**2
      DO 33 I=1,N
      NM3=NM1+I
      NM4=NM2+I
      DO 33 J=I,N
      NM5=NM1+J
      NM6=NM2+J
   33 R(I,J)=R(I,J)+FK*(X(NM3)-X(NM4))*(X(NM5)-X(NM6))/Z
   12 NM2=NM2+N
      NM1=NM1+N
   11 CONTINUE
      DO 34 I=1,N
      DO 34 J=I,N
      R(I,J)=R(I,J)/RL
      IF(I.EQ.J) GO TO 34
      R(J,I)=R(I,J)
   34 CONTINUE
      RETURN
      END
      SUBROUTINE VKNVR(R,M,N,VK,RNRX,EPS,ITER)
      DIMENSION R(M,M),VK(M,M),RNRX(N),V(20,20),VK1(20)
      DO 14 I=1,N
      DO 14 J=1,N
   14 V(I,J)=R(I,J)
      DO 15 I=1,N
      CALL MAXNVR(V,20,N,VK1,RNRX(I),EPS,ITER)
      DO 12 J1=1,N
      DO 12 J2=1,N
   12 V(J1,J2)=V(J1,J2)-RNRX(I)*VK1(J1)*VK1(J2)
      DO 13 J=1,N
   13 VK(J,I)=VK1(J)
   15 CONTINUE
      RETURN
      END
      SUBROUTINE INWR22(A,B,N,X,NM,IPAR,IPA)
      DIMENSION A(N),B(N),X(NM),IPAR(30)
      COMMON /STATIS/IFAIL,IT,ITM,NF/BS1/F(1000)
      MIM=10
      MN=20
      MIP=30
      MM=300
      NOUT=I1MACH(2)
      K=2
      R1M=SQRT(R1MACH(2))/100.
      IF (IFAIL.EQ.0) GO TO 3
      WRITE (NOUT,970)
      RETURN
    3 CONTINUE
      IF (IPA.GE.0.AND.IPA+K.LE.MIP) GO TO 10
      WRITE (NOUT,520) K,MIP
      WRITE (NOUT,510) IPA
    5 IFAIL=10
      RETURN
   10 CONTINUE
      IPRINT=IPAR(IPA+1)
      IF (IPRINT.LT.0) GO TO 110
      WRITE(NOUT,960)
      WRITE (NOUT,620)
      WRITE (NOUT,630) N
  110 IF (N.GT.0.AND.N.LE.MN) GO TO 20
      WRITE (NOUT,500) MN
      IF (IPRINT.LT.0) WRITE (NOUT,630) N
      GO TO 5
   20 CONTINUE
      M=IPAR(IPA+2)
      IF (IPRINT.LT.0) GO TO 40
      WRITE (NOUT,640) IPRINT
      WRITE (NOUT,650) M
   40 IF (M.GE.MIM.AND.M.LE.MM) GO TO 47
      WRITE(NOUT,530) MIM,MM
      IF (IPRINT.LT.0) WRITE (NOUT,650) M
      GO TO 5
   47 IF (NM.GE.N*M) GO TO 50
      WRITE (NOUT,730)
      IF (IPRINT.GE.0) GO TO 48
      WRITE (NOUT,630) N
      WRITE (NOUT,650) M
   48 WRITE (NOUT,635) NM
      GO TO 5
   50 CONTINUE
      IF (IPRINT.LT.0) GO TO 200
      WRITE (NOUT,570)
      WRITE (NOUT,580) (A(I),I=1,N)
      WRITE (NOUT,590)
      WRITE (NOUT,580) (B(I),I=1,N)
  200 NER=0
      DO 90 I=1,N
      IF (A(I).LT.B(I)) GO TO 90
      IF (NER.NE.0) GO TO 86
      WRITE (NOUT,600) I,I
      GO TO 87
   86 WRITE (NOUT,605) I,I
   87 CONTINUE
      NER=1
   90 CONTINUE
      IF (NER.NE.1) GO TO 260
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,570)
      WRITE (NOUT,580) A
      WRITE (NOUT,590)
      WRITE (NOUT,580) B
      GO TO 5
  260 NER=0
      DO 270 I=1,M
      IF (ABS(F(I)).LT.R1M) GO TO 275
      WRITE (NOUT,860) F(I)
      J1=(I-1)*N+1
      J2=I*N
      WRITE (NOUT,580) (X(J),J=J1,J2)
      GO TO 5
  275 CONTINUE
      DO 285 J=1,N
      J1=(I-1)*N+J
      IF(X(J1).LE.B(J).AND.X(J1).GE.A(J)) GOTO 285
      IF (NER.NE.0) GO TO 280
      WRITE(NOUT,830) I
      GO TO 290
  280 WRITE(NOUT,840) I
  290 NER=1
      GO TO 270
  285 CONTINUE
  270 CONTINUE
      IF (NER.EQ.1) GO TO 5
      RETURN
  500 FORMAT (/2X,61H**E R R O R  I N  A N A L 2** N LESS THAN 1 OR N GR
     CEATER THAN,I3)
  510 FORMAT (/2X,20HNUMBER OF PARAMETERS,11X,5HIPA =,I6)
  520 FORMAT (/2X,45H**E R R O R  I N  A N A L 2** IPA LESS THAN 0/2X,
     C7HOR IPA+,I2,13H GREATER THAN,I3)
  530 FORMAT(/2X,41H**E R R O R  I N  A N A L 2** M LESS THAN,I3/2X,
     C17HOR M GREATER THAN,I6/)
  570 FORMAT ( /2X,32HVECTOR OF LOWER BOUNDS (A) FOR X)
  580 FORMAT (4(2X,E15.8))
  590 FORMAT (2X,32HVECTOR OF UPPER BOUNDS (B) FOR X)
  600 FORMAT (/2X,32H**E R R O R  I N  A N A L 2** A(,I2,22H) GREATER OR
     C EQUALS B(,I2,1H))
  605 FORMAT (32X,2HA(,I2,22H) GREATER OR EQUALS B(,I2,1H))
  620 FORMAT (/2X,22HI N I T I A L  D A T A)
  630 FORMAT(/2X,19HNUMBER OF VARIABLES,14X,3HN =,I6)
  635 FORMAT (2X,26HDIMENSION OF WORKING ARRAY,6X,4HNM =,I6)
  640 FORMAT(/2X,18HPRINTING PARAMETER,13X,5HIPR =,I6)
  650 FORMAT(2X,36HNUMBER OF FUNCTION EVALUATIONS   M =,I6)
  730 FORMAT (/2X,46H**E R R O R  I N  A N A L 2** NM LESS THAN N*M)
  830 FORMAT(/2X,42H**E R R O R  I N  A N A L 2** POINT NUMBER,I4,
     C14H OUT OF BOUNDS)
  840 FORMAT(32X,12HPOINT NUMBER,I4,14H OUT OF BOUNDS)
  860 FORMAT (/2X,54H**E R R O R  I N  A N A L 2** TOO LARGE FUNCTION VA
     CLUE//2X,3HF =,E15.8,2X,3HX =)
  960 FORMAT (////12X,9HA N A L 2)
  970 FORMAT (/2X,61H**E R R O R  I N  A N A L 2** VARIATION OF OBJECTIV
     CE FUNCTION/2X,12HIS TOO SMALL)
      END
      SUBROUTINE SPAU22(ISP,VID,DISP,N)
      COMMON /ANA1/R(20,20)/ANA2/VK(20,20)/ANA3/DX(20)/ANA4/DY(20)
      DIMENSION V4(60)
      DATA V1,V2/1HX,1HY/
      NOUT=I1MACH(2)
      IF (ISP.LT.0) GO TO 100
      WRITE (NOUT,170)
      WRITE (NOUT,180)
      WRITE (NOUT,210) VID,DISP
      WRITE (NOUT,500)
      N1=1
   10 N2=MIN0(N,N1+4)
      CALL LENT22(V1,N1,N2,V4)
      DO 20 I=1,N
      IF (I.LE.9) WRITE (NOUT,550) I,(R(I,J),J=N1,N2)
      IF (I.GT.9) WRITE (NOUT,560) I,(R(I,J),J=N1,N2)
   20 CONTINUE
      WRITE (NOUT,570) V4
      IF (N2.EQ.N) GO TO 30
      N1=N2+1
      GO TO 10
   30 CONTINUE
      WRITE (NOUT,590)
      N1=1
   40 N2=MIN0(N,N1+4)
      CALL LENT22(V2,N1,N2,V4)
      DO 50 I=1,N
      IF (I.LE.9) WRITE (NOUT,550) I,(VK(I,J),J=N1,N2)
      IF (I.GT.9) WRITE (NOUT,560) I,(VK(I,J),J=N1,N2)
   50 CONTINUE
      WRITE (NOUT,570) V4
      IF (N2.EQ.N) GO TO 60
      N1=N2+1
      GO TO 40
   60 CONTINUE
      WRITE (NOUT,510)
      DO 70 I=1,N
      IF (I.LE.9) WRITE (NOUT,520) I,DX(I),I,DY(I)
      IF (I.GT.9) WRITE (NOUT,530) I,DX(I),I,DY(I)
   70 CONTINUE
      WRITE (NOUT,540)
  100 DO 110 I=1,N
      IF (DY(I).GT.0.) GO TO 110
      WRITE (NOUT,300) I
  110 CONTINUE
      IF (ISP.LT.0) RETURN
      WRITE (NOUT,450)
      WRITE (NOUT,170)
      RETURN
  170 FORMAT (/1X,34(2H *)/1X,34(2H *))
  180 FORMAT (/2X,13HR E S U L T S)
  210 FORMAT (/2X,16HMEAN VALUE MV = ,E15.8,3X,16HDISPERSION DS = ,
     CE15.8)
  300 FORMAT (2X,12HWARNING: DY(,I2,13H) LESS THAN 0)
  450 FORMAT (/7X,16HANAL2 TERMINATED)
  500 FORMAT (/2X,18HCOVARIACION MATRIX)
  510 FORMAT (/4X,33HDEGREES OF INFLUENCE OF VARIABLES/2X,37(1H-)/4X,
     C33HINITIAL SYSTEM  I  OPTIMAL SYSTEM/2X,18(1H-),1HI,18(1H-)/
     C3X,1HX,8X,2HDX,6X,1HI,2X,1HY,8X,2HDY/2X,18(1H-),1HI,18(1H-))
  520 FORMAT (2X,1HX,I1,3X,E12.5,3H I ,1HY,I1,3X,E12.5)
  530 FORMAT (2X,1HX,I2,2X,E12.5,3H I ,1HY,I2,2X,E12.5)
  540 FORMAT (2X,37(1H-))
  550 FORMAT (2X,1HX,I1,3X,5(E12.5))
  560 FORMAT (2X,1HX,I2,2X,5(E12.5))
  570 FORMAT (2X,5(1H-),60A1/)
  580 FORMAT (/)
  590 FORMAT (/2X,25HOPTIMAL COORDINATE SYSTEM)
      END
      SUBROUTINE LENT22(V3,N1,N2,V4)
      DIMENSION V(51),V1(10),V4(60)
      DATA V2,V5/1H ,1H-/
      DATA V1/1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H0/
      NOUT=I1MACH(2)
      DO 10 I=1,51
   10 V(I)=V2
      J=1
      DO 40 I=N1,N2
      V(J)=V3
      IF (I.GT.9) GO TO 20
      V(J+1)=V1(I)
      GO TO 30
   20 K=MOD(I,10)
      K1=K
      IF (K1.EQ.0) K1=10
      V(J+2)=V1(K1)
      K=(I-K)/10
      V(J+1)=V1(K)
   30 J=J+12
   40 CONTINUE
      WRITE (NOUT,100) V
      DO 50 I=1,60
   50 V4(I)=V2
      J=12*(N2-N1+1)
      DO 60 I=1,J
   60 V4(I)=V5
      WRITE (NOUT,110) V4
      RETURN
  100 FORMAT (12X,51A1)
  110 FORMAT (2X,5(1H-),60A1)
      END

      SUBROUTINE LBAYES(X,A,B,N,F1,IPAR,PAR,IPA,IPAA)
      DIMENSION X(N),A(N),B(N),IPAR(30),PAR(30),
     CDML1(100),X1(100),DML(100),X2(100)
      COMMON /LAIK/FM,XM(100)
      COMMON /STATIS/IFAIL,M,IM,L/INW/IN
      IFAIL=0
      IN=0
      CALL INWR36(X,A,B,N,F1,IPAR,PAR,IPA,IPAA)
      IF (IFAIL.EQ.10) RETURN
      IT=IPAR(IPA+2)
      NIPA=IPAR(IPA+3)
      AIT=FLOAT(IT)
      EPS2=1.E-6
      EPS3=1.E-6
      EPS4=1.E-10
      ANIU=PAR(IPAA+1)
      BETA=PAR(IPAA+2)
      N2=2*N
      AN2=FLOAT(N2)
      AM2=1.
      L=0
      M=1
      IM=M
      A1=0.
      AN0=1.
      L0=1
      M1=INT(0.8*AIT)
      F1=0.
      F11=0.
      DO 33 I=1,N
  33  X(I)=(X(I)*2.-(B(I)+A(I)))/(B(I)-A(I))
      DO 20 I=1,N2
      F=FI1(X,N,A,B,NIPA)
      F1=F1+F
  20  F11=F11+F*F
      F13=F1
      F1=F1/AN2
      IN=1
      IPRINT=IPAR(IPA+1)
      IF (IPRINT.GE.0) CALL INWR36(X,A,B,N,F1,IPAR,PAR,IPA,IPAA)
      IN=0
      F11=F11/AN2-F1*F1
      FM=F1
      DO 22 I=1,N
   22 XM(I)=X(I)
   25 LB=1
   26 AM1=FLOAT(M)
      AL=FLOAT(LB)
      HM0=0.2*AM1**(-ANIU)
      HM=SQRT(HM0)
      DO 30 I=1,N
      X1(I)=X(I)
  30  X2(I)=X(I)
      F6=0
      DO 40 I=1,N
      X1(I)=X(I)+HM0
      IF (X1(I).GT.1.) X1(I)=1.
      F2=FI1(X1,N,A,B,NIPA)
      X2(I)=X(I)-HM0
      IF (X2(I).LT.-1.) X2(I)=-1.
      F3=FI1(X2,N,A,B,NIPA)
      DML(I)=(F2-F3)*2.*HM0/ABS(X2(I)-X1(I))
      F6=F6+F2+F3
       X2(I)=X(I)
   40 X1(I)=X(I)
      IF (LB.EQ.1) GO TO 60
      DO 50 I=1,N
   50 DML(I)=DML(I)/AL+DML1(I)*(AL-1.)/AL
   60 CONTINUE
      S1=0.
      DO 70 I=1,N
   70 S1=S1+DML(I)**2
      S1=SQRT(S1)+EPS4
      DO 100 I=1,N
      SM=DML(I)/S1
      X1(I)=X(I)+HM*SM
      IF (X1(I).GT.1.) X1(I)=1.
      IF (X1(I).LT.-1.) X1(I)=-1.
      X2(I)=X(I)-HM*SM
      IF (X2(I).GT.1.) X2(I)=1.
      IF (X2(I).LT.-1.) X2(I)=-1.
  100  CONTINUE
      HS=0.
      HS1=0.
      HS2=0.
      F4=FI1(X1,N,A,B,NIPA)
      F5=FI1(X2,N,A,B,NIPA)
      DO 102 I=1,N
      HS=HS+(X2(I)-X1(I))**2
      HS1=HS1+(X1(I)-X(I))**2+EPS3
102   HS2=HS2+(X2(I)-X(I))**2+EPS3
      HS=SQRT(HS)
      HS1=SQRT(HS1)
      HS2=SQRT(HS2)
      HS12=HS1*HS2*(HS1+HS2)
      AM=F4*HS2-F1*HS+F5*HS1
      AM=AM*HM0*2./HS12
      D1=AM
      IF (AM.LT.1.E-6) D1=1.E-6
      IF (AM.LT.1.E-2.AND.M.EQ.1) D1=1.
      A1=A1+D1/HM0
      EPSM=HM0*A1/AM1
      IF (M.GE.M1) GO TO 120
      IF (F11.GE.EPS2) GO TO 71
      F11=EPS2
      N2=2
      AN2=FLOAT(N2)
   71 SIG0=SQRT(F11)
      SIG0=SIG0*SQRT(AN2/(AN2-1.))
      SIG=HM0*SIG0
      SIGL=(SQRT(FLOAT(N)/(2*AL)))*SIG/D1
      IF (L0.EQ.1) GO TO 115
      IF (S1.LT.SIGL) GO TO 120
      L0=1
      GO TO 130
  115 IF (S1.GT.0.5*SIGL) GO TO 130
      L0=2
  120 AN0=AN0+1.
  130 CONTINUE
      A3=(AN0**BETA+2.)*EPSM
      DO 150 I=1,N
      D3=X(I)-DML(I)/A3
      IF (D3.GT.1.) D3=1.
      IF (D3.LT.-1.) D3=-1.
  150  X1(I)=D3
      F8=0.
      F12=0.
      DO 160 I=1,N2
      F=FI1(X1,N,A,B,NIPA)
      F8=F8+F
  160  F12=F12+F*F
      F14=F8
      F8=F8/AN2
      M=M+1
      IF (F8.GT.F1+0.5*SIG0/SQRT(AN2)) GO TO 185
      DO 170 I=1,N
  170 X(I)=X1(I)
      F1=F8
      F13=F14
      AM2=AM2+1.
      F11=(F12/AN2-F1**2)/AM2+F11*(AM2-1.)/AM2
      IF (M.EQ.IT) GO TO 185
      IF (FM.LE.F1) GO TO 176
      FM=F1
      DO 175 I=1,N
  175 XM(I)=X(I)
      IM=M
  176 CONTINUE
      IF (IPRINT.LE.0) GO TO 25
      IF (MOD(M,IPRINT).EQ.0) CALL SPAU36(X,A,B,N,F1,IPRINT)
      GO TO 25
  185 F=FI1(X,N,A,B,NIPA)
      ALF=AN2+AL
      IF (AM2.EQ.1) ALF=FLOAT(2*N)+AL
      F13=F13+F
      F1=F13/ALF
      IF (FM.LE.F1) GO TO 187
      FM=F1
      DO 188 I=1,N
  188 XM(I)=X(I)
      IM=M
  187 CONTINUE
      IF (M.EQ.IT) GO TO 200
      LB=LB+1
      DO 190  I=1,N
  190 DML1(I)=DML(I)
      IF (IPRINT.LE.0) GO TO 200
      IF (MOD(M,IPRINT).EQ.0) CALL SPAU36(X,A,B,N,F1,IPRINT)
  200 CONTINUE
      IF (M.LT.IT)  GO TO 26
      DO 122 I=1,N
      X(I)=((B(I)+A(I))+X(I)*(B(I)-A(I)))/2.
  122  XM(I)=((B(I)+A(I))+XM(I)*(B(I)-A(I)))/2.
      IF (IPRINT.LT.0) RETURN
      IN=1
      CALL SPAU36(X,A,B,N,F1,IPRINT)
      RETURN
      END
      FUNCTION FI1(Z,N,A,B,N3)
      DIMENSION X(100),XE(100),Z(N),A(N),B(N)
      COMMON /STATIS/IFAIL,M,IM,L
      DO 22 I=1,N
   22 X(I)=((B(I)+A(I))+Z(I)*(B(I)-A(I)))/2.
      IF (N3.GT.0.) GO TO 36
      FI1=FI(X,N)
      L=L+1
      RETURN
 36   Y4=0.
      DO 11 I=1,N3
      XE(I)=X(I)
      IF (X(I).LE.A(I)) GO TO 11
      IF (X(I).GE.B(I)) GO TO 10
      IF (X(I).LT.0.) GO TO 10
      X(I)=AINT(X(I))
      GO TO 11
  10  X(I)=AINT(X(I))-1.
  11  CONTINUE
      Y1=FI(X,N)
      DO 12 I=1,N3
      C2=XE(I)-X(I)
      X(I)=X(I)+1.
      Y2=FI(X,N)
      Y=C2*(Y2-Y1)
      Y4=Y+Y4
  12  X(I)=X(I)-1.
      L=L+N3+1
      FI1=Y4+Y1
      RETURN
      END
      SUBROUTINE INWR36(X,A,B,N,F1,IPAR,PAR,IPA,IPAA)
      DIMENSION A(N),B(N),X(N),IPAR(30),PAR(30)
      COMMON /STATIS/IFAIL,M,IM,L/INW/IN
      K=3
      MIP=30
      NOUT=I1MACH(2)
      IF (IN.EQ.1) GO TO 130
      IF (IPA.GE.0.AND.IPA+K.LE.MIP) GO TO 10
      WRITE (NOUT,520) K,MIP
      WRITE (NOUT,510) IPA
    5 IFAIL=10
      RETURN
   10 CONTINUE
      IPRINT=IPAR(IPA+1)
      MN=100
      K1=2
      IF (IPRINT.LT.0) GO TO 15
      WRITE (NOUT,610)
      WRITE (NOUT,620)
      WRITE (NOUT,630) N
   15 IF (N.GT.0.AND.N.LE.MN) GO TO 20
      WRITE (NOUT,500) MN
      IF (IPRINT.LT.0) WRITE (NOUT,630) N
      GO TO 5
   20 CONTINUE
      M=IPAR(IPA+2)
      NIPA=IPAR(IPA+3)
      IF (IPRINT.LT.0) GO TO 40
      WRITE (NOUT,640) IPRINT
      WRITE (NOUT,650) M
      WRITE (NOUT,660) NIPA
   40 IF (M.GT.0) GO TO 50
      WRITE (NOUT,525)
      IF (IPRINT.LT.0) WRITE (NOUT,650) M
      GO TO 5
   50 IF (NIPA.GE.0.AND.NIPA.LE.N) GO TO 60
      WRITE (NOUT,550)
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,630) N
      WRITE (NOUT,660) NIPA
      GO TO 5
   60 IF (IPAA.GE.0.AND.IPAA+K1.LE.MIP) GO TO 70
      WRITE (NOUT,710) K1,MIP
      WRITE (NOUT,700) IPAA
      GO TO 5
   70 IF (IPRINT.LT.0) GO TO 80
      ANIU=PAR(IPAA+1)
      BETA=PAR(IPAA+2)
      WRITE (NOUT,940) ANIU
      WRITE (NOUT,950) BETA
      WRITE (NOUT,570)
      WRITE (NOUT,580) A
      WRITE (NOUT,590)
      WRITE (NOUT,580) B
   80 NER=0
      DO 90 I=1,N
      IF (A(I).LT.B(I)) GO TO 90
      IF (NER.EQ.0) WRITE (NOUT,600) I,I
      IF (NER.NE.0) WRITE (NOUT,605) I,I
      NER=1
   90 CONTINUE
      IF (NER.EQ.0) GO TO 100
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,570)
      WRITE (NOUT,580) A
      WRITE (NOUT,590)
      WRITE (NOUT,580) B
      GO TO 5
  100 IF (IPRINT.LT.0) GO TO 110
      WRITE (NOUT,820)
      WRITE (NOUT,580) X
  110 NER=0
      DO 120 I=1,N
      IF (X(I).LE.B(I).AND.X(I).GE.A(I)) GO TO 120
      WRITE (NOUT,830) I,I,I,I
      NER=1
  120 CONTINUE
      IF (NER.EQ.0) RETURN
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,570)
      WRITE (NOUT,580) A
      WRITE (NOUT,590)
      WRITE (NOUT,580) B
      WRITE (NOUT,820)
      WRITE (NOUT,580) X
      GO TO 5
  130 WRITE (NOUT,850) F1
      RETURN
  500 FORMAT (/2X,63H**E R R O R  I N  L B A Y E S** N LESS THAN 1 OR N
     CGREATER THAN,I4)
  510 FORMAT (/2X,26HNUMBER OF PARAMETERS IPA =,I3)
  520 FORMAT (/2X,47H**E R R O R  I N  L B A Y E S** IPA LESS THAN 0/2X,
     C7HOR IPA+,I2,13H GREATER THAN,I3)
  525 FORMAT (/2X,45H**E R R O R  I N  L B A Y E S** M LESS THAN 1/)
  550 FORMAT (/2X,48H**E R R O R  I N  L B A Y E S** NIPA LESS THAN 0/
     C2X,22HOR NIPA GREATER THAN N)
  570 FORMAT (/2X,32HVECTOR OF LOWER BOUNDS (A) FOR X)
  580 FORMAT (4(2X,E15.8))
  590 FORMAT (2X,32HVECTOR OF UPPER BOUNDS (B) FOR X)
  600 FORMAT (/2X,34H**E R R O R  I N  L B A Y E S** A(,I2,22H) GREATER
     COR EQUALS B(,I2,1H))
  605 FORMAT (34X,2HA(,I2,22H) GREATER OR EQUALS B(,I2,1H))
  610 FORMAT (////12X,11HL B A Y E S)
  620 FORMAT (/2X,22HI N I T I A L  D A T A)
  630 FORMAT (/2X,19HNUMBER OF VARIABLES,12X,3HN =,I6)
  640 FORMAT (/2X,18HPRINTING PARAMETER,11X,5HIPR =,I6)
  650 FORMAT (2X,20HNUMBER OF ITERATIONS,11X,3HM =,I6)
  660 FORMAT (2X,34HNUMBER OF INTEGER VARIABLES NIPA =,I6)
  700 FORMAT (/2X,27HNUMBER OF PARAMETERS IPAA =,I3)
  710 FORMAT (/2X,48H**E R R O R  I N  L B A Y E S** IPAA LESS THAN 0/
     C2X,8HOR IPAA+,I2,13H GREATER THAN,I3)
  820 FORMAT (/2X,14HSTARTING POINT)
  830 FORMAT (/2X,34H**E R R O R  I N  L B A Y E S** X(,I2,17H) GREATER
     CTHAN B(,I2,1H)/2X,5HOR X(,I2,14H) LESS THAN A(,I2,1H))
  850 FORMAT (2X,19HFUNCTION VALUE F = ,E15.8)
  940 FORMAT (/2X,29HRATE OF TRIAL STEP DECREASING,5X,6HANIU =,E15.8)
  950 FORMAT (2X,40HRATE OF ITERATION STEP DECREASING BETA =,E15.8)
      END
      SUBROUTINE SPAU36(X,A,B,N,F,IPR)
      DIMENSION X(N),A(N),B(N),Y(100)
      COMMON /STATIS/IFAIL,IT,IM,L/INW/IN/LAIK/FM,XM(100)
      NOUT=I1MACH(2)
      IF (IN.EQ.1) GO TO 30
      WRITE (NOUT,100)
      IF (IT.EQ.IPR) WRITE (NOUT,210)
      WRITE (NOUT,110) IT
      WRITE (NOUT,120) F
      WRITE (NOUT,140)
      DO 10 I=1,N
   10 Y(I)=((B(I)+A(I))+X(I)*(B(I)-A(I)))/2.
      WRITE (NOUT,130) (Y(I),I=1,N)
      IF (IT.EQ.1) RETURN
      WRITE (NOUT,150) FM,IM
      WRITE (NOUT,160)
      DO 20 I=1,N
   20 Y(I)=((B(I)+A(I))+XM(I)*(B(I)-A(I)))/2.
      WRITE (NOUT,130) (Y(I),I=1,N)
      RETURN
   30 WRITE (NOUT,170)
      WRITE (NOUT,180)
      WRITE (NOUT,230) F
      WRITE (NOUT,220)
      WRITE (NOUT,130) X
      WRITE (NOUT,150) FM,IM
      WRITE (NOUT,160)
      WRITE (NOUT,130) (XM(I),I=1,N)
      WRITE (NOUT,190) L
      WRITE (NOUT,200)
      WRITE (NOUT,170)
      RETURN
  100 FORMAT (/1X,34(2H -))
  110 FORMAT (2X,23HI T E R A T I O N  NR =,I6)
  120 FORMAT (/2X,19HFUNCTION VALUE F = ,E15.8)
  130 FORMAT (4(2X,E15.8))
  140 FORMAT (2X,13HCURRENT POINT)
  150 FORMAT (/2X,28HOPTIMAL FUNCTION VALUE FM = ,E15.8,17H OBTAINED IN
     CNR =,I6)
  160 FORMAT (2X,13HOPTIMAL POINT)
  170 FORMAT (/1X,34(2H *)/1X,34(2H *))
  180 FORMAT (/2X,13HR E S U L T S)
  190 FORMAT (/2X,34HNUMBER OF FUNCTION EVALUATIONS L =,I6)
  200 FORMAT (7X,17HLBAYES TERMINATED)
  210 FORMAT (1X,34(2H -))
  220 FORMAT (2X,10HLAST POINT)
  230 FORMAT (/2X,24HLAST FUNCTION VALUE F = ,E15.8)
      END

      program ex
      dimension x(2),a(2),b(2),ipar(30),par(30)
      data n,nm,ipa,ipaa/2,400,0,0/,a/-0.25,-0.125/,b/0.5,0.625/
      data ipar/0,100,6,2,1,25*0/
      data par/0.01,0.01,0.01,27*0./
      call exkor(x,a,b,n,fm,ipar,par,ipa,ipaa)
      stop
      end
      function fi(x,n)
      dimension x(n)
      fi=furasn(x,n)
      return
      end

      program ex
      dimension x(2),a(2),b(2),xn(200),hes(3),ipar(30),par(30),h(2,2),
     *q(2,2),gc(100,2)
      data n,nm,nh,ipa,ipaa/2,200,3,0,0/,a/-0.25,-0125/,b/0.5,0.625/
      data ipar/1,5,5,1,100,2,100,0,5,0,0,50,1,3,0,50,1,3,0,40,30,5,
     *0,1000,10,0,50,100,2*0/
      data par/100.,3*1.e-4,0.05,0.9,0.3,1.e-5,1.,0.25,2*1.e-4,18*0./
      write(*,1)
c     read(*,2) ipar(1),ipar(2),ipar(3),a(1),b(1),a(2),b(2),ipar(9)
    2 format(3i5,4f7.2,i5)
    1 format('i1=  ,i2= ,i3= ,a1=.  ,b1=.  ,a2=.  ,b2=.  ,i9= ,')
      call bayes1(x,a,b,n,xn,nm,fm,ipar,ipa)
      ipa=3
c     call mivar402(x,a,b,n,hes,nh,fm,ipar,par,ipa,ipaa)
      ipa=7
      ipaa=4
      call lbayes(x,a,b,n,f,ipar,par,ipa,ipaa)
      ipa=10
      ipaa=6
      call flexi(x,n,fm,ipar,par,ipa,ipaa)
      ipa=14
      ipaa=8
      call reqp(x,h,q,g,n,fm,ipar,par,ipa,ipaa)
c     write(*,3) x(1),x(2)
    3 format(2f5.2)
c     ipa=14
c     ipaa=10
c     call flexi(x,n,fm,ipar,par,ipa,ipaa)
      ipa=18
      ipaa=12
      call unt(x,a,b,n,xn,nm,fm,ipar,ipa)
      ipa=22
      call glopt(x,a,b,n,fm,ipar,ipa)
      ipa=25
      call lpmin(x,a,b,n,xn,nm,fm,ipar,ipa)
      stop
      end
      function fi2(x,n)
      dimension x(n)
      fi2=furasn(x,n)
      return
      end
      function fi(x,n)
      dimension x(n)
      fi=x(1)**3-12*x(1)*x(2)+8*x(2)**3
      return
      end
      subroutine constr(x,n,g,m)
      dimension x(n),g(m)
      g(1)=x(1)+1.
      g(2)=x(2)+1.
      g(3)=1.-x(1)
      g(4)=1.-x(2)
      return
      end

      SUBROUTINE FLEXI(Z,M1,FF,IPAR,PAR,IPA,IPAA)
C     NX      TOTAL NUMBER OF INDEPENDENT VARIABLES
C     NC      TOTAL NUMBER OF EQUALITY CONSTRAINTS
C     NIC     TOTAL NUMBER OF INEQUALITY CONSTRAINTS
C     SIZE    EDGE LENGHT OF THE INITIAL POLYHEDRON
C     CONVER  CONVERGENCE CRITERION FOR TERMINATION OF THE SEARCH
C     ALFA    THE REFLECTION COEFFICIENT
C     BETA    THE CONTRACTION COEFFICIENT
C     GAMA    THE EXPANSION COEFFICIENT
C     X(I)    THE ASSUMED VECTOR TO INITIATE THE SEARCH
C     FDIFER  THE TOLERANCE CRITERION FOR CONSTRAINT VIOLATION
C     ICONT   A COUNTER TO RECORD STAGE COMPUTATIONS
C     NCONT   A COUNTER TO PRINT INFORMATION EVERY (NX+1) STAGE
C     LOW     AN INDEX TO IDENTIFY INFORMATION RELATED TO THE LOWEST
C	      VALUE OF OBJ. FUNCTION IN MOST RECENT POLYHEDRON
C     LHIGH   AN INDEX TO IDENTIFY INFORMATION RELATED TO LARGEST VALUE
C	      OF OBJ. FUNCTION IN MOST RECENT POLYHEDRON
C     LSEC    AN INDEX TO IDENTIFY INFORMATION RELATED TO THE SECOND
C     LARGEST VALUE OF OBJ. FUNCTION IN MOST RECENT POLYHEDRON
      COMMON /U/NX,X(20)/V/STEP,K1,X1(29,20)/C/NC,NIC,R(100)
     1/D/K6,K7,K9/E/IN,K8,SEQL,SUM(29)/T/K2,K3,K4,INF,L5,
     2L6,L7,L8,L9,FDIFER,R1A,R2A,R3A,FOLD,SR(24),X2(24,20)
      COMMON /STATIS/IFAIL,ICONT,ITMIN,NF
      DIMENSION F(24)
      DIMENSION CMI(100)
      DIMENSION IPAR(30),PAR(30)
       DIMENSION Z(M1)
      NX=M1
      IFAIL=0
      CALL INWR32(Z,NX,FF,IPAR,PAR,IPA,IPAA)
      IF (IFAIL.EQ.10) RETURN
      IPRINT=IPAR(IPA+1)
      NFMAX=IPAR(IPA+2)
      NC=IPAR(IPA+3)
      NF=0
      NIC=IPAR(IPA+4)
      SIZE=PAR(IPAA+1)
      CONVER=PAR(IPAA+2)
      ALFA=1.
      DO 2005 I=1,NX
 2005 X(I) = Z(I)
      BETA=0.5
      GAMA=2.
       STEP=SIZE
      K1=NX+1
      K2=NX+2
      K3=NX+3
      K4=NX+4
      K5=NX+5
      K6=NC+NIC
      K7=NC+1
      K8=NC+NIC
      K9=K8+1
      N=NX-NC
      N1=N+1
      IF(N1.GE.3) GO TO 50
      N1=3
      N=2
   50 N2=N+2
      N3=N+3
      N4=N+4
      N5=N+5
      N6=N+6
      N7=N+7
      N8=N+8
      XN=FLOAT(N)
      XNX=FLOAT(NX)
      XN1=FLOAT(N1)
      R1A=0.5*(SQRT(5.)-1.)
      R2A=R1A*R1A
      R3A=R2A*R1A
      L5=NX+5
      L6=NX+6
      L7=NX+7
      L8=NX+8
      L9=NX+9
      ICONT=1
      NCONT=1
      FDIFER=2.*FLOAT(NC+1)*STEP
      FOLD=FDIFER
      IN=N1
      CALL SUMR
      SR(N1)=SQRT(SEQL)
      RK9=FI(X,NX)
      NF=NF+1
      FF=RK9
      INW1=1
      IF (IPRINT.GE.0) CALL SPAU32(INW1,ICONT,RK9,IPRINT)
      IF (SR(N1).LT.FDIFER) GO TO 2003
      INF=N1
      STEP=0.05*FDIFER
      CALL FEASBL
      IF (FOLD.GE.1.E-09) GO TO 341
      IFAIL=10
      ITMIN=0
      CALL INWR32(Z,NX,FF,IPAR,PAR,IPA,IPAA)
      RETURN
  341 INW1=2
      CALL SUMR
      RK9=FI(X,NX)
      NF=NF+1
      IF (IPRINT.GE.0) CALL SPAU32(INW1,ICONT,RK9,IPRINT)
 2003 CONTINUE
      FTER=RK9
      RMIN=RK9
      IF (K8.EQ.0) GO TO 3010
      DO 2040 I=1,K8
 2040 CMI(I)=R(I)
 3010 CONTINUE
      COMIN=SEQL
      DO 2070 I=1,NX
 2070 Z(I)=X(I)
C     COMPUTE CENTROID OF ALL VERTICES OF INITIAL POLYHEDRON
  237 STEP1=STEP*(SQRT(XNX+1.)+XNX-1.)/(XNX*SQRT(2.))
      STEP2=STEP*(SQRT(XNX+1.)-1.)/(XNX*SQRT(2.))
      ETA=(STEP1+(XNX-1.)*STEP2)/(XNX+1.)
      DO 4 J=1,NX
      X(J)=X(J)-ETA
    4 CONTINUE
      CALL START
      DO 9 I=1,N1
      DO 9 J=1,NX
      X2(I,J)=X1(I,J)
    9 CONTINUE
      DO 5 I=1,N1
      IN=I
      DO 6 J=1,NX
    6 X(J)=X2(I,J)
      CALL SUMR
      SR(I)=SQRT(SEQL)
      IF(SR(I).LT.FDIFER) GO TO 8
      CALL FEASBL
      IF(FOLD.LT.1.E-09) GO TO 80
    8 F(I)=FI(X,NX)
      NF=NF+1
    5 CONTINUE
 1000 STEP=0.05*FDIFER
      ICONT=ICONT+1
C  SELECT LARGEST VALUE OF OBJECTIVE FUNCTION FROM POLYHEDRON VERTICES
      FH=F(1)
      LHIGH=1
      DO 16 I=2,N1
      IF(F(I).LT.FH) GO TO 16
      FH=F(I)
      LHIGH=I
   16  CONTINUE
C   SELECT MINIMUM VALUE OF OBJECTIVE FUNCTION FROM POLYHEDRON VERTICES
   41 FL=F(1)
      LOW=1
      DO 17 I=2,N1
      IF(FL.LT.F(I)) GO TO 17
      FL=F(I)
      LOW=I
   17 CONTINUE
      DO 86 J=1,NX
   86 X(J)=X2(LOW,J)
      IN=LOW
      CALL SUMR
      SR(LOW)=SQRT(SEQL)
      IF(SR(LOW).LT.FDIFER) GO TO 87
      INF=LOW
      CALL FEASBL
      IF(FOLD.LT.1.E-09) GO TO 80
      F(LOW)=FI(X,NX)
      NF=NF+1
      GO TO 41
   87 CONTINUE
C     FIND CENTROID OF POINTS WITH I DIFFERENT THAN LHIGH
      DO 19 J=1,NX
      SUM2=0.
      DO 20 I=1,N1
   20 SUM2=SUM2+X2(I,J)
   19 X2(N2,J)=1./XN*(SUM2-X2(LHIGH,J))
      SUM2=0.
      DO 36 I=1,N1
      DO 36 J=1,NX
      SUM2=SUM2+(X2(I,J)-X2(N2,J))**2
   36 CONTINUE
      FDIFER=FLOAT(NC+1)/XN1*SQRT(SUM2)
      IF(FDIFER.LT.FOLD) GO TO 98
      FDIFER=FOLD
      GO TO 198
   98 FOLD=FDIFER
  198 CONTINUE
      FTER=F(LOW)
  137 NCONT=NCONT+1
      IF (NCONT.LT.4*N1) GO TO 337
      NCONT=1
      IF (ICONT.LT.1500) GO TO 337
      FOLD=0.5*FOLD
  337 INW1=3
      ITMIN=ICONT
      RK9=F(LOW)
      IF (COMIN.GT.SEQL.OR.RMIN.GE.RK9) GO TO 2020
      RK9=RMIN
      DO 2030 I=1,NX
 2030 X(I)=Z(I)
      IF (K8.EQ.0) GO TO 3020
      DO 2050 I=1,K8
 2050 R(I)=CMI(I)
 3020 CONTINUE
      ITMIN=0
 2020 CONTINUE
      IF (NF.LT.NFMAX) GO TO 2060
      IFAIL=2
      GO TO 81
 2060 CONTINUE
      IF (IPRINT.LE.0) GO TO 37
      IF (MOD(ICONT,IPRINT).EQ.0) CALL SPAU32(INW1,ICONT,RK9,IPRINT)
   37 IF (FDIFER.LT.CONVER) GO TO 81
C  SELECT SECOND LARGEST VALUE OF OBJECTIVE FUNCTION
      IF(LHIGH.EQ.1) GO TO 43
      FS=F(1)
      LSEC=1
      GO TO 44
   43 FS=F(2)
      LSEC=2
   44 DO 18 I=1,N1
       IF(LHIGH.EQ.I) GO TO 18
      IF(F(I).LT.FS) GO TO 18
      FS=F(I)
      LSEC=I
   18 CONTINUE
C     REFLECT HIGH POINT THROUGH CENTROID
      DO 61 J=1,NX
      X2(N3,J)=X2(N2,J)+ALFA*(X2(N2,J)-X2(LHIGH,J))
   61 X(J)=X2(N3,J)
      IN=N3
      CALL SUMR
      SR(N3)=SQRT(SEQL)
   89 IF(SR(N3).LT.FDIFER) GO TO 82
      INF=N3
      CALL FEASBL
      IF(FOLD.LT.1.E-09) GO TO 80
   82 F(N3)=FI(X,NX)
      NF=NF+1
      IF(F(N3).LT.F(LOW)) GO TO 84
      IF(F(N3).LT.F(LSEC)) GO TO 92
      GO TO 60
   92 DO 93 J=1,NX
   93 X2(LHIGH,J)=X2(N3,J)
      SR(LHIGH)=SR(N3)
      F(LHIGH)=F(N3)
      GO TO 1000
C   EXPAND VECTOR OF SEARCH ALONG DIRECTION THROUGH CENTROID AND
C     REFLECTED VECTOR
   84 DO 23 J=1,NX
      X2(N4,J)=X2(N3,J)+GAMA*(X2(N3,J)-X2(N2,J))
   23 X(J)=X2(N4,J)
      IN=N4
      CALL SUMR
      SR(N4)=SQRT(SEQL)
      IF(SR(N4).LT.FDIFER) GO TO 25
      INF=N4
      CALL FEASBL
      IF(FOLD.LT.1.E-09) GO TO 80
   25 F(N4)=FI(X,NX)
      NF=NF+1
      IF(F(LOW).LT.F(N4)) GO TO 92
      DO 26 J=1,NX
   26 X2(LHIGH,J)=X2(N4,J)
      F(LHIGH)=F(N4)
      SR(LHIGH)=SR(N4)
      GO TO 1000
   60 IF(F(N3).GT.F(LHIGH)) GO TO 64
      DO 65 J=1,NX
   65 X2(LHIGH,J)=X2(N3,J)
   64 DO 66 J=1,NX
      X2(N4,J)=BETA*X2(LHIGH,J)+(1.-BETA)*X2(N2,J)
   66 X(J)=X2(N4,J)
      IN=N4
      CALL SUMR
      SR(N4)=SQRT(SEQL)
      IF(SR(N4).LT.FDIFER) GO TO 67
      INF=N4
      CALL FEASBL
      IF(FOLD.LT.1.E-09) GO TO 80
   67 F(N4)=FI(X,NX)
      NF=NF+1
      IF(F(LHIGH).GT.F(N4)) GO TO 68
      DO 69 J=1,NX
      DO 69 I=1,N1
   69 X2(I,J)=0.5*(X2(I,J)+X2(LOW,J))
      DO 70 I=1,N1
      DO 71 J=1,NX
   71 X(J)=X2(I,J)
      IN=I
      CALL SUMR
      SR(I)=SQRT(SEQL)
      IF(SR(I).LT.FDIFER) GO TO 72
      INF=I
      CALL FEASBL
      IF(FOLD.LT.1.E-09) GO TO 80
   72 F(I)=FI(X,NX)
   70 NF=NF+1
      GO TO 1000
   68 DO 73 J=1,NX
   73 X2(LHIGH,J)=X2(N4,J)
      SR(LHIGH)=SR(N4)
      F(LHIGH)=F(N4)
      GO TO 1000
   80 IFAIL=1
      RK9=FI(X,NX)
      NF=NF+1
      IF (K8.NE.0) CALL CONSTR(X,NX,R,K8)
      ITMIN=ICONT
   81 CONTINUE
      DO 3000 I=1,NX
 3000 Z(I) = X(I)
      FF=RK9
      INW1=4
      IF (IPRINT.GE.0) CALL SPAU32(INW1,ICONT,RK9,IPRINT)
      RETURN
      END
      SUBROUTINE FEASBL
C*****SUBROUTINE FEASBL MINIMIZES THE SUM OF THE SQUARE VALUES OF THE
C     VIOLATED CONSTRAINTS. IT IS CALLED EVERY TIME THE COMBINED VALUE
C     OF THE VIOLATED CONSTRAINTS EXCEEDS THE THE VALUE OF THE TOLERANCE
C     CRITERION FOR THE CURRENT STAGE
      COMMON /U/NX,X(20)/V/STEP,K1,X1(29,20)/C/NC,NIC,R(100)
     1/D/K6,K7,K9/E/IN,K8,SEQL,SUM(29)/T/K2,K3,K4,INF,L5,
     2 L6,L7,L8,L9,FDIFER,R1A,R2A,R3A,FOLD,SR(24),X2(24,20)
     3/STATIS/IFAIL,IT,ITM,NF
      DIMENSION R1(100),R3(100),FLG(3),H(20)
      ALFA=1.
      BETA=0.5
      GAMA=2.
      XNX=FLOAT(NX)
      ICONT=0
      LCHEK=0
      ICHEK=0
   25 CALL START
      DO 3 I=1,K1
      DO 4 J=1,NX
    4 X(J)=X1(I,J)
      IN=I
      CALL SUMR
    3 CONTINUE
C  SELECT LARGEST VALUE OF SUM(I) IN SIMPLEX
   28 SUMH=SUM(1)
      INDEX=1
      DO 7 I=2,K1
      IF(SUM(I).LE.SUMH) GO TO 7
      SUMH=SUM(I)
      INDEX=I
    7 CONTINUE
C  SELECT MINIMUM VALUE OF SUM(I) IN SIMPLEX
      SUML=SUM(1)
      KOUNT=1
      DO 8 I=2,K1
      IF(SUML.LE.SUM(I)) GO TO 8
      SUML=SUM(I)
      KOUNT=I
    8 CONTINUE
C  FIND CENTROID OF POINTS WITH I DIFFERENT THAN INDEX
      DO 9 J=1,NX
      SUM2=0.
      DO 10 I=1,K1
   10 SUM2=SUM2+X1(I,J)
      X1(K2,J)=1./XNX*(SUM2-X1(INDEX,J))
C  FIND REFLECTION OF HIGH POINT THROUGH CENTROID
      X1(K3,J)=2.*X1(K2,J)-X1(INDEX,J)
    9 X(J)=X1(K3,J)
      IN=K3
      CALL SUMR
      IF(SUM(K3).LT.SUML) GO TO 11
C  SELECT SECOND LARGEST VALUE IN SIMPLEX
      IF(INDEX.EQ.1) GO TO 38
      SUMS=SUM(1)
      GO TO 39
   38 SUMS=SUM(2)
   39 DO 12 I=1,K1
      IF((INDEX-I).EQ.0) GO TO 12
      IF(SUM(I).LE.SUMS) GO TO 12
      SUMS=SUM(I)
   12 CONTINUE
      IF(SUM(K3).GE.SUMS) GO TO 13
      GO TO 14
C  FORM EXPANSION OF NFW MINIMUM IF REFLECTION HAS PRODUCED ONE MINIMUM
   11 DO 15 J=1,NX
      X1(K4,J)=X1(K2,J)+2.*(X1(K3,J)-X1(K2,J))
   15 X(J)=X1(K4,J)
      IN=K4
      CALL SUMR
      IF(SUM(K4).LT.SUML) GO TO 16
      GO TO 14
   13 IF(SUM(K3).GT.SUMH) GO TO 17
      DO 18 J=1,NX
   18 X1(INDEX,J)=X1(K3,J)
   17 DO 19 J=1,NX
      X1(K4,J)=0.5*X1(INDEX,J)+0.5*X1(K2,J)
   19 X(J)=X1(K4,J)
      IN=K4
      CALL SUMR
      IF(SUMH.GT.SUM(K4)) GO TO 6
C  REDUCE SIMPLEX BY HALF IF REFLECTION HAPPENS TO PRODUCE A LARGER VALL
C  UE THAH THE MAXIMUM
      DO 20 J=1,NX
      DO 20 I=1,K1
   20 X1(I,J)=0.5*(X1(I,J)+X1(KOUNT,J))
      DO 29 I=1,K1
      DO 30 J=1,NX
   30 X(J)=X1(I,J)
      IN=I
      CALL SUMR
   29 CONTINUE
    5 SUML=SUM(1)
      KOUNT=1
      DO 23 I=2,K1
      IF(SUML.LT.SUM(I)) GO TO 23
      SUML=SUM(I)
      KOUNT=I
   23 CONTINUE
      SR(INF)=SQRT(SUM(KOUNT))
      DO 27 J=1,NX
   27 X(J)=X1(KOUNT,J)
      GO TO 26
    6 DO 31 J=1,NX
   31 X1(INDEX,J)=X1(K4,J)
      SUM(INDEX)=SUM(K4)
      GO TO 5
   16  DO 21 J=1,NX
      X1(INDEX,J)=X1(K4,J)
   21 X(J)=X1(INDEX,J)
      SUM(INDEX)=SUM(K4)
      SR(INF)=SQRT(SUM(K4))
      GO TO 26
   14 DO 22 J=1,NX
      X1(INDEX,J)=X1(K3,J)
   22 X(J)=X1(INDEX,J)
      SUM(INDEX)=SUM(K3)
      SR(INF)=SQRT(SUM(K3))
   26 ICONT=ICONT+1
      DO 36 J=1,NX
   36 X2(INF,J)=X(J)
      IF(ICONT.LT.2*K1) GO TO 50
      ICONT=0
      DO 24 J=1,NX
   24 X(J)=X1(K2,J)
      IN=K2
      CALL SUMR
      DIFER=0.
      DO 57 I=1,K1
   57 DIFER=DIFER+(SUM(I)-SUM(K2))**2
      DIFER=1./(FLOAT(K7)*XNX)*SQRT(DIFER)
      IF (DIFER.LE.1.E-7 ) GO TO 51
      XABS=0.
      DO 110 J=1,NX
      D1=0.
      DO 111 I=1,K1
  111 D1=D1+ABS(X1(I,J)-X1(K2,J))
  110 XABS=XABS+D1/(ABS(X1(K2,J))+1.E-7)
      XABS=XABS/(XNX*FLOAT(K1))
      IF (XABS.GT.1.E-6) GO TO 50
C     IF FLEXIBLE SIMPLEX METHOD FAILED TO SATISFY THE CONSTRAINTS WITHI
C     N THE TOLERANCE CRITERION FOR THE CURRENT STAGE, THE SEARCH IS
C     PERTURBED FROM THE POSITION WHERE X VECTOR IS STUCK AND THEN
C     FEASBL IS REPEATED ONCE MORE FROM THE BEGINNING
   51 IN=K1
      STEP=20.*FDIFER
      CALL SUMR
      SR(INF)=SQRT(SEQL)
      DO 52 J=1,NX
   52 X1(K1,J)=X(J)
      DO 53 J=1,NX
      FACTOR=1.
      X(J)=X1(K1,J)+FACTOR*STEP
      X1(L9,J)=X(J)
      IN=L9
      CALL SUMR
      X(J)=X1(K1,J)-FACTOR*STEP
      X1(L5,J)=X(J)
      IN=L5
      CALL SUMR
   56 IF(SUM(L9).LT.SUM(K1)) GO TO 54
      IF(SUM(L5).LT.SUM(K1)) GO TO 55
      GO TO 97
   54 X1(L5,J)=X1(K1,J)
      SUM(L5)=SUM(K1)
      X1(K1,J)=X1(L9,J)
      SUM(K1)=SUM(L9)
      FACTOR=FACTOR+1.
      X(J)=X1(K1,J)+FACTOR*STEP
      IN=L9
      CALL SUMR
      GO TO 56
   55 X1(L9,J)=X1(K1,J)
      SUM(L9)=SUM(K1)
      X1(K1,J)=X1(L5,J)
      SUM(K1)=SUM(L5)
      FACTOR=FACTOR+1.
      X(J)=X1(K1,J)-FACTOR*STEP
      IN=L5
      CALL SUMR
      GO TO 56
C     ONE DIMENSIONAL SEARCH BY GOLDEN SECTION ALONG EACH COORDINATE
   97 H(J)=X1(L9,J)-X1(L5,J)
      IF (ABS(H(J))/AMAX1(ABS(X1(L9,J)),ABS(X1(L5,J))).LE.1.E-6)
     CGO TO 750
      X1(L6,J)=X1(L5,J)+H(J)*R1A
      X(J)=X1(L6,J)
      IN=L6
      CALL SUMR
      X1(L7,J)=X1(L5,J)+H(J)*R2A
      X(J)=X1(L7,J)
      IN=L7
      CALL SUMR
      IF(SUM(L6).GT.SUM(L7)) GO TO 68
      X1(L8,J)=X1(L5,J)+(1.-R3A)*H(J)
      X1(L5,J)=X1(L7,J)
      X(J)=X1(L8,J)
      IN=L8
      CALL SUMR
      IF(SUM(L8).GT.SUM(L6)) GO TO 76
      X1(L5,J)=X1(L6,J)
      SUM(L5)=SUM(L6)
      GO TO 75
   76 X1(L9,J)=X1(L8,J)
      SUM(L9)=SUM(L8)
      GO TO 75
   68 X1(L9,J)=X1(L6,J)
      X1(L8,J)=X1(L5,J)+R3A*H(J)
      X(J)=X1(L8,J)
      IN=L8
      CALL SUMR
      SUM(L9)=SUM(L6)
      IF(SUM(L7).GT.SUM(L8)) GO TO 71
      X1(L5,J)=X1(L8,J)
      SUM(L5)=SUM(L8)
      GO TO 75
   71 X1(L9,J)=X1(L7,J)
      SUM(L9)=SUM(L7)
   75 IF(ABS(X1(L9,J)-X1(L5,J)).GT.0.01*FDIFER) GO TO 97
  750 CONTINUE
      X1(K1,J)=X1(L7,J)
      X(J)=X1(L7,J)
      SUM(K1)=SUM(L5)
      SR(INF)=SQRT(SUM(K1))
      IF(SR(INF).LT.FDIFER) GO TO 760
   53 CONTINUE
      ICHEK=ICHEK+1
      STEP=FDIFER
      IF(ICHEK.LE.2) GO TO 25
      FOLD=1.E-10
      GO TO 46
  760 DO 761 J=1,NX
      X2(INF,J)=X1(K1,J)
  761 X(J)=X1(K1,J)
   50 IF(SR(INF).GT.FDIFER) GO TO 28
C  MODIFIED LAGRANGE INTERPOLATION FOR TIGHT INEQUALITIES
      IF(SR(INF).GT.0.)GO TO 35
      FINT=FI(X,NX)
      NF=NF+1
      DO 139 J=1,NX
  139 X(J)=X2(INF,J)
      CALL CONSTR(X,NX,R,K8)
      DO 40 J=K7,K8
   40 R1(J)=R(J)
      DO 41 J=1,NX
   41 X(J)=X1(KOUNT,J)
      CALL CONSTR(X,NX,R,K8)
      DO 42 J=K7,K8
   42 R3(J)=R(J)
      DO 43 J=1,NX
      H(J)=X1(KOUNT,J)-X2(INF,J)
   43 X(J)=X2(INF,J)+0.5*H(J)
      CALL CONSTR(X,NX,R,K8)
      FLG(1)=0.
      FLG(2)=0.
      FLG(3)=0.
      DO 44 J=K7,K8
      IF(R3(J).GE.0.) GO TO 44
      FLG(1)=FLG(1)+R1(J)*R1(J)
      FLG(2)=FLG(2)+R(J)*R(J)
      FLG(3)=FLG(3)+R3(J)*R3(J)
   44 CONTINUE
      SR(INF)=SQRT(FLG(1))
      IF(SR(INF).LT.FDIFER) GO TO 35
      ALFA1=FLG(1)-2.*FLG(2)+FLG(3)
      BETA1=3.*FLG(1)-4.*FLG(2)+FLG(3)
      RATIO=BETA1/(4.*ALFA1)
      DO 45 J=1,NX
   45 X(J)=X2(INF,J)+H(J)*RATIO
      IN=INF
      CALL SUMR
      SR(INF)=SQRT(SEQL)
      IF(SR(INF).LT.FDIFER) GO TO 465
      DO 49 I=1,20
      DO 48 J=1,NX
   48 X(J)=X(J)-0.05*H(J)
      CALL SUMR
      SR(INF)=SQRT(SEQL)
      IF(SR(INF).LT.FDIFER) GO TO 465
   49 CONTINUE
  465 RK9=FI(X,NX)
      NF=NF+1
      IF (FINT.GT.RK9) GO TO 46
      SR(INF)=0.
      GO TO 35
   46 DO 47 J=1,NX
   47 X2(INF,J)=X(J)
   35 CONTINUE
      DO 335 J=1,NX
  335 X(J)=X2(INF,J)
      RETURN
      END
      SUBROUTINE START
      COMMON /U/NX,X(20)/V/STEP,K1,X1(29,20)
      DIMENSION A(21,20)
      VN=FLOAT(NX)
      STEP1=STEP/(VN*SQRT(2.))*(SQRT(VN+1.)+VN-1.)
      STEP2=STEP/(VN*SQRT(2.))*(SQRT(VN+1.)-1.)
      DO 1 J=1,NX
    1 A(1,J)=0.
      DO 2 I=2,K1
      DO 4 J=1,NX
    4 A(I,J)=STEP2
      L=I-1
      A(I,L)=STEP1
    2 CONTINUE
      DO 3 I=1,K1
      DO 3 J=1,NX
    3 X1(I,J)=X(J)+A(I,J)
      RETURN
      END
      SUBROUTINE SUMR
C*****THIS SUBROUTINE COMPUTES THE SUM OF THE SQUARE VALUES OF THE
C     VIOLATED CONSTRAINTS IN ORDER TO BE COMPARED WITH THE TOLERANCE
C     CRITERION
      COMMON /U/NX,X(20)/C/NC,NIC,R(100)/D/K6,
     1K7,K9/E/IN,K8,SEQL,SUM(29)
      SUM(IN)=0.
      SEQL=0.
      IF (K8.EQ.0) GO TO 3
      CALL CONSTR(X,NX,R,K8)
      IF(NIC.EQ.0) GO TO 4
      DO 1 J=K7,K8
      IF(R(J).GE.0.) GO TO 1
      SEQL=SEQL+R(J)*R(J)
    1 CONTINUE
    4 IF(NC.EQ.0) GO TO 3
      DO 2 J=1,NC
    2 SEQL=SEQL+R(J)*R(J)
    3 SUM(IN)=SEQL
    5 RETURN
      END
      SUBROUTINE SPAU32(IN,ICONT,RK9,IPR)
      COMMON /C/NC,NIC,R(100)/D/K6,K7,K9/U/NX,X(20)
     1/STATIS/IFAIL,IT,ITM,NF
      NOUT=I1MACH(2)
      GO TO (10,50,60,70),IN
   10 WRITE (NOUT,320) RK9
   20 IF (K6.EQ.0) GO TO 30
      WRITE (NOUT,330)
      WRITE (NOUT,130) (R(J),J=1,K6)
   30 RETURN
   50 WRITE (NOUT,350)
      WRITE (NOUT,380)
      WRITE (NOUT,130) (X(J),J=1,NX)
      GO TO 10
   60 CONTINUE
      WRITE (NOUT,100)
      IF (ICONT.EQ.IPR) WRITE (NOUT,210)
      WRITE (NOUT,110) ICONT
      WRITE (NOUT,120) RK9
      WRITE (NOUT,140)
      WRITE (NOUT,130) (X(J),J=1,NX)
      GO TO 20
   70 WRITE (NOUT,170)
      WRITE (NOUT,180)
      WRITE (NOUT,150) RK9
      WRITE (NOUT,160)
      WRITE (NOUT,130) (X(I),I=1,NX)
      IF (NC.EQ.0.AND.NIC.EQ.0) GO TO 90
      WRITE (NOUT,330)
      WRITE (NOUT,130) (R(J),J=1,K6)
   90 WRITE (NOUT,390) NF,ICONT
      IF (IFAIL.EQ.0) WRITE (NOUT,400)
      IF (IFAIL.EQ.2) WRITE (NOUT,360)
      IF (IFAIL.EQ.1) WRITE (NOUT,410)
      WRITE (NOUT,370)
      WRITE (NOUT,170)
      RETURN
  100 FORMAT (/1X,34(2H -))
  110 FORMAT (2X,23HI T E R A T I O N  NR =,I6)
  120 FORMAT (/2X,19HFUNCTION VALUE F = ,E15.8)
  130 FORMAT(4(2X,E15.8))
  140 FORMAT (2X,13HCURRENT POINT)
  150 FORMAT (/2X,28HOPTIMAL FUNCTION VALUE FM = ,E15.8)
  160 FORMAT(2X,13HOPTIMAL POINT)
  170 FORMAT (/1X,34(2H *)/1X,34(2H *))
  180 FORMAT (/2X,13HR E S U L T S)
  210 FORMAT (1X,34(2H -))
  320 FORMAT (2X,19HFUNCTION VALUE F = ,E15.8)
  330 FORMAT (2X,11HCONSTRAINTS)
  350 FORMAT (/2X,27HSTARTING POINT - INFEASIBLE)
  360 FORMAT (/2X,52HIFAIL = 2. TERMINATION CRITERION: NUMBER OF FUNCTIO
     CN/2X,26HEVALUATIONS EXCEEDED LIMIT)
  370 FORMAT (/7X,16HFLEXI TERMINATED)
  380 FORMAT (2X,34HCALCULATED FEASIBLE STARTING POINT)
  390 FORMAT (/2X,34HNUMBER OF FUNCTION EVALUATIONS L =,I6/2X,
     C25HNUMBER OF ITERATIONS NR =,I6)
  400 FORMAT (/2X,66HIFAIL = 0. TERMINATION CRITERION:TOLERANCE CRITERIO
     CN LESS THAN EPS)
  410 FORMAT (/2X,58HIFAIL = 1. TERMINATION CRITERION: CONSTRAINTS ARE V
     CIOLATED/2X,29HMORE THAN TOLERANCE CRITERION)
      END
      SUBROUTINE INWR32(X,N,FM,IPAR,PAR,IPA,IPAA)
      COMMON /STATIS/IFAIL,ICT,ICTM,NF
      DIMENSION IPAR(30),PAR(30),X(N)
      MN=20
      MIP=30
      MAP=100
      K=4
      K1=2
      NOUT=I1MACH(2)
      IPRINT=IPAR(IPA+1)
      IF (IFAIL.EQ.10) GO TO 300
      IF (IPA.GE.0.AND.IPA+K.LE.MIP) GO TO 10
      WRITE (NOUT,520) K,MIP
      WRITE (NOUT,510) IPA
    5 IFAIL=10
      RETURN
   10 CONTINUE
      IF (IPRINT.LT.0) GO TO 110
      WRITE (NOUT,860)
      WRITE (NOUT,620)
      WRITE (NOUT,630) N
  110 IF (N.GT.0.AND.N.LE.MN) GO TO 20
      WRITE (NOUT,500) MN
      IF (IPRINT.LT.0) WRITE (NOUT,630) N
      GO TO 5
   20 CONTINUE
      M=IPAR(IPA+2)
      NC=IPAR(IPA+3)
      NIC=IPAR(IPA+4)
      IF (IPRINT.LT.0) GO TO 30
      WRITE (NOUT,640) IPRINT
      WRITE (NOUT,650) M
      WRITE (NOUT,870) NC
      WRITE (NOUT,890) NIC
   30 IF (M.GE.0) GO TO 40
      WRITE (NOUT,525)
      IF (IPRINT.LT.0) WRITE (NOUT,650) M
      GO TO 5
   40 IF (NC.GE.0) GO TO 50
      WRITE (NOUT,900)
      IF (IPRINT.LT.0) WRITE (NOUT,870) NC
      GO TO 5
   50 IF (NIC.GE.0) GO TO 70
      WRITE (NOUT,910)
      IF (IPRINT.LT.0) WRITE (NOUT,890) NIC
      GO TO 5
   70 IF (NC+NIC.LE.MAP) GO TO 120
      WRITE (NOUT,930) MAP
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,870) NC
      WRITE (NOUT,890) NIC
      GO TO 5
  120 CONTINUE
      IF (IPAA.GE.0.AND.IPAA+K1.LE.MIP) GO TO 240
      WRITE (NOUT,710) K1,MIP
      WRITE (NOUT,700) IPAA
      GO TO 5
  240 CONTINUE
      IF (IPRINT.LT.0) GO TO 250
      DELTA=PAR(IPAA+1)
      EPS=PAR(IPAA+2)
      WRITE (NOUT,940) DELTA
      WRITE (NOUT,950) EPS
  250 CONTINUE
  255 IF (IPRINT.LT.0) GO TO 260
  256 CONTINUE
      WRITE (NOUT,820)
      WRITE (NOUT,580) (X(I),I=1,N)
  260 CONTINUE
      RETURN
  300 WRITE (NOUT,540)
      IF (IPRINT.LT.0) GO TO 256
      RETURN
  500 FORMAT (/2X,61H**E R R O R  I N  F L E X I** N LESS THAN 1 OR N GR
     CEATER THAN,I3)
  510 FORMAT (/2X,26HNUMBER OF PARAMETERS IPA =,I6)
  520 FORMAT (/2X,45H**E R R O R  I N  F L E X I** IPA LESS THAN 0/2X,
     C7HOR IPA+,I2,13H GREATER THAN,I3)
  525 FORMAT (/2X,43H**E R R O R  I N  F L E X I** M LESS THAN 1/)
  540 FORMAT (/2X,51H**E R R O R  I N  F L E X I** IMPOSSIBLE TO SATISFY
     C/2X,45HVIOLATED CONSTRAINTS FROM THIS STARTING POINT)
  580 FORMAT (4(2X,E15.8))
  620 FORMAT (/2X,22HI N I T I A L  D A T A)
  630 FORMAT (/2X,19HNUMBER OF VARIABLES,22X,3HN =,I6)
  640 FORMAT (/2X,18HPRINTING PARAMETER,21X,5HIPR =,I6)
  650 FORMAT (2X,44HMAXIMUM NUMBER OF FUNCTION EVALUATIONS   M =,I6)
  700 FORMAT (/2X,27HNUMBER OF PARAMETERS IPAA =,I3)
  710 FORMAT (/2X,46H**E R R O R  I N  F L E X I** IPAA LESS THAN 0/2X,
     C8HOR IPAA+,I2,13H GREATER THAN,I3)
  820 FORMAT (/2X,14HSTARTING POINT)
  860 FORMAT (////12X,9HF L E X I)
  870 FORMAT (2X,30HNUMBER OF EQUALITY CONSTRAINTS,10X,4HNC =,I6)
  890 FORMAT(2X,32HNUMBER OF INEQUALITY CONSTRAINTS,7X,5HNIC =,I6)
  900 FORMAT (/2X,44H**E R R O R  I N  F L E X I** NC LESS THAN 0/)
  910 FORMAT (/2X,45H**E R R O R  I N  F L E X I** NIC LESS THAN 0/)
  930 FORMAT (/2X,55H**E R R O R  I N  F L E X I** NUMBER OF ALL CONSTRA
     CINTS/2X,12HGREATER THAN,I4/)
  940 FORMAT (/2X,34HSIZE OF INITIAL POLYHEDRON DELTA =,E15.8)
  950 FORMAT (2X,19HDESIRED CONVERGENCE,10X,5HEPS =,E15.8)
      END

      SUBROUTINE BAYES1(X,A,B,N,XN,NM,FM,IPAR,IPA)
C
C      BAYESIAN ONE-STEP METHOD.
C
C    PARAMETERS
C    IPAR - THE ARRAY OF INTEGER PARAMETERS
C    IPAR(IPA+1) = IPR - PRINTING PARAMETER
C    IPAR(IPA+2) = M - THE TOTAL NUMBER OF FUNCTION EVALUATIONS
C    IPAR(IPA+3) = LT - THE NUMBER OF INITIAL RANDOM POINTS
C    IF IPR LESS 0 THEN NO PRINTNNG
C    IF IPR = 0 THEN TERMINAL VALUES ARE PRINTED
C    IF IPR MORE 0 THEN VALUES ARE PRINTED WITH PERIOD=IPR.
C
      DIMENSION X(N),A(N),B(N),XN(NM)
      DIMENSION IPAR(30)
      COMMON/BAYZ/Z(20)/BAYX2/IX,X2(20)
     -/STATIS/IFAIL,M,IM,L/INW/IN/BAFI/YM
      COMMON /BS1/Y(1000)
C     --------------------------------------
C     1.INITIATION
C
      IFAIL=0
      IX=0
      M=IPAR(IPA+2)
      LT=IPAR(IPA+3)
      IN=1
      CALL INWR11(A,B,N,NM,IPAR,IPA)
      IF (IFAIL.EQ.10) RETURN
      K2=M
      L=0
      IPR=IPAR(IPA+1)
C     ----------------------------------------------------------
C      2.- MAIN LOOP
C
      DO 70 K=1,K2
      IF(K.GT.LT) GOTO 20
C     --------------------------------------------------------
C      2.1 - RANDOM POINTS
C
      AKK=K
      CALL LPTAU(AKK,N,Z)
      DO 15 I=1,N
   15 Z (I)=Z(I)*(B(I)-A(I))+A(I)
      GOTO 30
C     -----------------------------------------------------
C      2.2 - PLANNED POINTS
   20 CALL MIG2F2(Z,A,B,N,XN,NM)
   30 FF=FI(Z,N)
      J=L*N
      L=L+1
      Y(L)=FF
      DO 35 I=1,N
      M1=J+I
   35 XN(M1)=Z(I)
C     ------------------------------------------------------
C      2.3 - SEARCH OF MINIMUM
C
      IF (K.EQ.1) GO TO 37
      IF (FM.LE.FF) GO TO 50
   37 FM=FF
      IM=K
      YM=FM
      DO 40 I=1,N
   40 X(I)=Z(I)
   50 IF (IPR.LE.0) GO TO 70
      IF (MOD(K,IPR).EQ.0) CALL SPAU11(X,Z,N,FF,IPR)
   70 CONTINUE
   80 IF(IPR.LT.0)RETURN
      IN=IN+100
      CALL SPAU11(X,Z,N,FF,IPR)
      RETURN
      END
      SUBROUTINE MIG2F2(X,A,B,NN,XN,NM)
C
C      MINIMIZATION BY MONTE CARLO METHOD.
C      THE SECOND MINIMUM IS FOUND ALSO.
C     -----------------------------------------
C
      DIMENSION X(NN),A(NN),B(NN),XN(NM)
      COMMON/BAYX2/IX,X2(20)
      COMMON/MIGZ/Z(20)/BAYFM/FMIN/ATT/T(15)
      COMMON /STATIS/IFAIL,IT,IMP,L
C     --------------------------------------
C      1.INITIATION
C
       N=NN
      FMIN=0.
      M=MIN0(50*N,MAX0(10*N,L*N))
      K2=M
C     ------------------------------------------
C      2.GENERATION OF INITIAL SECOND MINIMUM POINT X2
C
      IF(IX.EQ.1)GOTO50
      DO 40 I=1,N
   40 X2(I)=ATS(1)*(B(I)-A(I))+A(I)
      K2=K2-1
   50 F2=FIAP1(X2,N,XN,NM)
C     -----------------------------------------
C      3.MAIN LOOP
C
      DO 150 K=1,K2
      DO 55 I=1,N
   55 Z(I)=ATS(1)*(B(I)-A(I))+A(I)
      FF=FIAP1(Z,N,XN,NM)
C     -----------------------------------------
C      3.1.SEARCH OF MINIMUM AND OF SECOND MINIMUM
C
      IF(K.NE.1)GOTO 90
      IF(FF.LT.F2)GOTO 110
      FM=F2
      IM=K
      DO 60 I=1,N
   60 X(I)=X2(I)
   70 F2=FF
      FMIN=FF
      DO 80 I=1,N
   80 X2(I)=Z(I)
      GO TO 150
   90 IF (FF.GE.F2) GO TO 150
      IF(FF.GE.FM)GOTO 70
      F2=FM
      DO 100 I=1,N
  100 X2(I)=X(I)
  110 FM=FF
      IM=K
      FMIN=F2
      DO 120 I=1,N
  120 X(I)=Z(I)
  150 CONTINUE
      IX=1
      RETURN
      END
      FUNCTION FIAP1(X,NN,XN,NM)
      DIMENSION X(NN),XN(NM)
      COMMON /STATIS/IFAIL,IT,LM,LL/BAFI/YM/BS1/Y(1000)
      COMMON/BAYFM/FMIN
      RMAX=R1MACH(2)/2.
      RLRS=100.*R1MACH(4)*ABS(YM)
      E=AMAX1(1.E-6,RLRS)
      N=NN
      L=LL
      FM=-FMIN
      YK=YM-E
      P=AMAX1(1.,Y(1)-YK)
      FII=RMAX/P
      M=0
      DO 20 J=1,L
      D=0.
      PP=Y(J)-YK
      IF (PP.LT.1.) GO TO 4
      IF (RMAX/PP.GT.FII) GO TO 4
      P=RMAX
      GO TO 6
    4 P=PP*FII
    6 CONTINUE
      DO 10 I=1,N
      M1=M+I
      D=D+(XN(M1)-X(I))**2
      IF(D.GE.P)GOTO 20
   10 CONTINUE
      FII=D/PP
      IF(FII.LE.FM) GOTO 30
   20 M=M+N
   30 FIAP1=-FII
      RETURN
      END
      SUBROUTINE SPAU11(X,Z,N,FF,IPR)
      DIMENSION X(N),Z(N)
      COMMON /STATIS/IFAIL,IT,IM,L/INW/IN/BAFI/YM
      NOUT=I1MACH(2)
      IF(IN.GT.100) GOTO 10
      WRITE(NOUT,100)
      IF (L.EQ.IPR) WRITE(NOUT,210)
      WRITE(NOUT,110) L
      WRITE(NOUT,120) FF
      WRITE(NOUT,140)
      WRITE(NOUT,130) (Z(I),I=1,N)
      IF (L.EQ.1) RETURN
      WRITE(NOUT,150) YM,IM
      WRITE(NOUT,160)
      WRITE(NOUT,130) (X(I),I=1,N)
      RETURN
   10 WRITE(NOUT,170)
      WRITE(NOUT,180)
      WRITE(NOUT,150) YM,IM
      WRITE(NOUT,160)
      WRITE(NOUT,130) (X(I),I=1,N)
      WRITE(NOUT,190) L
      WRITE (NOUT,200)
      WRITE(NOUT,170)
      RETURN
  100 FORMAT (/1X,34(2H -))
  110 FORMAT(2X,23HI T E R A T I O N  NR =,I6)
  120 FORMAT (/2X,19HFUNCTION VALUE F = ,E15.8)
  130 FORMAT(4(2X,E15.8))
  140 FORMAT (2X,13HCURRENT POINT)
  150 FORMAT (/2X,28HOPTIMAL FUNCTION VALUE FM = ,E15.8,17H OBTAINED IN
     CNR =,I6)
  160 FORMAT(2X,13HOPTIMAL POINT)
  170 FORMAT (/1X,34(2H *)/1X,34(2H *))
  180 FORMAT (/2X,13HR E S U L T S)
  190 FORMAT (/2X,34HNUMBER OF FUNCTION EVALUATIONS L =,I6)
  200 FORMAT(/7X,17HBAYES1 TERMINATED)
  210 FORMAT (1X,34(2H -))
      END
      SUBROUTINE INWR11(A,B,N,NM,IPAR,IPA)
      DIMENSION A(N),B(N)
      DIMENSION IPAR(30)
      COMMON /STATIS/IFAIL,IT,LM,LL
      MN=20
      MIM=1
      MM=1000
      MIP=30
      NOUT=I1MACH(2)
      K=3
      IF (IPA.GE.0.AND.IPA+K.LE.MIP) GO TO 10
      WRITE (NOUT,520) K,MIP
      WRITE (NOUT,510) IPA
    5 IFAIL=10
      RETURN
   10 CONTINUE
      IPRINT=IPAR(IPA+1)
      IF (IPRINT.LT.0) GO TO 110
      WRITE (NOUT,610)
      WRITE (NOUT,620)
      WRITE (NOUT,630) N
  110 IF (N.GT.0.AND.N.LE.MN) GO TO 20
      WRITE (NOUT,500) MN
      IF (IPRINT.LT.0) WRITE (NOUT,630) N
      GO TO 5
   20 CONTINUE
      M=IPAR(IPA+2)
      LT=IPAR(IPA+3)
      IF (IPRINT.LT.0) GO TO 40
      WRITE (NOUT,640) IPRINT
      WRITE (NOUT,650) M
      WRITE (NOUT,660) LT
   40 IF (M.GT.0.AND.M.LE.MM) GO TO 50
      WRITE (NOUT,525) MM
      IF (IPRINT.LT.0) WRITE (NOUT,650) M
      GO TO 5
   50 IF (NM.GE.N*M) GO TO 60
      WRITE (NOUT,540)
      IF (IPRINT.GE.0)GO TO 55
      WRITE (NOUT,630) N
      WRITE (NOUT,650) M
   55 WRITE (NOUT,635) NM
      GO TO 5
   60 CONTINUE
      IF (LT.GE.MIM.AND.LT.LE.M) GO TO 80
      WRITE (NOUT,550) MIM
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,660) LT
      WRITE (NOUT,650) M
      GO TO 5
   80 CONTINUE
      IF (IPRINT.LT.0) GO TO 200
      WRITE (NOUT,570)
      WRITE (NOUT,580) (A(I),I=1,N)
      WRITE (NOUT,590)
      WRITE (NOUT,580) (B(I),I=1,N)
  200 NER=0
      DO 90 I=1,N
      IF (A(I).LE.B(I)) GO TO 90
      IF (NER.NE.0) GO TO 86
      WRITE (NOUT,600) I,I
      GO TO 87
   86 WRITE (NOUT,605) I,I
   87 CONTINUE
      NER=1
   90 CONTINUE
      IF (NER.NE.1) RETURN
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,570)
      WRITE (NOUT,580) A
      WRITE (NOUT,590)
      WRITE (NOUT,580) B
      GO TO 5
  500 FORMAT (/2X,63H**E R R O R  I N  B A Y E S 1** N LESS THAN 1 OR N
     CGREATER THAN,I3)
  510 FORMAT (/2X,20HNUMBER OF PARAMETERS,11X,5HIPA =,I6)
  520 FORMAT (/2X,47H**E R R O R  I N  B A Y E S 1** IPA LESS THAN 0/2X,
     C7HOR IPA+,I2,13H GREATER THAN,I3)
  525 FORMAT (/2X,45H**E R R O R  I N  B A Y E S 1** M LESS THAN 1/
     C2X,17HOR M GREATER THAN,I6/)
  540 FORMAT (/2X,48H**E R R O R  I N  B A Y E S 1** NM LESS THAN N*M)
  550 FORMAT (/2X,44H**E R R O R  I N  B A Y E S 1** LT LESS THAN,I3/2X,
     C20HOR LT GREATER THAN M/)
  570 FORMAT ( /2X,32HVECTOR OF LOWER BOUNDS (A) FOR X)
  580 FORMAT (4(2X,E15.8))
  590 FORMAT (2X,32HVECTOR OF UPPER BOUNDS (B) FOR X)
  600 FORMAT (/2X,34H**E R R O R  I N  B A Y E S 1** A(,I2,17H) GREATER
     CTHAN B(,I2,1H))
  605 FORMAT (34X,2HA(,I2,17H) GREATER THAN B(,I2,1H))
  610 FORMAT (////12X,11HB A Y E S 1)
  620 FORMAT (/2X,22HI N I T I A L  D A T A)
  630 FORMAT (/2X,19HNUMBER OF VARIABLES,14X,3HN =,I6)
  635 FORMAT (2X,26HDIMENSION OF WORKING ARRAY,6X,4HNM =,I6)
  640 FORMAT (/2X,18HPRINTING PARAMETER,13X,5HIPR =,I6)
  650 FORMAT (2X,30HNUMBER OF FUNCTION EVALUATIONS, 3X,3HM =,I6)
  660 FORMAT (2X,24HNUMBER OF INITIAL POINTS, 8X,4HLT =,I6)
      END

      SUBROUTINE SMD(SM,DS,X,N,XN,NM)
C     AUXILIARY SUBROUTINE FOR UNT:
C     CALCULATES EXPECTED VALUE AND CONDITIONAL UNCERTAINTY
      COMMON /BL1/ZI,ZA,KT/BS1/Y(1000)/BL5/NH(5),LS(500)
     C/BL6/A1,A2(5,20)/BL7/NK,AM(20)/BL8/A,NB,D/BL10/AB(10),NL(10),
     CNX(10,100),AF/BL11/AMS(20)/STATIS/IFAIL,IT,ITM,L
      DIMENSION X(N),XN(NM),AN(5),AT(5)
      NA=NK
      EPS=1.E-3
      IF (MOD(KT,2).NE.0) GO TO 20
      DO 10 N1=1,NA
      M=(NH(N1)-1)*N
      R=0.
      DO 5 N2=1,N
      NM1=M+N2
    5 R=R+AM(N2)*(X(N2)-XN(NM1))**2
   10 AT(N1)=R
      GO TO 150
   20 RM=0.
      IF (L.GT.70) GO TO 60
      N2=1
      NM1=0
      DO 30 N1=1,NA
      IF (N2.NE.NB) GO TO 22
      N2=N2+1
      NM1=NM1+N
   22 CONTINUE
      NH(N1)=N2
      R=0.
      DO 25 N3=1,N
      NM2=NM1+N3
   25 R=R+AM(N3)*(X(N3)-XN(NM2))**2
      AT(N1)=R
      IF (R.LE.RM) GO TO 26
      RM=R
      M=N1
   26 NM1=NM1+N
   30 N2=N2+1
      DO 50 N3=N2,L
      IF (N3.EQ.NB) GO TO 45
      R=0.
      DO 35 N1=1,N
      NM2=NM1+N1
   35 R=R+AM(N1)*(X(N1)-XN(NM2))**2
      IF (R.GE.RM) GO TO 45
      NH(M)=N3
      AT(M)=R
      RM=R
      DO 40 N1=1,NA
      R=AT(N1)
      IF (R.LE.RM) GO TO 40
      RM=R
      M=N1
   40 CONTINUE
   45 NM1=NM1+N
   50 CONTINUE
      GO TO 150
   60 R=X(1)
      DO 70 N1=2,10
      IF (R.LT.AB(N1)) GO TO 80
   70 CONTINUE
      K=9
      GO TO 90
   80 K=N1-1
      IF (K.NE.1.AND.R.LT.AB(K)+AF) K=K-1
   90 KN=NL(K)
      KS=0
      KR=1
      DO 120 N1=1,NA
  100 IF (KS.LT.KN) GO TO 110
      KR=2
      KS=0
      K=K+1
      KN=NL(K)
  110 KS=KS+1
      N2=NX(K,KS)
      IF (N2.EQ.NB) GO TO 100
      NH(N1)=N2
      R=0.
      NM1=(N2-1)*N
      DO 115 N3=1,N
      NM2=NM1+N3
  115 R=R+AM(N3)*(X(N3)-XN(NM2))**2
      AT(N1)=R
      IF (R.LE.RM) GO TO 120
      RM=R
      M=N1
  120 CONTINUE
  130 IF (KR.EQ.2.AND.KS.EQ.KN) GO TO 150
      IF (KS.LT.KN) GO TO 140
      KR=2
      KS=0
      K=K+1
      KN=NL(K)
  140 KS=KS+1
      N2=NX(K,KS)
      IF (N2.EQ.NB) GO TO 130
      R=0.
      NM1=(N2-1)*N
      DO 145 N3=1,N
      NM2=NM1+N3
  145 R=R+AM(N3)*(X(N3)-XN(NM2))**2
      IF (R.GE.RM) GO TO 130
      NH(M)=N2
      AT(M)=R
      RM=R
      DO 147 N3=1,NA
      R=AT(N3)
      IF (R.LE.RM) GO TO 147
      RM=R
      M=N3
  147 CONTINUE
      GO TO 130
  150 DO 160 N1=1,NA
      R=AT(N1)
      RM=SQRT(R)
      AT(N1)=RM
      R=EXP(-R/A)/(RM+EPS)
      IF (R.LT.1.E-8) R=1.E-8
  160 AN(N1)=R
      IF (KT-3) 250,170,220
  170 RM=1.E-8
      DO 210 N1=1,NA
      N2=NH(N1)
      B1=0.
      Z=Y(N2)
      NM1=(N2-1)*N
      DO 200 N4=1,N
      S=0.
      V=0.
      NM2=NM1+N4
      R2=XN(NM2)
      R3=AMS(N4)
      DO 190 K=1,NA
      IF (K.EQ.N1) GO TO 190
      K1=NH(K)
      R=0.
      NM3=(K1-1)*N
      DO 180 K2=1,N
      NM4=NM3+K2
      NM5=NM1+K2
  180 R=R+AM(K2)*(XN(NM4)-XN(NM5))**2
      R1=AN(K)
      NM4=NM3+N4
      S=S+(Y(K1)-Z)*(XN(NM4)-R2)*R1*R3/R
      V=V+R1
  190 CONTINUE
      A1=S/V
      A2(N1,N4)=A1
  200 B1=B1+A1*A1
      IF (B1.GT.RM) RM=B1
  210 CONTINUE
      A1=0.5*(ZA-ZI)/SQRT(RM)
  220 S=0.
      V=0.
      DO 240 N1=1,NA
      N2=NH(N1)
      B1=AN(N1)
      DZ=0.
      NM1=(N2-1)*N
      DO 230 K=1,N
      NM2=NM1+K
  230 DZ=DZ+A2(N1,K)*(X(K)-XN(NM2))*AMS(K)
      S=S+(Y(N2)+DZ*A1/(A1+AT(N1)))*B1
  240 V=V+B1
      SM=S/V
      RETURN
  250 S=0.
      V=0.
      V2=0.
      V3=0.
      DO 270 N1=1,NA
      N2=NH(N1)
      DS=0.
      IF (NB.NE.0.AND.Y(N2).GT.ZA) RETURN
      B1=AN(N1)
      R=AT(N1)
      S=S+B1*Y(N2)
      IF (LS(N2).LT.7) GO TO 260
      RM=R/5.
      R1=EXP(-RM*RM/A)/(RM+EPS)
      IF (R1.LT.1.E-8) R1=1.E-8
      V3=V3+R1
      V2=V2+RM*R1
      GO TO 270
  260 V3=V3+B1
      V2=V2+R*B1
  270 V=V+B1
      SM=S/V
      DS=D*V2/V3
      RETURN
      END
      SUBROUTINE VERT(N,XN,NM)
C     AUXILIARY SUBROUTINE FOR UNT:
C     ESTIMATION OF SCALE FACTORS
      COMMON /BL1/ZI,ZA,KT/BS1/Y(1000)/BL7/NA,AM(20)
     C/BL8/A1,NB,D/BL11/AMS(20)/STATIS/IFAIL,IT,ITM,L
      DIMENSION X(20),XN(NM)
      A1=0.3
      NA=5
      KT=1
      DO 30 K=1,N
      F=0.
      DO 10 M=1,L
      NM1=(M-1)*N+K
   10 F=F+XN(NM1)
      F=F/FLOAT(L)
      S=0.
      DO 20 M=1,L
      NM1=(M-1)*N+K
   20 S=S+(XN(NM1)-F)**2
      F=FLOAT(L)/S
      AM(K)=F
   30 AMS(K)=SQRT(F)
      D=1.
      S=0.
      V=0.
      NM1=0
      DO 50 NB=1,L
      F=Y(NB)
      IF (F.GE.ZA) GO TO 50
      DO 40 K=1,N
      NM2=NM1+K
   40 X(K)=XN(NM2)
      CALL SMD(SM,DS,X,N,XN,NM)
      S=S+DS*(SM-F)**2
      V=V+DS*DS
   50 NM1=NM1+N
      NB=0
      D=S/V
      RETURN
      END
      FUNCTION FU(X,N,XN,NM)
C     AUXILIARY SUBROUTINE FOR UNT:
C     FUNCTION WHICH TO BE MINIMIZED
      COMMON /BL1/ZI,ZA,KT/BL3/ZM,YL/BL9/SM,DS
      DIMENSION X(N),XN(NM)
      IF (KT.LT.3) GO TO 20
      CALL SMD(SM,DS,X,N,XN,NM)
      FU=SM
      RETURN
   20 IF (ZM.LT.0.5) CALL SMD(SM,DS,X,N,XN,NM)
      Z=ABS(ZM)
      IF (DS.LT.1.E-10) DS=1.E-10
      IF (Z.GT.0.5) GO TO 30
      FU=(SM+YL-2.*ZI)/SQRT(DS)
      RETURN
   30 FU=(SM-ZI+(ZA-ZI)*Z)/SQRT(DS)
      RETURN
      END
      FUNCTION FP(X,N,XN,NM)
      DIMENSION X(N),XN(NM)
      COMMON/BS1/Y(1000)/BL10/AB(10),NL(10),NX(10,100),AF/STATIS/IFAIL,
     CIT,ITM,L
      F=FI(X,N)
      NM1=L*N
      L=L+1
      Y(L)=F
      DO 10 N1=1,N
      NM2=NM1+N1
   10 XN(NM2)=X(N1)
      R=X(1)
      DO 20 N1=2,10
      IF (R.LT.AB(N1)) GO TO 30
   20 CONTINUE
      N1=11
   30 K=N1-1
      M=NL(K)+1
      NL(K)=M
      NX(K,M)=L
      FP=F
      RETURN
      END
      SUBROUTINE UNT(X,A,B,N,XN,NM,FM,IPAR,IPA)
C     MINIMIZATION OF MULTIMODAL FUNCTION FI(X,N)
      COMMON /BL1/ZI,ZA,KT/BS1/Y(1000)/BL3/ZM,YL
     1/BL5/NH(5),LS(500)/BL7/NA,AM(20)/BL10/AB(10),NL(10),NX(10,100),AF
     2/BL12/KAU,FS(20),XS(20,20)/BL6/AUN1,AUN2(5,20)/GR1/DEL(20)
     3/BL9/SMU,DSU/ATT/AT(15)/STATIS/IFAUL,IT,ITM,L
      COMMON /INW/INW1
      DIMENSION X(N),A(N),B(N),XN(NM)
      DIMENSION KS(20),IPAR(30),AC(20),Z(20),X1(20),X2(20)
C     INITIALIZATION OF PARAMETERS
      IFAUL=0
      CALL INWR18(A,B,N,NM,IPAR,IPA)
      IF (IFAUL.EQ.10) RETURN
      INW1=0
      L=0
      IPR=IPAR(IPA+1)
      KAU=0
      DO 10 K=1,500
   10 LS(K)=0
C     GENERATION OF RANDOM POINTS
       S2=0.
      DO 20 K=1,N
      DEL(K)=(B(K)-A(K))*1.E-4
      S2=S2+(B(K)-A(K))**2
   20 AC(K)=B(K)-A(K)
      S2=0.5*SQRT(S2)
      AF=AC(1)/10.
      DO 30 K=1,10
      NL(K)=0
   30 AB(K)=A(1)+FLOAT(K-1)*AF
      LT=IPAR(IPA+3)
      K5=IPAR(IPA+4)
      DO 60 K=1,LT
      M=MOD(K,10)
      IF (M.EQ.0) M=10
      Z(1)=ATS(1)*AF+AB(M)
      DO 40 M=2,N
   40 Z(M)=ATS(1)*AC(M)+A(M)
      F=FP(Z,N,XN,NM)
      IF (K.EQ.1) GO TO 45
      IF (F.GE.ZI) GO TO 60
   45 ZI=F
      ITM=L
      DO 50 M=1,N
   50 X(M)=Z(M)
   60 CONTINUE
C     ESTIMATION OF K-TH MAXIMAL FUNCTION VALUE ZA
      AF=AF/2.
      K=MIN0(LT/5,10)
      DO 70 M=1,K
      F=Y(M)
      FS(M)=F
      IF (M.EQ.1) GO TO 65
      IF (F.GE.ZA) GO TO 70
   65 ZA=F
      N1=M
   70 CONTINUE
      N2=K+1
      DO 90 M=N2,LT
      F=Y(M)
      IF (F.LE.ZA) GO TO 90
      ZA=F
      FS(N1)=F
      DO 80 N3=1,K
      F=FS(N3)
      IF (F.GE.ZA) GO TO 80
      ZA=F
      N1=N3
   80 CONTINUE
   90 CONTINUE
      F=ABS(ZI-ZA)
      IF (F.GT.1.E-8.AND.F.LT.SQRT(R1MACH(2))) GO TO 95
      IFAUL=10
      FM=ZI
      IT=L
      CALL INWR18(A,B,N,NM,IPAR,IPA)
      RETURN
   95 CONTINUE
      CALL VERT(N,XN,NM)
      YL=0.7*ZI+0.3*ZA
      K1=LT+1
      K2=(IPAR(IPA+2)+LT)/2
      KX=0
      K4=3
      XL=0.
C     MAIN LOOP OF GLOBAL MINIMIZATION
      DO 390 K=K1,K2
      KT=1
      DO 140 M=1,40
      DO 100 N1=1,N
  100 Z(N1)=ATS(1)*AC(N1)+A(N1)
      ZM=0.1
      F1=FU(Z,N,XN,NM)
      ZM=1.
      F2=FU(Z,N,XN,NM)
      IF (M.EQ.1) GO TO 105
      IF (F1.GE.F3) GO TO 120
  105 F3=F1
      DO 110 N1=1,N
  110 X2(N1)=Z(N1)
  120 IF (M.EQ.1) GO TO 125
      IF (F2.GE.F4) GO TO 140
  125 F4=F2
      DO 130 N1=1,N
  130 X1(N1)=Z(N1)
  140 CONTINUE
      ZM=-1.
      KT=1
      S1=S2*EXP(-ALOG(FLOAT(L))/FLOAT(N))
      CALL GRAUNT(X1,A,B,N,F,S1,XN,NM)
      F1=FP(X1,N,XN,NM)
      IF (F1.GE.ZI) GO TO 144
      ITM=L
      ZI=F1
      DO 142 M=1,N
  142 X(M)=X1(M)
  144 IF (IPR.LE.0) GO TO 145
      IF (MOD(L,IPR).EQ.0) CALL SPAU18(X,N,ZI,IPR)
  145 CONTINUE
      ZM=-0.1
      KT=1
      S1=S2*EXP(-ALOG(FLOAT(L))/FLOAT(N))
      CALL GRAUNT(X2,A,B,N,F,S1,XN,NM)
      D1=0.
      DO 160 I=1,N
  160 D1=D1+(X1(I)-X2(I))**2
      KXL=0
      IF (SQRT(D1).GT.0.01*S2) GO TO 170
      KXL=1
      DO 165 I=1,N
  165 X2(I)=ATS(1)*AC(I)+A(I)
  170 CONTINUE
      F2=FP(X2,N,XN,NM)
      IF (F2.GE.ZI)  GO TO 148
      ITM=L
      ZI=F2
      DO 146 M=1,N
  146 X(M)=X2(M)
  148 IF (IPR.LE.0) GO TO 147
      IF (MOD(L,IPR).EQ.0) CALL SPAU18(X,N,ZI,IPR)
  147 IF (KXL.EQ.0) GO TO 180
      F2=F1
      DO 185 I=1,N
  185 X2(I)=X1(I)
  180 CONTINUE
      KX=KX+1
      XK=FLOAT(KX)
      XL=((XK-1.)*XL+F2)/XK
      IF (MOD(K,10).EQ.0) YL=XL
      N4=0
      DO 150 N1=1,NA
      N2=NH(N1)
      M=LS(N2)+1
      IF (M.NE.7) GO TO 150
      F=Y(N2)
      IF(N4.EQ.0) GO TO 149
      IF (F.GE.F3) GO TO 150
  149 F3=F
      N4=N2
  150 LS(N2)=M
      IF (N4.EQ.0) GO TO 390
      IF (F2.GT.F3) GO TO 220
      DO 210 M=1,N
  210 Z(M)=X2(M)
      GO TO 240
  220 CONTINUE
      NM1=(N4-1)*N
      DO 230 M=1,N
      NM2=NM1+M
  230 Z(M)=XN(NM2)
C     ESTIMATION OF LOCAL MINIMUM OF FU(X,N)
  240 KT=3
      CALL GRAUNT(Z,A,B,N,F,S1,XN,NM)
      DO 250 M=1,NA
      N1=NH(M)
      R=Y(N1)
      IF (M.EQ.1) GO TO 245
      IF (R.GE.F) GO TO 250
  245 N4=N1
      F=R
  250 LS(N1)=7
      NM1=(N4-1)*N
      DO 260 M=1,N
      NM2=NM1+M
  260 Z(M)=XN(NM2)
  270 IF (KAU.EQ.0) GO TO 320
      DO 310 N1=1,KAU
      R=0.
      DO 280 N2=1,N
  280 R=R+AM(N2)*(XS(N2,N1)-Z(N2))**2
      IF (SQRT(R).GE.0.2) GO TO 310
      R=FS(N1)
      IF (F.GE.R) GO TO 305
      DO 300 N4=1,N
  300 XS(N4,N1)=Z(N4)
      FS(N1)=F
  305 N4=KS(N1)
      IF (N4.LT.K4) GO TO 290
      IFAUL=1
      GO TO 400
  290 KS(N1)=N4+1
      GO TO 390
  310 CONTINUE
  320 CONTINUE
      KAU=KAU+1
      KS(KAU)=1
      FS(KAU)=F
      DO 330 N1=1,N
  330 XS(N1,KAU)=Z(N1)
      IF (KAU.LT.K5) GO TO 390
      IFAUL=0
      GO TO 400
  390 CONTINUE
      IFAUL=2
  400 CONTINUE
      FM=ZI
      INW1=2
      IT=L
      IF (IPR.GE.0) CALL SPAU18(X,N,FM,IPR)
      RETURN
      END
      SUBROUTINE GRAUNT(X,A,B,N,F,S1,XN,NM)
      DIMENSION X(N),A(N),B(N),XN(NM),Z(20),FF(20)
      COMMON /GR1/DEL(20)/BL1/ZI,ZA,KTIP
       S=S1
      EPS=0.03*S
      F=FU(X,N,XN,NM)
      KTIP=KTIP+1
      DO 20 I=1,N
   20 Z(I)=X(I)
   30 SG=0.
      DO 50 I=1,N
      X1=X(I)
      IF (X1.LE.B(I)-EPS.AND.X1.GE.A(I)+EPS) GO TO 40
      FF(I)=0.
      GO TO 50
   40 D1=DEL(I)
      Z(I)=X1+D1
      F1=FU(Z,N,XN,NM)
      Z(I)=X1-D1
      F2=FU(Z,N,XN,NM)
      FF(I)=(F1-F2)/(2.*D1)
      SG=SG+FF(I)**2
   50 Z(I)=X(I)
      IF (SG.LT.1.E-8) GO TO 100
      SG=SQRT(SG)
   60 DO 70 I=1,N
      X1=X(I)-S*FF(I)/SG
      IF (X1.GT.B(I)) X1=B(I)
      IF (X1.LT.A(I)) X1=A(I)
   70 Z(I)=X1
       KTIP=KTIP-1
      F1=FU(Z,N,XN,NM)
      KTIP=KTIP+1
      IF (F1.GE.F) GO TO 90
      F=F1
      DO 80 I=1,N
   80 X(I)=Z(I)
      GO TO 30
   90 S=S/2.
      IF (S.GE.EPS) GO TO 60
  100 CONTINUE
      RETURN
      END
      SUBROUTINE INWR18(A,B,N,NM,IPAR,IPA)
      DIMENSION A(N),B(N),IPAR(30)
      COMMON /STATIS/IFAIL,IT,ITM,NF
      MN=20
      MIM=30
      MM=500
      MIP=30
      MAL=20
      K=4
      NOUT=I1MACH(2)
      IF (IFAIL.EQ.0) GO TO 4
      WRITE (NOUT,740)
      RETURN
    4 CONTINUE
      IF (IPA.GE.0.AND.IPA+K.LE.MIP) GO TO 10
      WRITE (NOUT,520) K,MIP
      WRITE (NOUT,510) IPA
    5 IFAIL=10
      RETURN
   10 CONTINUE
      IPRINT=IPAR(IPA+1)
      IF (IPRINT.LT.0) GO TO 110
      WRITE (NOUT,610)
      WRITE (NOUT,620)
      WRITE (NOUT,630) N
  110 IF (N.GT.0.AND.N.LE.MN) GO TO 20
      WRITE (NOUT,500) MN
      IF (IPRINT.LT.0) WRITE (NOUT,630) N
      GO TO 5
   20 CONTINUE
      M=IPAR(IPA+2)
      LT=IPAR(IPA+3)
      ML=IPAR(IPA+4)
      IF (IPRINT.LT.0) GO TO 40
      WRITE (NOUT,640) IPRINT
      WRITE (NOUT,650) M
      WRITE (NOUT,660) LT
      WRITE (NOUT,670) ML
   40 IF (M.GT.0.AND.M.LE.MM) GO TO 47
      WRITE (NOUT,530) MM
      IF (IPRINT.LT.0) WRITE (NOUT,650) M
      GO TO 5
   47 IF (NM.GE.N*M) GO TO 50
      WRITE (NOUT,730)
      IF (IPRINT.GE.0) GO TO 55
      WRITE (NOUT,630) N
      WRITE (NOUT,650) M
   55 WRITE (NOUT,635) NM
      GO TO 5
   50 CONTINUE
      IF (LT.EQ.0) LT=MAX0(15*N,6*ML)
      IPAR(IPA+3)=LT
      IF (LT.GE.MIM.AND.LT.LE.M) GO TO 80
      WRITE (NOUT,550) MIM
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,650) M
      WRITE (NOUT,660) LT
      GO TO 5
   80 CONTINUE
      IF (ML.GT.0.AND.ML.LE.MAL) GO TO 100
      WRITE (NOUT,680) MAL
      IF (IPRINT.LT.0) WRITE (NOUT,670) ML
      GO TO 5
  100 CONTINUE
      IF (IPRINT.LT.0) GO TO 200
      WRITE (NOUT,570)
      WRITE (NOUT,580) (A(I),I=1,N)
      WRITE (NOUT,590)
      WRITE (NOUT,580) (B(I),I=1,N)
  200 NER=0
      DO 90 I=1,N
      IF (A(I).LT.B(I)) GO TO 90
      IF (NER.NE.0) GO TO 86
      WRITE (NOUT,600) I,I
      GO TO 87
   86 WRITE (NOUT,605) I,I
   87 CONTINUE
      NER=1
   90 CONTINUE
      IF (NER.NE.1) RETURN
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,570)
      WRITE (NOUT,580) A
      WRITE (NOUT,590)
      WRITE (NOUT,580) B
      GO TO 5
  500 FORMAT (/2X,57H**E R R O R  I N  U N T** N LESS THAN 1 OR N GREATE
     CR THAN,I3)
  510 FORMAT (/2X,20HNUMBER OF PARAMETERS,11X,5HIPA =,I6)
  520 FORMAT (/2X,41H**E R R O R  I N  U N T** IPA LESS THAN 02X,
     C7HOR IPA+,I2,13H GREATER THAN,I3)
  530 FORMAT (/2X,57H**E R R O R  I N  U N T** M LESS THAN 1 OR M GREATE
     CR THAN,I6/)
  550 FORMAT (/2X,38H**E R R O R  I N  U N T** LT LESS THAN,I3,
     C21H OR LT GREATER THAN M/)
  570 FORMAT ( /2X,32HVECTOR OF LOWER BOUNDS (A) FOR X)
  580 FORMAT (4(2X,E15.8))
  590 FORMAT (2X,32HVECTOR OF UPPER BOUNDS (B) FOR X)
  600 FORMAT (/2X,28H**E R R O R  I N  U N T** A(,I3,17H) GREATER THAN B
     C(,I3,1H))
  605 FORMAT (28X,2HA(,I3,17H) GREATER THAN B(,I3,1H))
  610 FORMAT (////12X,5HU N T)
  620 FORMAT (/2X,22HI N I T I A L  D A T A)
  630 FORMAT (/2X,19HNUMBER OF VARIABLES,22X,3HN =,I6)
  635 FORMAT (2X,26HDIMENSION OF WORKING ARRAY,14X,4HNM =,I6)
  640 FORMAT (/2X,18HPRINTING PARAMETER,21X,5HIPR =,I6)
  650 FORMAT (2X,44HMAXIMUM NUMBER OF FUNCTION EVALUATIONS   M =,I6)
  660 FORMAT (2X,24HNUMBER OF INITIAL POINTS,16X,4HLT =,I6)
  670 FORMAT (2X,30HMAXIMUM NUMBER OF LOCAL MINIMA,10X,4HML =,I6)
  680 FORMAT (/2X,59H**E R R O R  I N  U N T** ML LESS THAN 1 OR ML GREA
     CTER THAN,I3/)
  730 FORMAT (/2X,42H**E R R O R  I N  U N T** NM LESS THAN N*M)
  740 FORMAT (/2X,57H**E R R O R  I N  U N T** VARIATION OF OBJECTIVE FU
     CNCTION/2X,25HIS TOO SMALL OR TOO LARGE)
       END
       SUBROUTINE SPAU18(X,N,FF,IPR)
      DIMENSION X(N)
      COMMON /INW/IN/BL12/KAU,FS(20),XS(20,20)
     C/STATIS/IFAIL,IT,ITM,L
      NOUT=I1MACH(2)
      IF (IN.EQ.2) GO TO 10
      WRITE(NOUT,100)
      IF (L.EQ.IPR) WRITE(NOUT,210)
      WRITE(NOUT,110) L
      WRITE(NOUT,120) FF
      WRITE(NOUT,160)
      WRITE(NOUT,130) (X(I),I=1,N)
      RETURN
   10 WRITE(NOUT,170)
      WRITE(NOUT,180)
      WRITE (NOUT,120) FF
      WRITE(NOUT,160)
      WRITE(NOUT,130) (X(I),I=1,N)
      IF (KAU.EQ.0) GO TO 40
      WRITE (NOUT,250)
      DO 30 I=1,KAU
      IF (N.GT.3) GO TO 20
      WRITE (NOUT,130) FS(I),(XS(J,I),J=1,N)
      GO TO 30
   20 N1=N-3
      WRITE (NOUT,130) FS(I),(XS(J,I),J=1,3)
      WRITE (NOUT,220) (XS(J,I),J=4,N)
   30 CONTINUE
   40 WRITE (NOUT,260) L
      IF (IFAIL.EQ.0) WRITE (NOUT,270)
      IF (IFAIL.EQ.1) WRITE (NOUT,280)
      IF (IFAIL.EQ.2) WRITE (NOUT,290)
      WRITE (NOUT,200)
      WRITE(NOUT,170)
      RETURN
  100 FORMAT (/1X,34(2H -))
  110 FORMAT (2X,34HNUMBER OF FUNCTION EVALUATIONS L =,I6)
  120 FORMAT (/2X,27HOPTIMAL FUNCTION VALUE FM =,E15.8)
  130 FORMAT(4(2X,E15.8))
  160 FORMAT(2X,13HOPTIMAL POINT)
  170 FORMAT (/1X,34(2H *)/1X,34(2H *))
  180 FORMAT (/2X,13HR E S U L T S)
  200 FORMAT (/7X,14HUNT TERMINATED)
  210 FORMAT (1X,34(2H -))
  220 FORMAT ((17X,3(2X,E15.8)))
  250 FORMAT (/12X,12HLOCAL OPTIMA/3X,14HFUNCTION VALUE,8X,5HPOINT)
  260 FORMAT (/2X,34HNUMBER OF FUNCTION EVALUATIONS L =,I6)
  270 FORMAT (/2X,66HIFAIL = 0. TERMINATION CRITERION: NUMBER OF LOCAL M
     CINIMA EQUALS ML)
  280 FORMAT (/2X,51HIFAIL = 1. TERMINATION CRITERION: DENSITY OF POINTS
     C/2X,30HIN LOCAL MINIMUM AREA EQUALS 3)
  290 FORMAT (/2X,52HIFAIL = 2. TERMINATION CRITERION: NUMBER OF FUNCTIO
     CN/2X,20HEVALUATIONS EQUALS M)
      END

      SUBROUTINE MIVAR4(X,A,B,NN,B1,NM,FM,IPAR,PAR,IPA,IPAA)
      COMMON/STATIS/IFAIL,ICT,ICTMIN,LFUN/INW/IN
      COMMON/MIVF/F(100)
      DIMENSION IPAR(30),PAR(30)
      DIMENSION A(NN),B(NN),X(NN),B1(NM)
      COMMON/MIVDE/DELT(101)/GRZ/ZET(100)
      COMMON /MIVNFN/IFN
      COMMON /MIVY/Y(100)/MIVP/P(100)/MIVOLP/OLDP(100)
      COMMON /MIVRVT/RVT(100)/B3/FVT(100)/MIVUPD/UPD(100)
      COMMON /MIVGRA/PM,IPM,FN2,KFF,FF,OFMAX,OXNOR1
     -/MIV3/INEXT/MIVJQ/JQ(100)
      COMMON/MIVDEL/DEL,DL/MIVRV/RV(100)/MIVOLF/OLDF(100)
      COMMON/MIVBMI/BMI(100)/MIVAMA/AMA(100)
      COMMON/MIVLIN/SQPNM,PMAX,IFV,SC,OLDFF,EPSC,ISC,ICON,ISGRAD,
     *SCM,FVTMAX,FMAX,IFM,FNM,FNM2,EPS,XEPS,IAP,SFO,
     *OPNM,PNM,OXNOR
      COMMON/MIVIG/IGRA
      COMMON/MIVKEY/KEY
      COMMON/MIVYM/YMAX/MIVPRI/SOFPRI
      COMMON/MIVLIB/OPMAX,ETA
      COMMON/LIN1/SCIN,IXT,PF,ICOSTA
      DOUBLE PRECISION PI
      IN=1
      NB1=(NN*(NN+1))/2
      N=NN
       IFAIL=0
      CALL INWR31(X,A,B,N,NM,FF,IPAR,PAR,IPA,IPAA)
      IF(IFAIL.EQ.10) RETURN
      AN=FLOAT(N)
      DEL=PAR(IPAA+4)
      XEPS=PAR(IPAA+1)
      RLRS=R1MACH(4)*AN*AN
      RMAX=R1MACH(2)
      RMIN=R1MACH(1)
      SRMAX=SQRT(RMAX)/10.
      SRMIN=SQRT(RMIN)*10.
      ICT=0
      IFV=0
      IFN=0
      EPSC=AMIN1(SRMIN,XEPS)
      EPSC=AMAX1(RMIN*AN,EPSC)
      SC=0.
      SCM=RMAX
      EPS=PAR(IPAA+2)
      EPS1=PAR(IPAA+3)
      IMAX=IPAR(IPA+4)
      NSTOP=IPAR(IPA+3)
      LFUNMA=IPAR(IPA+2)
      IPRINT=IPAR(IPA+1)
      IGRA=0
      IXT1=0
      XNOR=SRMAX
      OXNOR=XNOR
      OXNOR1=OXNOR
      INEXT=IPRINT
      MSTOP=0
      DO 20 I=1,N
      AMA(I)=AMAX1(A(I)*(1.+RLRS),A(I)+RMIN+R1MACH(4)/10.)
      BMI(I)=AMIN1(B(I)*(1.-RLRS),B(I)-RMIN-R1MACH(4)/10.)
      IF(X(I).GE.BMI(I)) X(I)=B(I)
      IF(X(I).LE.AMA(I)) X(I)=A(I)
   20 RVT(I)=0.
      IQM=0
      IQM1=1
      KFF=0
      LFUN=1
      CALL GRABP1(X,N,A,B)
      IF(KFF.EQ.0) IGRA=11
      IFV=IFV+1
      DO 60 I=1,N
      RV(I)=0.
      OLDF(I)=FVT(I)
      IF(FVT(I))50,34,40
   34 IF(X(I).EQ.B(I)) GOTO 52
   40 IF(X(I).GT.A(I))GOTO 60
      OLDF(I)=0.
      RVT(I)=1.
      GOTO 60
   50 IF(X(I).LT.B(I)) GOTO 60
   52 OLDF(I)=0.
      RVT(I)=-1.
   60 CONTINUE
      CALL VMAX(OLDF,N,OFMAX,IFMA)
      CALL ENORM(OLDF,N,OFMAX,OFNM)
      SQOFNM=SQRT(OFNM)
      ICOSTA=0
      IF(OFNM.EQ.0.) GOTO 80
      IF(SQOFNM*OFMAX.LE.EPS) ICOSTA=1
      GOTO 85
   80 FM=FF
      IN=2
      CALL INWR31(X,A,B,N,NM,FF,IPAR,PAR,IPA,IPAA)
      RETURN
   85 FVTMAX=OFMAX
       IF(LFUN.LT.LFUNMA) GOTO 87
      IF(ICOSTA.NE.1) IFAIL=3
      GOTO 940
  87  DAUG=1.
      ISGRAD=0
       IAP=0
      ICON=0
      OLDFF=FF
  100 DO 110 I=2,NB1
  110 B1(I)=0.
      J=0
      DO 120 I=1,N
      J=J+I
  120 B1(J)=1.0
      ISGRAD=1
  140 IF(IQM.EQ.0 ) GOTO 170
      DO 160 I=IQM1,IQM
      IQ=JQ(I)
      IF(X(IQ).NE.A(IQ).AND.X(IQ).NE.B(IQ)) GOTO 160
      RVT(IQ)=RV(IQ)
      OLDF(IQ)=0.
      IF(RVT(IQ).EQ.-1.) GOTO 150
      X(IQ)=A(IQ)
      GOTO 160
  150 X(IQ)=B(IQ)
  160 CONTINUE
      CALL VMAX(OLDF,N,OFMAX,IFMA)
      CALL ENORM(OLDF,N,OFMAX,OFNM)
  170 SC=0.
      IQM1=1
      SQOFNM=SQRT(OFNM)
      SCM=RMAX
      ISGR=0
  180 IF(IAP.NE.1) ICT=ICT+1
      ISC=0
      DO 200 I=1,N
      PI=0.D0
      IF(RVT(I).NE.0.) GOTO 195
      IJ=(I*(I-1))/2+1
      DO 190 J=1,N
      IF(RVT(J).NE.0.) GOTO 184
      PI=PI-B1(IJ)*OLDF(J)
  184 IF(I.GT.J) GOTO 186
      IJ=IJ+J
      GOTO 190
  186 IJ=IJ+1
  190 CONTINUE
  195 P(I)=SNGL(PI)
  200 CONTINUE
      CALL VMAX(P,N,PMAX,IPM)
      CALL ENORM(P,N,PMAX,PNM)
      SQPNM=SQRT(PNM)
      CALL PROD(OLDF,P,N,OFMAX,PMAX,SFO)
      IF(OFNM.LE.0.)GOTO 270
      IF(PNM.GT.0.)GOTO 240
  220 DO 230 I=1,N
  230 P(I)=-OLDF(I)
      IXT1=1
      IF(ISGRAD.NE.1) ISGR=1
      SQPNM=SQOFNM
      IPM=IFMA
      PMAX=OFMAX
      PNM=OFNM
      SFO=-OFNM
      ISGRAD=1
      GOTO 260
  240 PFN=SQPNM*SQOFNM
      IF(SFO.LT.-0.01*PFN)GOTO 260
      IPM=IFMA
      IF(ISGRAD.NE.1) ISGR=1
      ISGRAD=1
      PMAX=PMAX*(SQPNM/SQOFNM)
      DO 250 I=1,N
  250 P(I)=-PMAX*(OLDF(I)/OFMAX)
      PNM=OFNM
      SQPNM=SQOFNM
      SFO=-OFNM
  260 SC=AMIN1(0.1,1.0/(SQPNM*PMAX))
  270 IF(FVTMAX.EQ.0.) GOTO 940
      ALF=0.
      I1=0
      DO 290 I=1,N
      IF(RVT(I).EQ.0..OR.FVT(I).EQ.0.)GOTO 290
  280 AL=-0.5*RVT(I)*FVT(I)*DAUG
      IF(SQPNM*PMAX.GE.AL)GOTO 290
      I1=I1+1
      IF(ALF.GE.AL)GOTO 290
      ALF=AL
      IQ=I
  290 CONTINUE
      IF(I1) 300,310,300
  300 FVTIQ=FVT(IQ)
      RVT(IQ)=0.
      OLDF(IQ)=FVTIQ
      IQQ=(IQ*(IQ+1))/2
      AFVTIQ=ABS(FVTIQ)
      B1IQ=AMAX1(B1(IQQ),(PMAX* SQPNM)/AFVTIQ)
      B1(IQQ)=AMIN1(1.,B1IQ)
      P(IQ)=-FVTIQ*B1(IQQ)
      IF(ABS(P(IQ)).LT.RMIN*AN) P(IQ)=-FVTIQ
      IF(ISGRAD.NE.1) ISGR=1
      ISGRAD=1
      PMAX1=PMAX
      APIQ=ABS(P(IQ))
      IF(PMAX.GT.APIQ) GOTO 304
      PMAX1=APIQ
      IPM=IQ
  304 PNMI=P(IQ)/PMAX1
      PNMA=PMAX/PMAX1
      PMAX=PMAX1
      PNM=PNM*PNMA*PNMA+PNMI*PNMI
      OFMAX1=OFMAX
      IF(OFMAX.GT.AFVTIQ) GOTO 306
      OFMAX1=AFVTIQ
      IFMA=IQ
  306 OFNMI=FVTIQ/OFMAX1
      OFNMA=OFMAX/OFMAX1
      OFMAX=OFMAX1
      OFNM=OFNM*OFNMA*OFNMA+OFNMI*OFNMI
      SFO=SFO*OFNMA*PNMA+OFNMI*PNMI
      IF(I1.GT.1)GOTO 270
      SQOFNM=SQRT(OFNM)
      SQPNM=SQRT(PNM)
  310 IF(OFNM.LE.0.) GOTO 940
       ICOSTA =0
      IF(SQOFNM*OFMAX.GT.EPS) GOTO 320
      ICOSTA=1
      IF(ICT.GT.1.AND.XNOR.LE.XEPS) GOTO 940
  320 IF(IAP.EQ.0) GOTO 330
       IF(ICT.LE.IMAX) GOTO 322
      IF(ICOSTA.NE.1) IFAIL=2
      GOTO 940
  322 IF(LFUN.LT.LFUNMA) GOTO 324
      IF(ICOSTA.NE.1) IFAIL=3
      GOTO 940
  324 ICT=ICT+1
  330 IAP=0
      IF(I1.EQ.0)GOTO 360
      IF(IXT1.EQ.1 )GOTO 350
      PFN=SQPNM*SQOFNM
      IF(SFO.LT.-0.01*PFN)GOTO 350
  335 IPM=IFMA
      IF(ISGRAD.NE.1) ISGR=1
      ISGRAD=1
      PMAX=PMAX*SQPNM/SQOFNM
      DO 340 I=1,N
  340 P(I)=-PMAX*(OLDF(I)/OFMAX)
      PNM=OFNM
      SQPNM=SQOFNM
      SFO=-OFNM
      IF(ISC.EQ.1) GOTO 360
  350 SC=AMIN1(0.1,1.0/(SQPNM*PMAX))
  360 DAUG=1.
      IQM=0
      IXT1=0
      DO 460 I=1,N
      RV(I)=0.
      IF(RVT(I).NE.0.) GOTO 460
      IF(P(I))370,460,380
  370 B2=A(I)-X(I)
      GOTO 390
  380 B2=B(I)-X(I)
  390 IF(I-1)400,400,420
  400 IF(ABS(P(1)).GT.1.) GOTO 410
      IF(ABS(B2).GT.RMAX*ABS(P(1)))GOTO 460
  410 SCM=B2/P(1)
      JQ(1)=1
      IQM=1
      RV(1)=-SIGN(1.0,P(1))
      GOTO 460
  420 IF(ABS(P(I)).GT.1.)GOTO 430
      IF(ABS(B2).GE.RMAX*ABS(P(I)))GOTO 460
  430 SCMI=B2/P(I)
      IF(SCMI-SCM)440,450,460
  440 SCM=SCMI
      IF (IQM.EQ.0) GO TO 444
      DO 442 J=1,IQM
      IQ=JQ(J)
  442 RV(IQ)=0.
  444 IQM=1
      RV(I)=-SIGN(1.0,P(I))
      JQ(1)=I
      GOTO 460
  450 IQM=IQM+1
      RV(I)=-SIGN(1.0,P(I))
      JQ(IQM)=I
  460 CONTINUE
      DO 464 I=1,N
      IF(RVT(I).NE.0..OR.RV(I).NE.0.) GOTO 464
      YI=X(I)+SCM*P(I)
      IF((YI.LT.BMI(I).OR.X(I).GE.BMI(I)).AND.(YI.GT.AMA(I).
     1OR.X(I).LE.AMA(I))) GOTO 464
      IQM=IQM+1
      RV(I)=-SIGN(1.,P(I))
      JQ(IQM)=I
  464 CONTINUE
      IF(SCM.NE.0.)GOTO 500
      IF(ISC.NE.1) GOTO 465
      IF(ISGRAD.NE.1) GOTO 335
      FF=OLDFF
      IF(ICOSTA.NE.1) IFAIL=4
      GOTO 940
  465 CONTINUE
      DO 470 J=1,N
  470 Y(J)=X(J)
      DO 490 I=1,IQM
      IQ=JQ(I)
      IF(P(IQ).LT.0.)GOTO 480
      Y(IQ)=B(IQ)
      GOTO 490
  480 Y(IQ)=A(IQ)
  490 CONTINUE
      SC=SCM
      KEY=2
      CALL LINE1(A,B,X,N)
      GOTO (335,360,921,940),KEY
  500 SC=AMIN1(SC,SCM)
      IF(ISC.EQ.1) GOTO 505
  501 IF(ICT.LE.N.OR.ISGRAD.EQ.1) GOTO 505
      SC=AMIN1(1.0,SCM)
  505 KEY=1
      CALL LINE1(A,B,X,N)
      GOTO (335,360,921,940),KEY
  921 IF (KFF.NE.1) SQFNM=SQRT(FNM)
      CALL ENORM(OLDP,N,OPMAX,OPNM)
      SQOPNM=SQRT(OPNM)
      XNOR=SQPNM*OPMAX
      OXNOR1=XNOR
      OXNOR=XNOR
      IF(KFF.NE.1) GOTO 926
      KFF=2
      PM=SQPNM*PMAX
      CALL GRABP1(X,N,A,B)
      IFV=IFV+1
      DO 919 I=1,N
      IF(RVT(I))917,918,917
  917 F(I)=0.
      GOTO 919
  918 F(I)=FVT(I)
  919 CONTINUE
      CALL VMAX(FVT,N,FVTMAX,IFVTMA)
      CALL VMAX(F,N,FMAX,IFM)
      CALL ENORM(F,N,FMAX,FNM)
      CALL ENORM(FVT,N,FVTMAX,FNM2)
      SQFNM=SQRT(FNM)
      IF(FNM.LE.0.)GOTO 920
      IF(ICT.LE.1.OR.SQFNM*FMAX.GT.EPS)GOTO 926
  920 IF(FNM2.LE.0.) GOTO 398
      ICOSTA=0
      IF(SQRT(FNM2)*FVTMAX.GT.EPS) GOTO 922
      ICOSTA=1
      IF(XNOR.LE.XEPS) GOTO 398
  922 IAP=1
  926 IF(ABS(FF-OLDFF).GT.EPS1) GOTO 928
      MSTOP=MSTOP+1
      IF(MSTOP.LT.NSTOP.OR.XNOR.GT.XEPS) GOTO 930
      IF(ICOSTA.NE.1) IFAIL=1
      GOTO 398
  928 MSTOP=0
  930 CONTINUE
      IF(IAP.EQ.1) GOTO 934
      IF(ICT.LT.IMAX) GOTO 932
      IF(ICOSTA.NE.1) IFAIL=2
      GOTO 398
  932 IF(LFUN.LT.LFUNMA) GOTO 934
      IF(ICOSTA.NE.1) IFAIL=3
      GOTO 398
 934  IF (ICON.EQ.1) GO TO 398
      IF (ICT.NE.INEXT) GO TO 990
      SOFPRI=FMAX*SQFNM
      IN=1
      CALL SPAU31(X,N,FF,ICT,IPRINT)
      INEXT=ICT+IPRINT
      GO TO 990
  398 OFMAX=FMAX
      SQOFNM=SQFNM
  940 FM=FF
      IN=2
      ICTMIN=ICT
      SOFPRI=SQOFNM*OFMAX
      IF (IPRINT.GE.0) CALL SPAU31(X,N,FF,ICT,IPRINT)
      RETURN
  990 OFNM=FNM
      OLDFF=FF
      IFMA=IFM
      OFMAX=FMAX
      SQOFNM=SQFNM
      YMAX=ABS(F(1)-OLDF(1))
      DO 1000 I=1,N
      Y(I)=F(I)-OLDF(I)
      AY=ABS(Y(I))
      IF(YMAX.LT.AY)YMAX=AY
 1000 OLDF(I)=F(I)
      IF(IAP.NE.1)GOTO 1020
      DAUG=3.
      IF(XNOR.GT.0.0)GOTO 1020
      IF(SC.EQ.SCM)GOTO 1010
      SC=0.
      SCM=RMAX
      GOTO 180
 1010 IF(ISGRAD.EQ.0)GOTO 1110
      IF(ISGR)140,140,1110
 1020 CONTINUE
      IF(YMAX.EQ.0.)GOTO 1110
      CALL MIVB1(N,M,B1)
      GOTO (100,1110,1021),KEY
 1021 ISGRAD=0
 1110 IF(IQM.EQ.0) GOTO 1170
      DO 1160 K=1,IQM
      IQ=JQ(K)
      IF(X(IQ).NE.A(IQ).AND.X(IQ).NE.B(IQ)) GOTO 1160
      IQQ=(IQ*(IQ+1))/2
      B1IQ=B1(IQQ)
      IQM1=K
      IF(B1IQ.EQ.0.)GOTO 100
      RVT(IQ)=RV(IQ)
      OLDF(IQ)=0.
 1130 IQJ=(IQ*(IQ-1))/2+1
      IIQ1=IQJ
      DO 1146 J=1,N
      IF(J.EQ.IQ) GOTO 1142
      IF(RVT(J).NE.0.) GOTO 1140
      B1IQJ=B1(IQJ)/B1IQ
      IJ1=(J*(J-1))/2
      IIQ=IIQ1
      DO 1138 I=1,J
      IJ=IJ1+I
      IF(I.EQ.IQ) GOTO 1134
      IF(RVT(I).NE.0.) GOTO 1132
      B1(IJ)=B1(IJ)-B1IQJ*B1(IIQ)
 1132 IF(IQ.GT.I)GOTO 1136
 1134 IIQ=IIQ+I
      GOTO 1138
 1136 IIQ=IIQ+1
 1138 CONTINUE
 1140 IF(IQ.GT.J) GOTO 1144
 1142 IQJ=IQJ+J
      GOTO 1146
 1144 IQJ=IQJ+1
 1146 CONTINUE
      DO 1150 I=1,N
      IF(IIQ1.EQ.IQQ) GOTO 1147
      B1(IIQ1)=0.
 1147 IF(IQ.GT.I) GOTO 1148
      IIQ1=IIQ1+I
      GOTO 1150
 1148 IIQ1=IIQ1+1
 1150 CONTINUE
 1160 CONTINUE
      CALL VMAX(OLDF,N,OFMAX,IFMA)
      CALL ENORM(OLDF,N,OFMAX,OFNM)
      SQOFNM=SQRT(OFNM)
      IQM1=1
 1170 SC=0.
      SCM=RMAX
      GOTO 180
      END
      SUBROUTINE LINE1(A,B,X,N)
      DIMENSION A(N),B(N),X(N)
      COMMON/STATIS/IFAIL,ICT,ICTMIN,LFUN
      COMMON/MIVF/F(100)
      COMMON/MIVP/P(100)/MIVOLP/OLDP(100)
      COMMON/MIVRVT/RVT(100)/B3/FVT(100)
      COMMON/MIVUPD/UPD(100)
      COMMON/MIVGRA/PM,IPM,FN2,KFF,FF,OFMAX,OXNOR1
      COMMON/MIV3/INEXT
      COMMON/MIVBMI/BMI(100)/MIVAMA/AMA(100)
      COMMON/GRZ/ZET(100)
      COMMON/MIVLIN/SQPNM,PMAX,IFV,SC,OLDFF,EPSC,ISC,ICON,ISGRAD,
     *SCM,FVTMAX,FMAX,IFM,FNM,FNM2,EPS,XEPS,IAP,SFO,
     *OPNM,PNM,OXNOR
      COMMON/MIVIG/IGRA
      COMMON/MIVKEY/KEY
      COMMON/MIVY/Y(100)
      COMMON/MIVLIB/OPMAX,ETA
      COMMON/LIN1/SCIN,IXT,PF,ICOSTA
      AN=FLOAT(N)
      RMIN=R1MACH(1)
      RLRS=R1MACH(4)*AN*AN
      RMAX=R1MACH(2)
      SRMAX=SQRT(RMAX)/10.
      SRMIN=SQRT(RMIN)*10
      KAP=0
      SCMIN=SC
      FFREC=OLDFF
      IF(ISC.EQ.1) GOTO 880
      SCIN=SC
      IXT=0
      IF(KEY.EQ.2) GOTO 538
      IF(ICT.LE.N.OR.ISGRAD.EQ.1) GOTO 880
      SQOPNM=SQRT(OPNM)
      IF(OPNM.LE.0..OR.PNM.LE.0.)GOTO 880
      CALL PROD(OLDP,P,N,OPMAX,PMAX,PARA)
      PARA=PARA/(SQOPNM*SQPNM)
  520 IF(ABS(PARA)-0.995)880,530,530
  530 IXT=1
      IF(PF.GT.1.5.AND.PF.LE.2.0) GOTO 880
      SC=AMIN1(SCM,0.5)
      IF(PF.LE.1.5) GOTO 535
      SC=AMIN1(PF-1.0,SCM)
      IXT=0
  535 SCMIN=SC
      GOTO 880
  538 XNOR=0
      KAP=1
  540 KFF=1+IGRA
      FF=FI(Y,N)
      LFUN=LFUN+1
      PM=SQPNM*PMAX
      CALL GRABP1(Y,N,A,B)
      IF(KFF.NE.1) IFV=IFV+1
      FN=FN2
      IF(KFF.GT.2) GOTO 544
      IF(FF.GE.FFREC) GOTO 544
      FNREC=FN
      KFFREC=KFF
      SCMIN=SC
      FFREC=FF
  544 CONTINUE
      IF(OLDFF.GE.FF) GOTO 570
      IF(XNOR.LT.EPSC) GOTO 545
      IF(SC.GT.SCIN*0.001) GOTO 570
      IF(FFREC.LT.OLDFF) GOTO 568
      GOTO 566
  545 IF(FFREC.LT.OLDFF) GOTO 568
  546 IF(ISC.NE.1 )GOTO 550
      KEY=4
      IF(ICOSTA.NE.1) IFAIL=4
      FF=OLDFF
      RETURN
  550 ISC=1
      IF(ISGRAD.EQ.1) GOTO 551
      KEY=1
      RETURN
  551 DO 560 I=1,N
  560 P(I)=-P(I)
      KEY=2
      RETURN
  566 GP=0.5*EPSC/(PMAX*SQPNM)
      IF(GP.EQ.0.)GOTO 546
      IXT=1
      SC=GP
      GOTO 880
  568 ISC=2
  570 PF=2.
      ETA=1.0
      IF(OLDFF.EQ.FF.AND.XNOR.EQ.0.) KAP=1
  576 IF(KFF.NE.1) GOTO 580
      FN1=FN
      FN=FN*SQPNM
      FMAX1=1.
      IPRO=0
      IF(ABS(FN1).GT.EPS) GOTO 660
      KFF=2
      FN2=FN1
      PM=SQPNM*PMAX
      CALL GRABP1(Y,N,A,B)
      IFV=IFV+1
  580 CONTINUE
      DO 606 I=1,N
      IF(RVT(I))590,600,590
  590 F(I)=0.
      GOTO 606
  600 F(I)=FVT(I)
  606 CONTINUE
      CALL VMAX(FVT,N,FVTMAX,IFVTMA)
      CALL VMAX(F,N,FMAX,IFM)
      CALL ENORM(F,N,FMAX,FNM)
      CALL ENORM(FVT,N,FVTMAX,FNM2)
      IF(KFF.LE.2) GOTO 608
      CALL PROD1(F,P,N,FMAX,PMAX,FN,IPRO)
      FMAX1=FMAX
  608 SQFNM=SQRT(FNM)
  610 IF(FF.GE.FFREC) GOTO 614
      SCMIN=SC
      FFREC=FF
      KFFREC=KFF
      FVMARE=FVTMAX
      FNM2RE=FNM2
      IFMREC=IFM
      FMAXRE=FMAX
      FNMREC=FNM
      SQFNMR=SQFNM
      DO 612 I=1,N
  612 UPD(I)=FVT(I)
  614 CONTINUE
      IF(FNM.LE.0.)GOTO 620
      IF(SQFNM*FMAX.GT.EPS)GOTO 660
  620 IF(OLDFF.GT.FF-RLRS*ABS(FF)-RMIN.OR.KAP.EQ.1) GOTO 630
      IF(FFREC.LT.OLDFF) GOTO 900
      SC=0.5*SC
      IXT=1
      GOTO 880
  630 SCMIN=SC
      ICOSTA=0
      IF(SQRT(FNM2)*FVTMAX.GT.EPS) GOTO 640
      ICOSTA=1
      IF(XNOR.LE.XEPS.OR.FNM2.LE.0.) ICON=1
      GOTO 900
  640 IAP=1
      GOTO 900
  660 IF(KAP.EQ.1.OR.ISC.EQ.2)GOTO 900
      IF(IPRO.EQ.0) GOTO 680
      IF(PMAX.LE.1.) GOTO 665
      IF(OFMAX.GE.(SRMAX/AN)/PMAX) GOTO 670
  665 SFO1=OFMAX*SFO*PMAX
      IF(SFO1.GE.1.) GOTO 668
      IF(ABS(FN).GT.SRMAX*ABS(SFO1)) GOTO 675
  668 DD=FN/SFO1
      GOTO 700
  670 DD=FN/(SRMAX*SFO)
      GOTO 700
  675 DD=-SRMAX*SIGN(1.0,FN)
      GOTO 700
  680 IF(ABS(OFMAX).GE.1.) GOTO 690
      IF(ABS(FMAX1).LT.SRMAX*ABS(OFMAX)) GOTO 690
      DD=SRMAX*(FN/SFO)
      GOTO 700
  690 DD=(FMAX1/OFMAX)*(FN/SFO)
  700 FO=(SC*PMAX)*(OFMAX*SFO)
      IF(ABS(FO).GT.SRMIN*ABS(OLDFF).AND.ABS(FO).GT.SRMIN*ABS(FF))
     -GOTO 730
      DFF=FF-OLDFF
      IF(ABS(FO).GT.SRMIN*ABS(DFF)) GOTO 720
      IF(ABS(DFF).LT.(SRMIN/100.)) GOTO 710
      D=-SRMIN*SIGN(1.0,DFF)
      GOTO 740
  710 D=-DFF/RMIN
      GOTO 740
  720 D=(FF-OLDFF)/FO
      GOTO 740
  730 D=1.+(FF-FO)/FO-OLDFF/FO
  740 G7=1.0
      P1=2.0
      GO=1.+2.*DD-3.*D
      IF(ABS(GO).LE.0.01)GOTO 750
      G7=(DD-1.)/(2.*GO)
  750 G1=3.*(DD+1.-2.*D)
      G2=2.*(3.*D-DD-2.)
      G3=G2*G2-4.*G1
      IF(ABS(G1).LE.0.003*ABS(G2).OR.G3.LE.0.0)GOTO 760
      G4=(-G2-SQRT(G3))/(2.*G1)
      IF(G4.LE.0.01)GOTO 760
      IF(G7.LT.0.1.OR.G7.GT.10.0) GOTO 760
      GP=G4*SC
      IF(ABS(DD).LT.0.01) GOTO 755
      PF=1.0+2.*(1.-G4)*GO/DD
  755 P1=1.0-0.5*G4*G2
      PF=AMIN1(3.0,PF)
      PF=AMAX1(2.0,PF)
      ETA=G7
      GOTO 780
  760 GP=2.5*SC
      IF(IXT.NE.1) GP=10.*SC
      ETA=1.0
      IF(DD.GT.0.99) GOTO 770
      GP=SC/(1.0-DD)
  770 IF(D.GT.0.99) GOTO 840
      GP=0.5*SC/(1.0-D)
  780 IF(D.GT.0.99.OR.DD.GT.0.99) GOTO 840
      IF(D*(1.+DD).LT.0.0.OR.DD.GT.D) GOTO 840
      IF(ABS(DD).LT.0.05)GOTO 840
      Z=2.0
      IKT=0
      Q=SC/(AMIN1(5*SC,AMAX1(GP,0.05*SC)))
      IF(Q.EQ.1.) Q=1.01
      F1=(1.0-DD)/(Z*Q)+DD/Z-D
      F2=((ABS(1.-Q))**Z)/(1.-Q)-DD
      R=ABS(F1)+ABS(F2)
  790 Z1=-((1.-DD)/(Z*Z*Q)+DD/(Z*Z))
      IF(Q.GE.SRMAX)GOTO 840
      Z2=-(1.-DD)/(Z*Q*Q)
      Z3=(ABS(1.-Q))**Z*ALOG(ABS(1.-Q))/(1.-Q)
      Z4=-(Z-1.)*(ABS(1.-Q))**(Z-2.)
      DET=Z1*Z4-Z2*Z3
      IF(ABS(DET).LE.SRMIN)GOTO 840
      DZ=(Z2*F2-Z4*F1)/DET
      DQ=(Z3*F1-Z1*F2)/DET
      T=1.0
      IF(IKT.GT.50) GOTO 840
      IKT=IKT+1
  800 ZN=Z+T*DZ
      QN=Q+T*DQ
      IF(QN.EQ.1.) GOTO 810
      IF(ZN.GE.5..OR.ZN.LE.1.1.OR.QN.LE.EPS) GOTO 810
      IF(ALOG10(ABS(1.-QN))*ZN.LT.14.)GOTO 820
  810 T=0.5*T
      IF(T.LE.SQRT(SRMIN))GOTO 840
      GOTO 800
  820 F1=(1.-DD)/(ZN*QN)+DD/ZN-D
      F2=((ABS(1.-QN))**ZN)/(1.-QN)-DD
      RN=ABS(F1)+ABS(F2)
      IF(RN.LE.SQRT(SRMIN))GOTO 830
      IF(RN.GE.R)GOTO 810
      R=RN
      Z=ZN
      Q=QN
      GOTO 790
  830 IF(DD*(Q-1.).GT.0.)GOTO 840
      G5=SC/QN
      G6=(1.-DD)*(G5-SC)/(DD*SC*(ZN-1.))
      IF(G6.LT.0.1.OR.G6.GT.10.)GOTO 840
      P1=ZN
      PF=ZN
      GP=G5
      ETA=G6
  840 IF(D.LT.0.01)GOTO 860
      IF(DD.GE.1.0)GOTO 850
      IF(GP/SC.GE.2..AND.(D.GT.0.99.OR.P1.GT.3.0))GOTO 850
      GOTO 900
 850  IF(IXT.EQ.1)GOTO 900
 860  IF(GP.GT.SC)GOTO 870
      IF(FF.LE.OLDFF.AND.IXT.EQ.1) GOTO 900
      IXT=1
 870  SCC=SC
      SCMA=5.
      IF(IXT.NE.1)SCMA=10.
      GP=AMIN1(GP,SCMA*SC)
      SC=AMAX1(GP,0.05*SC)
      IF(SC.GT.SCM)SC=SCM
      IF(SC.NE.SCC) GOTO 880
      IF(OLDFF.GE.FF) GOTO 900
      SC=0.5*SC
 880  ZMAX=0.
      DO 890 I=1,N
      XI=X(I)
      YI=XI+SC*P(I)
      IF(YI.GE.BMI(I)) YI=B(I)
      IF(YI.LE.AMA(I)) YI=A(I)
      Y(I)=YI
      ZET(I)=XI-YI
  890 ZMAX=AMAX1(ZMAX,ABS(ZET(I)))
      CALL ENORM(ZET,N,ZMAX,XNOR)
      XNOR=SQRT(XNOR)*ZMAX
      OXNOR1=AMAX1(OXNOR,XNOR)
      GOTO 540
  900 OPMAX=0.
      IF(FFREC.EQ.OLDFF.OR.SC.EQ.SCMIN) GOTO 912
      KFF=KFFREC
      SC=SCMIN
      FF=FFREC
      IF(KFF.EQ.1) GOTO 901
      FNM=FNMREC
      IFM=IFMREC
      FMAX=FMAXRE
      FVTMAX=FVMARE
      SQFNM=SQFNMR
  901 FN1=FNREC
      DO 910 I=1,N
      IF(KFF.EQ.1) GOTO 906
      UPDI=UPD(I)
      IF(RVT(I).EQ.0.) GOTO 902
      F(I)=0.
      GOTO 904
  902 F(I)=UPDI
  904 FVT(I)=UPDI
  906 OLDP(I)=SC*P(I)
      IF(RVT(I).NE.0.)GOTO 910
      XI=X(I)
      YI=XI+OLDP(I)
      IF(YI.LT.BMI(I)) GOTO 907
      YI=B(I)
      OLDP(I)=YI-XI
  907 IF(YI.GT.AMA(I)) GOTO 908
      YI=A(I)
      OLDP(I)=YI-XI
  908 X(I)=YI
      OPMAX=AMAX1(OPMAX,ABS(OLDP(I)))
  910 CONTINUE
      GOTO 916
  912 CONTINUE
      DO 915 I=1,N
      OLDP(I)=SC*P(I)
      IF(RVT(I).NE.0.) GOTO 915
      YI=Y(I)
      IF(YI.NE.A(I).AND.YI.NE.B(I)) GOTO 914
      OLDP(I)=YI-X(I)
  914 OPMAX=AMAX1(OPMAX,ABS(OLDP(I)))
      X(I)=YI
  915 CONTINUE
  916 KEY=3
      FN2=FN1
      RETURN
      END
      SUBROUTINE MIVB1(N,NM,B1)
      DOUBLE PRECISION SG,UPDI,GHG,ZZ,PI,PJ,ZER
      DIMENSION B1(NM)
      COMMON/MIVUPD/UPD(100)
      COMMON/MIVOLP/OLDP(100)
      COMMON/MIVRVT/RVT(100)
      COMMON/MIVY/Y(100)/MIVKEY/KEY/MIVYM/YMAX
      COMMON/MIVLIB/OPMAX,ETA
      AN=FLOAT(N)
      ZER=0.D0
      RMAX=R1MACH(2)
      DO 1030 I=1,N
 1030 Y(I)=Y(I)/YMAX
 1040 SG=ZER
      GHG=ZER
      DO 1060 I=1,N
      UPDI=ZER
      YI=Y(I)
      IF(RVT(I).NE.0.)GOTO 1060
      IJ=(I*(I-1))/2+1
      DO 1050 J=1,N
      IF(RVT(J).NE.0.) GOTO 1042
      UPDI=UPDI+B1(IJ)*Y(J)
 1042 IF(I.GT.J) GOTO 1044
      IJ=IJ+J
      GOTO 1050
 1044 IJ=IJ+1
 1050 CONTINUE
      SG=SG+OLDP(I)*YI
      GHG=GHG+UPDI*YI
 1060 UPD(I)=SNGL(UPDI)
      IF(GHG.GT.ZER) GOTO 1061
      KEY=1
      RETURN
 1061 IF(SG.GT.ZER) GOTO 1062
      KEY=2
      RETURN
 1062 IF(SG.GT.1.D0) GOTO 1070
      IF(DBLE(OPMAX).LE.SG*RMAX/(AN*AN)) GOTO 1070
      KEY=2
      RETURN
 1070 IF(YMAX.GE.1.) GOTO 1080
      IF(DBLE(YMAX*RMAX).GE.SG) GOTO 1080
      KEY=2
      RETURN
 1080 ZZ=ETA*(SG/YMAX)+GHG
      DO 1095 I=1,N
      IF(RVT(I).NE.0.) GOTO 1095
      UPDI=UPD(I)
      PI=OLDP(I)/SG
      IJ1=(I*(I-1))/2
      DO 1090 J=1,I
      IF(RVT(J).NE.0.) GOTO 1090
      IJ=IJ1+J
      PJ=OLDP(J)/SG
      B1(IJ)=SNGL(B1(IJ)-UPDI*PJ-UPD(J)*PI+ZZ*PI*PJ)
 1090 CONTINUE
 1095 CONTINUE
      KEY=3
      RETURN
      END
      SUBROUTINE SPAU31(X,N,FF,IM,IPRINT)
      DIMENSION X(N)
      COMMON /INW/IN/STATIS/IFAIL,ICT,ICTM,L
      COMMON/MIVPRI/SOFPRI
      NOUT=I1MACH(2)
      IF (IN.EQ.2) GO TO 10
      WRITE(NOUT,100)
      IF (IM.EQ.IPRINT) WRITE (NOUT,210)
      WRITE (NOUT,110) IM
      WRITE(NOUT,120) FF
      WRITE(NOUT,220) SOFPRI
      WRITE(NOUT,140)
      WRITE(NOUT,130) (X(I),I=1,N)
      RETURN
   10 WRITE(NOUT,170)
      WRITE(NOUT,180)
      WRITE (NOUT,150) FF
      WRITE(NOUT,220) SOFPRI
      WRITE(NOUT,160)
      WRITE(NOUT,130) (X(I),I=1,N)
      WRITE(NOUT,190) L
      WRITE (NOUT,390) IM
      IF (IFAIL.EQ.0) WRITE (NOUT,400)
      IF (IFAIL.EQ.4) WRITE (NOUT,410)
      IF (IFAIL.EQ.3) WRITE (NOUT,420)
      IF (IFAIL.EQ.2) WRITE (NOUT,430)
      IF (IFAIL.EQ.1) WRITE (NOUT,440)
      WRITE (NOUT,200)
      WRITE(NOUT,170)
      RETURN
  100 FORMAT (/1X,34(2H -))
  110 FORMAT(2X,23HI T E R A T I O N  NR =,I6)
  120 FORMAT (/2X,19HFUNCTION VALUE F = ,E15.8)
  130 FORMAT(4(2X,E15.8))
  140 FORMAT (2X,13HCURRENT POINT)
  150 FORMAT (/2X,28HOPTIMAL FUNCTION VALUE FM = ,E15.8)
  160 FORMAT(2X,13HOPTIMAL POINT)
  170 FORMAT (/1X,34(2H *)/1X,34(2H *))
  180 FORMAT (/2X,13HR E S U L T S)
  190 FORMAT (/2X,34HNUMBER OF FUNCTION EVALUATIONS L =,I6)
  200 FORMAT (/7X,17HMIVAR4 TERMINATED)
  210 FORMAT (1X,34(2H -))
  220 FORMAT (2X,30HNORM OF CONSTRAINED GRADIENT =,E15.8)
  370 FORMAT (/7X,17HMIVAR4 TERMINATED)
  390 FORMAT (2X,25HNUMBER OF ITERATIONS NR =,I6)
  400 FORMAT (/2X,61HIFAIL = 0. TERMINATION CRITERION: GRADIENT NORM LES
     CS THAN EPS)
  410 FORMAT (/2X,65HIFAIL = 4. TERMINATION CRITERION: IMPOSSIBLE TO DEC
     1REASE FUNCTION)
  420 FORMAT (/2X,64HIFAIL = 3. TERMINATION CRITERION: NUMBER OF FUNCTIO
     1N EVALUATIONS/2X,14HGREATER THAN M)
  430 FORMAT (/2X,54HIFAIL = 2. TERMINATION CRITERION: NUMBER OF ITERATI
     CONS/2X,14HEXCEEDED LIMIT)
  440 FORMAT (/2X,53HIFAIL = 1. TERMINATION CRITERION: CHANGE OF FUNCTIO
     1N,/2X,35HLESS THAN EPS1, OCCURED NSTOP TIMES)
      END
      SUBROUTINE GRABP1(X,NN,A,B)
      DIMENSION X(NN),A(NN),B(NN)
      COMMON /MIVDEL/DEL,DL/GRZ/Z(100)/STATIS/IFAIL,ICT,ICTM,LFUN
     C/MIV3/IEXT
      COMMON /MIVGRA/PM,IP,FN,KFF,FF,FMAX,XNOR
      COMMON /MIVNFN/IFN
      COMMON /B3/F(100)/MIVP/P(100)/MIVDE/DELT(101)
      N=NN
      iprad=1
      icom=1
      RBASE=FLOAT(I1MACH(10))
      RDIG=FLOAT(I1MACH(11))
      TOL1=RBASE**(-RDIG*0.15)
      TOL2=RBASE**(-RDIG*0.2)
      TOL3=RBASE**((-RDIG)*0.5)
      TOL4=RBASE**((-RDIG)*0.75)
      RLRS=R1MACH(4)
      SRL1=SQRT(RLRS)
      SRL=SQRT(SRL1)
       IF(ICT.NE.0)GOTO 30
      FMAX=0.
      DL=B(1)-A(1)
      IF (DEL.LE.0.) DEL=RLRS
      DELT(1)=DEL
      DELT(N+1)=DEL
      DO 20 I=2,N
      DELT(I)=DEL
   20 DL=AMIN1(DL,B(I)-A(I))
      DL=DL*0.05
   30 FMA=ABS(FMAX)
      IF (DEL.LE.0) DEL=RLRS
      DO 40 I=1,N
   40 Z(I)=X(I)
      IPP=IP
      IF(KFF.EQ.2) GOTO 200
      IF(KFF.EQ.0) GOTO 190
      DEL=AMIN1(DELT(N+1),DL)
      IF(DEL.LE.XNOR) GOTO 50
      DEL=AMAX1(XNOR,0.1*DEL)
   50 DEL=AMAX1(DEL,RLRS)
      DI=DEL
      S1=1.
   90 SK=1.
      IK=0
  100 CONTINUE
      DO 120 I=1,N
      IF(P(I).EQ.0.) GOTO 120
  102 Z(I)=X(I)+SK*DI*S1*(P(I)/PM)
      IF(IP.NE.I) GO TO 104
      IF(Z(I).NE.X(I)) GOTO 104
      DI=DI*10.
      GO TO 100
  104 IF(Z(I).LE.B(I).AND.Z(I).GE.A(I)) GOTO 120
      IF(IK.NE.0) GOTO 410
      IF(S1.EQ.-1.) GOTO 110
      S1=-1.
      GOTO 100
  110 KFF=3
      DO 112 J=1,I
  112 Z(J)=X(J)
      GOTO 190
  120 CONTINUE
      I=0
      IF(IK.NE.0) GOTO 400
      IK=1
      GOTO 300
  190  IPP=N+1
  200 PN=0.
  202 continue
      DO 260 I=iprad,N
      goto (204,210,220,250),icom
  204 IF(IPP.EQ.I) GOTO 260
      XI=X(I)
      AI=A(I)
      BI=B(I)
      DEL=AMIN1(DELT(I),DL)
       IF(DEL.LE.XNOR)GOTO 206
      DEL=AMAX1(XNOR,0.1*DEL)
  206 DEL=AMAX1(DEL,RLRS)
      DI=DEL
      S1=1.
  210 Z(I)=XI+DI*S1
      IF(Z(I).NE.XI) GOTO 214
      DI=DI*10.
      GOTO 210
  214 SK=1.
      IF(Z(I).LE.BI)GOTO 300
      S1=-1.
      GOTO 210
  220 Z(I)=XI-SK*DI
      IF(Z(I).LT.AI)GOTO 410
      GOTO 400
  250 IF(KFF.NE.2) GOTO 256
      PN=PN+(P(I)/PM)*FNI
  256 F(I)=FNI
      Z(I)=XI
      DELT(I)=DI
      icom=1
  260 CONTINUE
      IF(KFF.EQ.0) KFF=1
      IF(KFF.NE.2) RETURN
      F(IP)=(FN-PN)/(P(IP)/PM)
      DELT(IP)=DELT(N+1)
      RETURN
  300 FF1=FI(Z,N)
      KK2=1
  310 LFUN=LFUN+1
      DIF=ABS(FF1-FF)
      AF=ABS(FF)
      IF(DIF.GT.TOL2*AF)SK=0.5
      IF(DI.NE.DEL)GOTO 320
      IF(DIF.LE.TOL1*AF)GOTO 320
      IF(DEL.EQ.RLRS) GOTO 330
      DI=0.25*DEL
      IF(KFF.EQ.1) GOTO 90
      iprad=i
      icom=2
      GOTO 202
  320 IF(DIF.GT.TOL3*AF) GOTO 330
      SK=2.
      IF(DI.NE.DEL.OR.(S1.EQ.-1..AND.I.EQ.0)) GOTO 330
      IF(DIF.GT.TOL4*AF)GOTO 330
      IF(DEL.GE.XNOR) GOTO 326
      DI=4.*DEL
      IF(KFF.EQ.1) GOTO 90
      iprad=i
      icom=2
      GOTO 202
  326 SK=4.
      IF(DIF.EQ.0.)SK=10.
  330 IF(XNOR.LT.AMAX1(SRL,DI*100.).OR.DEL.EQ.RLRS.OR.FMA.LT.SRL)GOTO332
      GOTO 410
  332 IF(S1.EQ.-1.) GOTO 410
      IF(KFF.eq.1) GOTO 340
      iprad=i
      icom=3
      goto 202
  340 S1=-1.
      GOTO 100
  400 DEN=(SK**2+SK)*DI
      DI=DI*SK
      FF2=FI(Z,N)
      KK2=2
  405 LFUN=LFUN+1
      FNI=(SK**2*(FF1-FF)-FF2+FF)/DEN
      GOTO 420
  410 FNI=(FF1-FF)/(DI*S1)
      DI=DI*SK
  420 IF(KFF.eq.1) GOTO 430
      iprad=i
      icom=4
      goto 202
  430 FN=FNI
      IFN=IFN+1
      DELT(N+1)=DI
      RETURN
      END
      SUBROUTINE VMAX(V,N,VM,IM)
C
      DIMENSION V(N)
C   *******************************************
C   SEARCH OF MAXIMAL ABSOLUTE VALUE OF ELEMENT
C
C   VM = MAX ABS(V(N)) - /OUTPUT/
C   IM = ARG (VM)      - /OUTPUT/
C   *******************************************
      NN=N
      VMM=ABS(V(1))
      IMM=1
      DO 10 I=2,NN
      VV=ABS(V(I))
      IF(VMM.GE.VV) GOTO 10
      VMM=VV
      IMM=I
   10 CONTINUE
      VM=VMM
      IM=IMM
      RETURN
      END
      SUBROUTINE ENORM(V,N,VM,EN)
C
      DIMENSION V(N)
C   *******************************
C   EUKLIDIAN NORM OF (V/VM)
C
C   VM = MAX ABS(V(N))	-  /INPUT /
C   EN = NORM(V/VM)**2	-  /OUTPUT/
C   *******************************
      EN=0.
      IF(VM.EQ.0.) RETURN
      ENN=0.
      VMM=VM
      NN=N
      DO 10 I=1,NN
      VI=V(I)/VMM
   10 ENN=ENN+VI*VI
      EN=ENN
      RETURN
      END
      SUBROUTINE PROD(V,Z,N,VMAX,ZMAX,PRO)
C
      DIMENSION V(N),Z(N)
C   ***********************************
C   SCALAR PRODUCT
C
C   VMAX = MAX ABS(V(I))     - /INPUT /
C   ZMAX = MAX ABS(Z(I))     - /INPUT /
C   PRO  = (V/VMAX)*(Z/ZMAX) - /OUTPUT/
C   ***********************************
      PRO=0.
      IF(VMAX.EQ.0.0.OR.ZMAX.EQ.0.0) RETURN
      NN=N
      PRO1=0.
      VMAX1=VMAX
      ZMAX1=ZMAX
      DO 10 I=1,NN
   10 PRO1=PRO1+(V(I)/VMAX1)*(Z(I)/ZMAX1)
      PRO=PRO1
      RETURN
      END
      SUBROUTINE PROD1(V,Z,N,VMAX,ZMAX,PRO,IPRO)
C
      DIMENSION V(N),Z(N)
C   **********************************************
C   SCALAR PRODUCT
C
C   VMAX = MAX ABS(V(I))		- /INPUT /
C   ZMAX = MAX ABS(Z(I))		- /INPUT /
C   PRO  = (V/VMAX)*(Z/ZMAX), IF IPRO=0 - /OUTPUT/
C   PRO  = V*Z		    , IF IPRO=1 - /OUTPUT/
C   IPRO - INDICATOR OF  P R O	EXPRES. - /OUTPUT/
C   **********************************************
      PRO=0.
      IPRO=0
      IF(VMAX.EQ.0.0.OR.ZMAX.EQ.0.0) RETURN
      NN=N
      AN=FLOAT(NN)
      PRO1=0.
      VMAX1=VMAX
      ZMAX1=ZMAX
      RMAX=R1MACH(2)/AN
      RMIN=R1MACH(1)
      IV=0
      IVV=0
      IF(VMAX1.GT.1.) GOTO 10
      VZ=VMAX1*ZMAX1
      IF(VZ.LE.1.) GOTO 20
      IF(VZ.LT.RMAX) GOTO 55
      GOTO 30
   10 RV=RMAX/VMAX1
      VV=1./VMAX1
      IF(ZMAX1.LE.VV) GOTO 20
      IF(ZMAX1.LT.RV) GOTO 55
      GOTO 30
   20 IV=1
   30 PROMAX=0.
      DO 40 I=1,NN
      PROI=(V(I)/VMAX1)*(Z(I)/ZMAX1)
      PRO1=PRO1+PROI
      APROI=ABS(PROI)
   40 PROMAX=AMAX1(PROMAX,APROI)
      PRO=PRO1
      IF(IV.EQ.1.OR.ABS(PRO1).GE.100.*AN*RMIN) RETURN
      IF(ZMAX1.LT.1.) GOTO 45
      IF(VMAX1*PROMAX.GT.RMAX/ZMAX1) RETURN
      GOTO 50
   45 IF(ZMAX1*PROMAX.GT.RMAX/VMAX1) RETURN
   50 IVV=1
   55 IPRO=1
      PRO1=0.
      DO 60 I=1,NN
   60 PRO1=PRO1+V(I)*Z(I)
      PRO=PRO1
      IF(PRO1.NE.0.) GOTO 70
      IPRO=0
      RETURN
   70 IF(IVV.NE.1) GOTO 80
      IF(ABS(PRO1).LE.1.) RETURN
      PRO1=(PRO1/ZMAX1)/VMAX1
      GOTO 90
   80 PRO1=PRO1/(ZMAX1*VMAX1)
   90 IF(ABS(PRO1).LE.0.) RETURN
      PRO=PRO1
      IPRO=0
      RETURN
      END
      SUBROUTINE INWR31(X,A,B,N,NH,FM,IPAR,PAR,IPA,IPAA)
      DIMENSION X(N),A(N),B(N)
      DIMENSION IPAR(30),PAR(30)
      COMMON/INW/INW1/STATIS/IFAIL,ICT,ICTM,NFUN
      NNH=N*(N+1)/2
      MN=100
      MIP=30
      K=4
      K1=4
      NOUT=I1MACH(2)
      IF (INW1.EQ.2) GO TO 300
      IF (IPA.GE.0.AND.IPA+K.LE.MIP) GO TO 10
      WRITE (NOUT,520) K,MIP
      WRITE (NOUT,510) IPA
    5 IFAIL=10
      RETURN
   10 CONTINUE
      IPRINT=IPAR(IPA+1)
      IF (IPRINT.LT.0) GO TO 110
      WRITE (NOUT,770)
      WRITE (NOUT,620)
      WRITE (NOUT,630) N
  110 IF (N.GT.0.AND.N.LE.MN ) GO TO 20
      WRITE (NOUT,500) MN
      IF (IPRINT.LT.0) WRITE (NOUT,630) N
      GO TO 5
   20 CONTINUE
      M=IPAR(IPA+2)
      NSTOP=IPAR(IPA+3)
      IMAX=IPAR(IPA+4)
      IF (IPRINT.LT.0) GO TO 40
      WRITE (NOUT,640) IPRINT
      WRITE (NOUT,650) M
      WRITE (NOUT,780) NSTOP
      WRITE (NOUT,790) IMAX
   40 IF (M.GT.0) GO TO 43
      WRITE (NOUT,525)
      IF (IPRINT.LT.0) WRITE (NOUT,650) M
      GO TO 5
   43 IF (NH.GE.NNH) GO TO 45
      WRITE (NOUT,730)
      IF (IPRINT.GE.0) GO TO 47
      WRITE (NOUT,630) N
   47 WRITE (NOUT,635) NH
      GO TO 5
   45 IF (NSTOP.GT.0) GO TO 50
      WRITE (NOUT,530)
      IF (IPRINT.LT.0) WRITE (NOUT,780) NSTOP
      GO TO 5
   50 IF (IMAX.GT.0) GO TO 120
      WRITE (NOUT,800)
      IF (IPRINT.LT.0) WRITE (NOUT,790) IMAX
      GO TO 5
  120 CONTINUE
      IF (IPAA.GE.0.AND.IPAA+K1.LE.MIP) GO TO 240
      WRITE (NOUT,710) K1,MIP
      WRITE (NOUT,700) IPAA
      GO TO 5
  240 IF (IPRINT.LT.0) GO TO 250
      J=IPAA+1
      J1=IPAA+4
      WRITE (NOUT,720) (PAR(I),I=J,J1)
  250 CONTINUE
      IF (IPRINT.LT.0) GO TO 200
      WRITE (NOUT,570)
      WRITE (NOUT,580) (A(I),I=1,N)
      WRITE (NOUT,590)
      WRITE (NOUT,580) (B(I),I=1,N)
  200 NER=0
      DO 90 I=1,N
      IF (A(I).LT.B(I)) GO TO 90
      IF (NER.NE.0) GO TO 86
      WRITE (NOUT,600) I,I
      GO TO 87
   86 WRITE (NOUT,605) I,I
   87 CONTINUE
      NER=1
   90 CONTINUE
      IF (NER.EQ.0) GO TO 150
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,570)
      WRITE (NOUT,580) A
      WRITE (NOUT,590)
      WRITE (NOUT,580) B
      GO TO 5
  150 CONTINUE
      IF (IPRINT.LT.0) GO TO 260
      WRITE (NOUT,820)
      WRITE (NOUT,580) (X(I),I=1,N)
  260 NER=0
      DO 270 I=1,N
      IF (X(I).LE.B(I).AND.X(I).GE.A(I)) GO TO 270
      WRITE (NOUT,830) I,I,I,I
      NER=1
  270 CONTINUE
      IF (NER.EQ.0) GO TO 160
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,570)
      WRITE (NOUT,580) A
      WRITE (NOUT,590)
      WRITE (NOUT,580) B
      WRITE (NOUT,820)
      WRITE (NOUT,580) X
      GO TO 5
  160 CONTINUE
      FM=FI(X,N)
      IF (IPRINT.GE.0) WRITE (NOUT,850) FM
      RETURN
  300 WRITE (NOUT,760)
      IF (IPAR(IPA+1).GE.0) GO TO 5
      WRITE (NOUT,820)
      WRITE (NOUT,580) X
      GO TO 5
  500 FORMAT (/2X,61H**E R R O R  I N  M I V A R 4** N LESS THAN 1 OR GR
     CEATER THAN,I4)
  510 FORMAT (/2X,20HNUMBER OF PARAMETERS,11X,5HIPA =,I6)
  520 FORMAT (/2X,47H**E R R O R  I N  M I V A R 4** IPA LESS THAN 0/2X,
     C7HOR IPA+,I2,13H GREATER THAN,I3)
  525 FORMAT (/2X,45H**E R R O R  I N  M I V A R 4** M LESS THAN 1/)
  530 FORMAT (/2X,49H**E R R O R  I N  M I V A R 4** NSTOP LESS THAN 1/)
  570 FORMAT ( /2X,32HVECTOR OF LOWER BOUNDS (A) FOR X)
  580 FORMAT (4(2X,E15.8))
  590 FORMAT (2X,32HVECTOR OF UPPER BOUNDS (B) FOR X)
  600 FORMAT (/2X,34H**E R R O R  I N  M I V A R 4** A(,I2,22H) GREATER
     COR EQUALS B(,I2,1H))
  605 FORMAT (34X,2HA(,I2,22H) GREATER OR EQUALS B(,I2,1H))
  620 FORMAT (/2X,22HI N I T I A L  D A T A)
  630 FORMAT (/2X,19HNUMBER OF VARIABLES,28X,3HN =,I6)
  635 FORMAT (2X,26HDIMENSION OF WORKING ARRAY,20X,4HNH =,I6)
  640 FORMAT (/2X,18HPRINTING PARAMETER,27X,5HIPR =,I6)
  650 FORMAT (2X,38HMAXIMUM NUMBER OF FUNCTION EVALUATIONS,9X,3HM =,I6)
  700 FORMAT (/2X,27HNUMBER OF PARAMETERS IPAA =,I3)
  710 FORMAT (/2X,48H**E R R O R  I N  M I V A R 4** IPAA LESS THAN 0/
     C2X,8HOR IPAA+,I2,13H GREATER THAN,I3)
  720 FORMAT (/2X,20HSMALL STEP TOLERANCE,6X,6HXEPS =,E15.8/2X,
     123HGRADIENT NORM TOLERANCE,4X,5HEPS =,E15.8/2X,
     232HFUNCTION CHANGE TOLERANCE EPS1 =,E15.8/2X,
     320HDIFFERENTIATION STEP,6X,6HDELT =,E15.8)
  730 FORMAT (/2X,54H**E R R O R  I N  M I V A R 4** NH LESS THAN N*(N+1
     C)/2)
  760 FORMAT (/2X,60H**E R R O R  I N  M I V A R 4** STARTING POINT IS S
     CTATIONARY)
  770 FORMAT (////12X,11HM I V A R 4)
  780 FORMAT (2X,50HNUMBER OF SMALL FUNCTION CHANGE RECURRENCE NSTOP =,
     CI6)
  790 FORMAT (2X,28HMAXIMUM NUMBER OF ITERATIONS,16X,6HIMAX =,I6)
  800 FORMAT (/2X,48H**E R R O R  I N  M I V A R 4** IMAX LESS THAN 1/)
  820 FORMAT (/2X,14HSTARTING POINT)
  830 FORMAT (/2X,34H**E R R O R  I N  M I V A R 4** X(,I2,17H) GREATER
     CTHAN B(,I2,1H)/2X,5HOR X(,I2,14H) LESS THAN A(,I2,1H))
  850 FORMAT (2X,19HFUNCTION VALUE F = ,E15.8)
      END
